<?php

	use \Automattic\WooCommerce\Admin\API\Reports\Cache as ReportsCache;
	use Automattic\WooCommerce\Admin\API\Reports\Coupons\DataStore as CouponsDataStore;
	use Automattic\WooCommerce\Admin\API\Reports\Orders\Stats\DataStore as OrdersStatsDataStore;
	use Automattic\WooCommerce\Admin\API\Reports\Products\DataStore as ProductsDataStore;
	use Automattic\WooCommerce\Admin\API\Reports\Taxes\DataStore as TaxesDataStore;
	
	add_action('wc_os_after_group_category_headings', 'wc_os_after_group_category_headings_callback');
	
	function wc_os_after_group_category_headings_callback(){
			global $wc_os_settings;
			
			$wc_os_settings['wc_os_cats'] = (isset($wc_os_settings['wc_os_cats']) && is_array($wc_os_settings['wc_os_cats'])?$wc_os_settings['wc_os_cats']:array());
			$wc_os_settings['wc_os_cats']['group_cats'] = (isset($wc_os_settings['wc_os_cats']['group_cats']) && is_array($wc_os_settings['wc_os_cats']['group_cats'])?$wc_os_settings['wc_os_cats']['group_cats']:array());
		
			$selected_group = array_keys($wc_os_settings['wc_os_cats']['group_cats']);
		
			global $wpdb;
	
				$results_query = "SELECT p.ID,pm.meta_key FROM `" . $wpdb->posts . "` p LEFT JOIN `" . $wpdb->postmeta . "` pm ON p.ID=pm.post_id WHERE p.post_type = 'shop_order' AND pm.meta_key!='NULL' GROUP BY pm.meta_key ";				
				$orders_unique_meta_keys = $wpdb->get_results($results_query);
				
				$shipping_items = "SELECT p.order_item_id,p.order_item_name FROM `".$wpdb->prefix."woocommerce_order_items` p WHERE p.order_item_type = 'shipping' GROUP BY p.order_item_name ORDER BY p.order_item_name ASC";
				$shipping_items_unique_keys = $wpdb->get_results($shipping_items);
				
				
				$line_items = "SELECT p.order_item_id,pm.meta_key FROM `".$wpdb->prefix."woocommerce_order_items` p LEFT JOIN `".$wpdb->prefix."woocommerce_order_itemmeta` pm ON p.order_item_id=pm.order_item_id WHERE p.order_item_type = 'line_item' AND pm.meta_key!='NULL' GROUP BY pm.meta_key ";
				$line_items_unique_meta_keys = $wpdb->get_results($line_items);
				
				
				$shipping_items = "SELECT p.order_item_id,pm.meta_key FROM `".$wpdb->prefix."woocommerce_order_items` p LEFT JOIN `".$wpdb->prefix."woocommerce_order_itemmeta` pm ON p.order_item_id=pm.order_item_id WHERE p.order_item_type = 'shipping' AND pm.meta_key!='NULL' GROUP pm.BY meta_key ";
				$shipping_items_unique_meta_keys = array();//$wpdb->get_results($shipping_items);
				//wc_os_pree($orders_unique_meta_keys);
		
		?>
        	<a class="wc_os_group_cat_meta_switch button button-secondary"><?php _e('Click here to manage order meta keys for each category group after split', 'woo-order-splitter'); ?></a>
			<div class="wc_os_group_cat_meta_wrapper">
            	<p><?php _e('You may select order meta keys to be cloned into child orders after split action. Select a group and allow/disallow meta keys from the following. Leave blank for all allowed.', 'woo-order-splitter'); ?></p>
				<table style="width: 100%" align="left">
					<tr>
					<td valign="top">
						<strong><?php _e('Category Groups', 'woo-order-splitter'); ?> (<?php _e('Active', 'woo-order-splitter'); ?>):</strong><br /><br />


						<select class="wc_os_selected_group">
							<?php foreach($selected_group as $v): 
								
								if($v === 0){ continue;}
								$k = strtoupper($v);
								
							?>
							<option  value="<?php echo $v; ?>"><?php echo $k; ?></option>
							<?php endforeach; ?>
						</select>
	
					</td>
					
					<td valign="top" align="left">
						<strong><?php _e('Available Order Meta Keys', 'woo-order-splitter'); ?> (<?php _e('Hold ctrl for multiple select', 'woo-order-splitter'); ?>):</strong><br /><br />


					<select multiple="multiple" size="7" class="wc_os_selected_meta">
						<option value="none"><?php _e('None', 'woo-order-splitter'); ?></option>
                        

						
                        
                        <?php if (!empty($line_items_unique_meta_keys)) : asort($line_items_unique_meta_keys);  //pree($wpqs_meta_key_columns); 
						?>
                        <optgroup label="<?php _e('Line Item Meta', 'woo-order-splitter'); ?>">
							<?php foreach ($line_items_unique_meta_keys as $meta_key) : ?>
								<option value="line_item_meta|<?php echo $meta_key->meta_key; ?>" ><?php echo $meta_key->meta_key; ?></option>
							<?php endforeach; ?>
                        </optgroup>    
						<?php endif; ?>
                        
                        
                        
                        <?php if (!empty($shipping_items_unique_keys)) : asort($shipping_items_unique_keys);  //pree($wpqs_meta_key_columns); 
						?>
                        <optgroup label="<?php _e('Shipping Items', 'woo-order-splitter'); ?>">
							<?php foreach ($shipping_items_unique_keys as $order_item) : ?>
								<option value="shipping|<?php echo $order_item->order_item_name; ?>" ><?php echo $order_item->order_item_name; ?></option>
							<?php endforeach; ?>
                        </optgroup>
						<?php endif; ?>
                                                
                        
                        
                        <?php if (!empty($shipping_items_unique_meta_keys)) : asort($shipping_items_unique_meta_keys);  //pree($wpqs_meta_key_columns); 
						?>
                        <optgroup label="<?php _e('Shipping Item Meta', 'woo-order-splitter'); ?>">
							<?php foreach ($shipping_items_unique_meta_keys as $meta_key) : ?>
								<option value="shipping_item_meta|<?php echo $meta_key->meta_key; ?>" ><?php echo $meta_key->meta_key; ?></option>
							<?php endforeach; ?>
                        </optgroup>
						<?php endif; ?>
                        
                        
						
						<?php if (!empty($orders_unique_meta_keys)) : asort($orders_unique_meta_keys);  //pree($wpqs_meta_key_columns); 
						?>
                        <optgroup label="<?php _e('Order Meta', 'woo-order-splitter'); ?>">
							<?php foreach ($orders_unique_meta_keys as $meta_key) : ?>
								<option value="order_meta|<?php echo $meta_key->meta_key; ?>" ><?php echo $meta_key->meta_key; ?></option>
							<?php endforeach; ?>
					    </optgroup>                            
						<?php endif; ?>
                       
                        
                        
                        
                        
					</select>
						
					</td>
					
                    </tr>
                    <tr>
                    
					<td colspan="2" align="left">
						
						<button class="button button-secondary wc_os_group_cat_meta_save"><?php _e('Save Meta', 'woo-order-splitter'); ?></button>
					
					</td>
                    <tr>
                    
                    <td colspan="2" align="left">
                    <span class="wc_os_group_cat_meta_msg">
                    	<?php _e('Updated successfully.', 'woo-order-splitter'); ?>
                    </span>
                    </td>
					</tr>
				</table>
			</div>
		<?php
	}
	
	function wc_os_meta_keys_array($index='', $group=''){
		
		$return = array();
		$wc_os_group_meta = get_option('wc_os_group_meta', array());	
		$wc_os_group_meta = (is_array($wc_os_group_meta)?$wc_os_group_meta:array());
		
		if(
			!empty($wc_os_group_meta) 
			&& 
			array_key_exists('wc_os_cats', $wc_os_group_meta) 
			&& 
			array_key_exists($index, $wc_os_group_meta['wc_os_cats'])
			&&
			array_key_exists($group, $wc_os_group_meta['wc_os_cats'][$index])
		){
			//this array contains line_item, shipping, order_meta with | seperator
			$return = $wc_os_group_meta['wc_os_cats'][$index][$group];
		}
		
		return $return;
	}
			
	function wc_os_group_cat_meta_post(){
		
		
		if(isset($_POST['action']) && 'wc_os_group_cat_meta_post' == $_POST['action']){
			
			$selected_group = sanitize_wc_os_data($_POST['wc_os_selected_group']);
			$selected_meta = sanitize_wc_os_data($_POST['wc_os_selected_meta']);	
	
			$wc_os_group_meta = get_option('wc_os_group_meta', array());	
			$wc_os_group_meta = (is_array($wc_os_group_meta)?$wc_os_group_meta:array());
	
			$wc_os_group_meta['wc_os_cats']['group_cats'][$selected_group] = $selected_meta;
	
			update_option('wc_os_group_meta', $wc_os_group_meta);
	
			$wc_os_group_meta = get_option('wc_os_group_meta', array());	
			$wc_os_group_meta = (is_array($wc_os_group_meta)?$wc_os_group_meta:array());
			//pree($wc_os_group_meta);
			//pree(wc_os_meta_keys_array('group_cats', $selected_group));
	
	
	
		
			echo json_encode($wc_os_group_meta);
			exit;
	
		}
		
	}
	
	add_action('wp_ajax_wc_os_group_cat_meta_post', 'wc_os_group_cat_meta_post');
		
	add_action('parse_query','filter_posts_per_meta_value');
	
	function filter_posts_per_meta_value( $query ) {
	
		global $pagenow, $post_type;
		// Only add parmeeters if on shop_order and if all is not selected
		if( $pagenow == 'edit.php' && $post_type == 'shop_order' && isset($_GET['parent_order']) && $_GET['parent_order'] != '' && is_numeric($_GET['parent_order']) ) {
			
			$parent_order = sanitize_wc_os_data($_GET['parent_order']);
			
	
			$query->query_vars['post_status'] = 'any';
			$query->query_vars['meta_query']['relation'] = 'OR';
			
			$query->query_vars['meta_query'][] = array(
				'key' => 'cloned_from',
				'value' => $parent_order,
				'compare' => '=',
			);
			
			$query->query_vars['meta_query'][] = array(
				'key' => 'splitted_from',
				'value' => $parent_order,
				'compare' => '=',
			);
			
			
	
		}
		
		//pre($query->query_vars);
	
	}
	
	if(!function_exists('wc_os_expected_child_orders_by_cart')){
		function wc_os_expected_child_orders_by_cart(){
			WC()->session = new WC_Session_Handler();
			WC()->session->init();						
			return wc_os_get_session('wc_os_expected_child_orders');//WC()->session->get('wc_os_expected_child_orders');
		}
	}
	
	
	
	if(!function_exists('wc_os_child_orders_by_order_id')){
		function wc_os_child_orders_by_order_id($order_id=0, $ids_only=false){
			
			$ret = array();
			
			if(!$order_id){
				return $ret;
			}
		
			$args = array(
				 'posts_per_page' => -1,
				 'post_type'      => 'shop_order',
				 'post_status'    => 'any',
				 
			);
			//pree($ids_only);
			if($ids_only){
				$args['fields'] = 'ids';
			}
			
			$args['meta_query']['relation'] = 'OR';
			
			$args['meta_query'][] = array(
				'key' => 'cloned_from',
				'value' => $order_id,
				'compare' => '=',
			);
			
			$args['meta_query'][] = array(
				'key' => 'splitted_from',
				'value' => $order_id,
				'compare' => '=',
			);				
			//pree($args);
			$ret = get_posts( $args );
			//pree($ret);
			
			//$wpdb->get_results("SELECT post_id FROM ".$wpdb->prefix."postmeta WHERE meta_key IN ('cloned_from', 'splitted_from') AND meta_value IN (".$query_string['order_id'].")")
			
			return $ret;
		}
	}
	
	add_action('woocommerce_checkout_after_customer_details', 'wc_os_before_cart_content_premssion');

	if(!function_exists('wc_os_before_cart_content_premssion')){
		function wc_os_before_cart_content_premssion($return = false){
			
			global $wc_os_general_settings, $wc_os_pro;
			
			$wc_os_customer_permitted = '';
			
			$wc_os_packages_overview = array_key_exists('wc_os_packages_overview', $wc_os_general_settings);
			$wc_os_customer_permission_text = array_key_exists('wc_os_customer_permission_text', $wc_os_general_settings) && trim($wc_os_general_settings['wc_os_customer_permission_text'])?$wc_os_general_settings['wc_os_customer_permission_text']:__('Confirm to split your order?', 'woo-order-splitter');
			
			$wc_os_customer_permission = array_key_exists('wc_os_customer_permission', $wc_os_general_settings);
			
			//pree(!$wc_os_customer_permission);
			
			if($wc_os_customer_permission){
				$wc_os_customer_permitted = '<div class="wc_os_customer_permission"><input type="checkbox" value="yes"  id="wc_os_customer_permitted" name="wc_os_customer_permitted" '.(wc_os_get_session( 'wc_os_customer_permitted')=='on'?'checked="checked"':'').' /><label for="wc_os_customer_permitted" >'.$wc_os_customer_permission_text.'</label></div>';
				
				if(wc_os_get_session( 'wc_os_customer_permitted') == 'on'){
				
					$wc_os_customer_permitted .= '<style type="text/css">.woocommerce-checkout-review-order-table thead, .woocommerce-checkout-review-order-table tbody{display: none}</style>';
				
				}				
			}else{
				
			}
			//pree('A '. $return. ' - '.$wc_os_customer_permission);
			//pree($wc_os_customer_permitted);

			if($return){
				return $wc_os_customer_permitted;
			}elseif(
					$wc_os_customer_permission
				
				&&
					(
							!$wc_os_pro
						||
							($wc_os_pro && !$wc_os_packages_overview)
					)
			){     
			    echo $wc_os_customer_permitted;
            }


		}
	}

	if(isset($_GET['shipping_items_test'])){
		add_action('admin_init', 'shipping_items_test');
	}
	
	function shipping_items_test(){
		
		$order_id = sanitize_wc_os_data($_GET['post']);
		
		$original_order = wc_get_order($order_id);
		
		pree(get_post_meta($order_id));
		
		$original_order_shipping_items = $original_order->get_items('shipping');
	
		foreach ( $original_order_shipping_items as $order_item ) {
			//pree($order_item);
			//$item_name = $order_item->get_name();
			//pree($order_item->get_id());
			$order_item_meta = wc_get_order_item_meta( $order_item->get_id(), '');
			pree($order_item_meta);

			$vendor_id = wc_get_order_item_meta( $order_item->get_id(), 'vendor_id',  true);
			pree($vendor_id);
		}
		exit;
	}

   add_action('init', 'wc_os_debug');

	function wc_os_debug(){
		
		
        global  $wc_os_general_settings;

        $order_split_summary = array_key_exists('wc_os_order_split_email', $wc_os_general_settings);
        $order_split_created = array_key_exists('wc_os_order_created_email', $wc_os_general_settings);
        $order_split_created_admin = array_key_exists('wc_os_order_created_email_admin', $wc_os_general_settings);
        $order_split_created = $order_split_summary ? $order_split_created : false;
		
		if(!is_admin() && date('i')%2==0){
			wc_os_emails_to_admin_cron();
		}


    }


    add_action('wc_os_after_order_split', 'wc_os_after_order_split_callback', 10, 2 );

    if(!function_exists('wc_os_after_order_split_callback')){

        function wc_os_after_order_split_callback($new_order_ids=array(), $originalorderid=0){
			
			
			$is_shop_order = (get_post_type($originalorderid)=='shop_order');
			
			//pre($is_shop_order);
			
			if(!$is_shop_order){
				$wc_os_logger_str = $originalorderid.' is not a Valid Order';
				wc_os_logger('email', $wc_os_logger_str);
				
				
				
				return;
			}
			
			
			//pree('wc_os_after_order_split_callback');
			//pree($new_order_ids);pree($originalorderid);
			//pree(get_post_meta($originalorderid));
			//exit;
			
			$wc_os_logger_str = 'PARENT ORDER #'.$originalorderid.' - CHILDREN '.implode(', ', $new_order_ids);
			//wc_os_logger('email', $wc_os_logger_str);
								
			
			global $woocommerce_account_funds, $wc_os_general_settings, $woocommerce, $wc_os_shipping_cost;
			
		
			$mailer = $woocommerce->mailer();
			

			if(function_exists('wc_os_calculate_delivery_date')){
				//pree($new_order_ids);pree($originalorderid);exit;
                wc_os_calculate_delivery_date($new_order_ids, $originalorderid);				
			}
						
            if(function_exists('wc_os_apply_coupon_child_orders')){
                wc_os_apply_coupon_child_orders($new_order_ids, $originalorderid);
            }
			
			$wc_os_logger_str = 'wc_os_apply_coupon_child_orders - CLEARED #1';
			//wc_os_logger('email', $wc_os_logger_str);
			
			if(function_exists('wc_os_update_io_status')){
				wc_os_update_io_status($new_order_ids, $originalorderid);
			}			
			
			$wc_os_logger_str = 'wc_os_update_io_status - CLEARED #2';
			//wc_os_logger('email', $wc_os_logger_str);
						
			if(function_exists('wc_os_update_method_order_status')){
                wc_os_update_method_order_status($new_order_ids, $originalorderid);
			}
			
			$wc_os_logger_str = 'wc_os_update_method_order_status - CLEARED #3';
			//wc_os_logger('email', $wc_os_logger_str);			

			if(function_exists('wc_os_update_group_order_status')){
                wc_os_update_group_order_status($new_order_ids, $originalorderid);
			}	
			
			$wc_os_logger_str = 'wc_os_update_group_order_status - CLEARED #4';
			//wc_os_logger('email', $wc_os_logger_str);	
								
			if($woocommerce_account_funds){
				wc_os_add_funds_used_child($originalorderid, $new_order_ids);
			}

			$wc_os_logger_str = 'wc_os_add_funds_used_child - CLEARED #5';
			//wc_os_logger('email', $wc_os_logger_str);	
			
						
						
            $wc_os_order_combine_email = array_key_exists('wc_os_order_combine_email', $wc_os_general_settings);
			$order_split_summary = array_key_exists('wc_os_order_split_email', $wc_os_general_settings);
            $order_split_created = array_key_exists('wc_os_order_created_email', $wc_os_general_settings); //New Orders Created After Split - Customer
            $order_split_created_admin = array_key_exists('wc_os_order_created_email_admin', $wc_os_general_settings); //New Orders Created After Split - Admin		
			$order_split_created_vendor = wc_os_order_vendor_email_status();
			
			//pre('$wc_os_order_combine_email: '.$wc_os_order_combine_email);//exit;
			//pre('$order_split_summary: '.$order_split_summary);//exit;
			//pre('$order_split_created: '.$order_split_created);//exit;
			//pre('$order_split_created_admin: '.$order_split_created_admin);//exit;
			//pre('$order_split_created_vendor: '.$order_split_created_vendor);//exit;
			
	
			
			
							
            //$order_split_created = $order_split_summary ? $order_split_created : false;
			
			//pree('$order_split_summary: '.$order_split_summary);
			//pree('$order_split_created: '.$order_split_created);
			//pree('$order_split_created_admin: '.$order_split_created_admin);
			//pree('$order_split_created: '.$order_split_created);exit;

            if($order_split_summary){

                wos_email_notification(array('new'=>$new_order_ids, 'original'=>$originalorderid), 'split');

            }


            /*$emails_array = array(

                'WC_Email_New_Order' => 'new_order',
                'WC_Email_Cancelled_Order' => 'cancelled_order',
                'WC_Email_Failed_Order' => 'failed_order',
                'WC_Email_Customer_On_Hold_Order' => 'customer_on_hold_order',
                'WC_Email_Customer_Processing_Order' => 'customer_processing_order',
                'WC_Email_Customer_Completed_Order' => 'customer_completed_order',
                'WC_Email_Customer_Refunded_Order' => 'customer_refunded_order',
                'WC_Email_Customer_Invoice' => 'customer_invoice',
                'WC_Email_Customer_Note' => 'customer_note',
                'WC_Email_Customer_Reset_Password' => 'customer_reset_password',
                'WC_Email_Customer_New_Account' => 'customer_new_account',

            );*/

			//pree($order_split_created.' || '.$order_split_created_admin);exit;
			
            if(!empty($new_order_ids)){
                //pree($new_order_ids);exit;
               
				
				
				//pree($new_order_ids);exit;
				

                foreach ($new_order_ids as $new_oder){
                    //pree($new_oder);
					//pree(get_post_meta($new_oder));exit;
					//$post_meta = get_post_meta($new_oder);
					//$post_meta = array_keys($post_meta);
					//pree($post_meta);
					//continue;
					
					$new_oder = is_array($new_oder)?current($new_oder):$new_oder;
					
					if(!is_numeric($new_oder))
					continue;
					
					$is_shop_order = (get_post_type($new_oder)=='shop_order');
					
					if(!$is_shop_order)
					continue;
							
					if(class_exists('WCML_Emails')){
						global $sitepress;
						$wpml_language = get_post_meta($new_oder, 'wpml_language', true);
						$language = $wpml_language?$wpml_language:'en';
						$sitepress->switch_lang( $language, true );
						$sitepress->set_admin_language( $language );				
					}


                    wc_downloadable_product_permissions($new_oder);
					
					//pre(('$order_split_created: '.$order_split_created.' || $order_split_created_admin: '.$order_split_created_admin.' || $order_split_created_vendor: '.$order_split_created_vendor));

                    if($order_split_created || $order_split_created_admin || $order_split_created_vendor){
						
						
						delete_post_meta($new_oder, '_new_order_email_sent');



                        $wc_mailer = WC()->mailer();
                        $mails = $wc_mailer->get_emails();
						
						//pree(array_keys($mails));exit;

                        $order = new WC_Order($new_oder);
						
						//pree($order->get_id());
						//pree(get_post_meta($order->get_id()));
						//pree($order->get_shipping_methods());

                        $order_status = $order->get_status();

                        switch($order_status){

                            case 'completed':

                                $email_template = $mails['WC_Email_Customer_Completed_Order'];

                                break;

                            case 'pending':

                                $email_template = $mails['WC_Email_Customer_On_Hold_Order'];

                                break;

                            case 'processing':

                                $email_template = $mails['WC_Email_Customer_Processing_Order'];

                                break;


                            case 'cancelled':

                                $email_template = $mails['WC_Email_Cancelled_Order'];

                                break;


                            case 'refunded':

                                $email_template = $mails['WC_Email_Customer_Refunded_Order'];

                                break;

                            case 'failed':

                                $email_template = $mails['WC_Email_Failed_Order'];

                                break;


                            default:

                                if($order->is_paid()){

                                    $email_template = $mails['WC_Email_Customer_Processing_Order'];

                                }else{

                                    $email_template = $mails['WC_Email_Customer_On_Hold_Order'];

                                }


                                break;


                        }

						$new_order_email_template = $mails['WC_Email_New_Order'];

                        if($order_split_created){
							$wc_os_logger_str = $new_oder.' - '.$order_status.' - New Orders Created After Split - Customer';
							//pree($wc_os_logger_str);exit;
							//wc_os_logger('email', $wc_os_logger_str);
							$email_template->trigger($new_oder);	//New Orders Created After Split - Customer
							
							/*
							$trigger_email_data = wc_os_trigger_email($new_oder, $email_template, 'body');
							//pree($trigger_email_data['body']);//exit;
							//wc_os_emails_to_resend_cron()
							$for_shipping1 = explode('Shipping:', $trigger_email_data['message']);
							
							if($wc_os_shipping_cost && count($for_shipping1)<=1){
								
								$emails_stack = get_option('wc_os_emails_to_resend_cron', array());
								$emails_stack = (is_array($emails_stack)?$emails_stack:array());
								if(!array_key_exists($new_oder, $emails_stack)){
									$emails_stack[$new_oder] = false;
									update_option('wc_os_emails_to_resend_cron', $emails_stack);
								}
								
							}else{			
												
								$trigger_email_status = $mailer->send($email_template->recipient, $trigger_email_data['subject'], $trigger_email_data['body'], $trigger_email_data['headers']);
								
							}*/
							
                        }

						//wc_os_logger('email', '$order_split_created_vendor: '.$order_split_created_vendor);
						//wc_os_logger('email', 'wc_os_vendor_email_template: '.$wc_os_general_settings['wc_os_vendor_email_template']);
						
                        if($order_split_created_vendor){
							
							$wc_os_vendor_email_template =  $new_order_email_template;
							
							
							if(array_key_exists('wc_os_vendor_email_template', $wc_os_general_settings) && $wc_os_general_settings['wc_os_vendor_email_template']!=''){
								$wc_os_vendor_email_template_str = $wc_os_general_settings['wc_os_vendor_email_template'];
								if(array_key_exists($wc_os_vendor_email_template_str, $mails)){
									$wc_os_vendor_email_template =  $mails[$wc_os_vendor_email_template_str];
								}
							}else{
								
							}
							
							
							//$wc_os_logger_str = $new_oder.' - '.$order_status.' - New Order Email - to Vendor - Fetching Vendor Information';
							//wc_os_logger('email', $wc_os_logger_str);
							//pree($new_oder);
							//pree(get_post_meta($originalorderid));
                            $user_info = wc_os_get_order_vendor($new_oder);
							
							
							
							//pree($user_info);exit;
                            if(!empty($user_info)){
								
								//$wc_os_logger_str = $new_oder.' - '.$order_status.' - New Order Email - to Vendor - Ready to Send';
								//wc_os_logger('email', $wc_os_logger_str);
								
								//pree($new_oder.' - _new_order_email_sent > '.get_post_meta($new_oder, '_new_order_email_sent', true));

                                $wc_os_vendor_email_template->recipient = $wc_os_vendor_email_template->settings['recipient'] = $user_info->user_email;
                                //pree($new_order_email_template);//exit;
								
								//$subject = $wc_os_vendor_email_template->get_subject();
								//$content = $wc_os_vendor_email_template->get_content();
								//$headers = $wc_os_vendor_email_template->get_headers();
								//$attachments = $wc_os_vendor_email_template->get_attachments();
								//pree($content);
								//exit;
								//wc_os_logger('email', 'is_object($wc_os_vendor_email_template): '.(is_object($wc_os_vendor_email_template)?'YES':'NO'));
								//pree($wc_os_vendor_email_template);
								//wc_os_logger('email', $wc_os_vendor_email_template);
								if(is_object($wc_os_vendor_email_template)){
									//pree($wc_os_vendor_email_template);exit;
									//wc_os_logger('email', 'Vendor Email Sent');
									//$wc_os_vendor_email_template->trigger($new_oder); REPLACING THIS TRIGGER WITH OUR CUSTOM TRIGGER ON 22/06/2021
									
									//$trigger_email_status = $mailer->send($wc_os_vendor_email_template->recipient, 'SUPPOSED TO SEND FOR #'.$new_oder, date('h:i:s A'));
									
									$trigger_email_data = wc_os_trigger_email($new_oder, $wc_os_vendor_email_template, 'body');
									
									
									
									//wc_os_logger('email', $trigger_email_data['subject']);
									//wc_os_logger('email', $trigger_email_data['message']);
									//wc_os_logger('email', $trigger_email_data['headers']);
									
									//pree($trigger_email_data);exit;
									//$trigger_email_status = $mailer->send($wc_os_vendor_email_template->recipient, $trigger_email_data['subject'], '$trigger_email_data[\'body\']', $trigger_email_data['headers']);//$trigger_email_data['message']
									//add_filter( 'wp_mail_content_type','wc_os_set_email_content_type' );
									$trigger_email_status = $mailer->send($wc_os_vendor_email_template->recipient, $trigger_email_data['subject'], $trigger_email_data['body'], $trigger_email_data['headers']);//$trigger_email_data['message']
									//remove_filter( 'wp_mail_content_type','wc_os_set_email_content_type' );
									//pree(wp_mail($wc_os_vendor_email_template->recipient, $trigger_email_data['subject'], $trigger_email_data['body'], $trigger_email_data['headers']));
									
									//wc_os_logger('email', 'Vendor Email Sent > '.($trigger_email_status?'Yes':'No').' to '.$user_info->user_email);
									
									//pree($trigger_email_data);exit;
									
									//pree($wc_os_vendor_email_template->trigger($new_oder));exit;
								}else{
									//wc_os_logger('email', 'Vendor Email Not Sent');
								}
								//exit;
								//WC>inclues/class-wc-email - SENDING - line 356
								//WC>inclues/emails/class-wc-email - FILTERING - line 645
								//WC>inclues/emails/class-wc-email-new-order - TRIGGER - line 84
								//woocommerce-product-vendors/includes/emails/class-wc-product-vendors-order-email-to-vendor.php - TRIGGER - 46
							
								//pree($new_order_email_template->recipient);
								//$mailer->send($wc_os_vendor_email_template->recipient, 'SUPPOSED TO SEND FOR #'.$new_oder, date('h:i:s A'));
								
								//$wc_os_logger_str = $new_oder.' - '.$order_status.' - Bypassing Default WC Trigger';
								//wc_os_logger('email', 'SENDING TO --- '.$wc_os_vendor_email_template->recipient);
								
								
								//pree($new_oder.' - _new_order_email_sent > '.get_post_meta($new_oder, '_new_order_email_sent', true));
								
								$wc_os_logger_str = $new_oder.' - '.$order_status.' - New Order Email <i class="fas fa-envelope-open-text"></i> - to Vendor - Sent to '.$user_info->user_email;
								//wc_os_logger('email', $wc_os_logger_str);
							
                                //($wc_os_mailer->send_mail($user_info->user_email, $_wos_parent_email['subject'], $_wos_parent_email['message'])?__('Vendor Success', 'woo-order-splitter'):__('Vendor Failure', 'woo-order-splitter')).'<br />';

                            }else{
								//$wc_os_logger_str = 'Vendor Information Missing';
								//wc_os_logger('email', $wc_os_logger_str);
							}

                        }
						if($order_split_created_admin){

                            //pree('$order_split_created_admin: '. $order_split_created_admin);
							//pree($new_oder);
							$wc_os_logger_str = 'Stacking ORDER# '.$new_oder.' for Email';
							//wc_os_logger('email', $wc_os_logger_str);
							
							
							//$new_order_email_template->trigger($new_oder);	//New Orders Created After Split - Admin
                            
							$emails_stack = get_option('wc_os_emails_to_admin', array());
							$emails_stack = (is_array($emails_stack)?$emails_stack:array());
							if(!array_key_exists($new_oder, $emails_stack)){
								$emails_stack[$new_oder] = false;
								update_option('wc_os_emails_to_admin', $emails_stack);
							}
							
							//$emails_stack = get_option('wc_os_emails_to_admin', array());
							//wc_os_logger('email', '$emails_stack');
							//wc_os_logger('email', $emails_stack);
							
							//wc_os_logger('email', '$email_template->trigger($new_oder);');
							//$email_template->trigger($new_oder);

                        }


                    }

                   	if(class_exists('WCML_Emails')){		
						do_action('wpml_restore_language_from_email');		
					}

                }

            }
			
			
		



        }
    }

    if(!function_exists('wc_os_user_ids_by_vendor')){

        function wc_os_user_ids_by_vendor($vendor = '', $array = true){

            $user_ids = array();


            if($vendor){


                $args = array(
                    'role' => $vendor,
                );


            }else{

                $args = array();
            }


            $users = get_users($args);

            if(!empty($users)){
                foreach ($users as $user){

                    $user_ids[] = $user->ID;
                }
            }

            if($array){

                return $user_ids;

            }else{


                $user_ids = array_map(function ($user_id){

                    return array('post_author' => $user_id );

                }, $user_ids);


                return json_decode(json_encode($user_ids));
            }

        }

    }


    add_action('wp_ajax_wc_os_update_vendor_role_selection', 'wc_os_update_vendor_role_selection');
    if(!function_exists('wc_os_update_vendor_role_selection')){

        function wc_os_update_vendor_role_selection(){


            if(isset($_POST['wc_os_vendor_role_selection'])){


                if (
                    ! isset( $_POST['wc_os_vendors_field'] )
                    || ! wp_verify_nonce( $_POST['wc_os_vendors_field'], 'wc_os_vendors_action' )
                ) {

                    _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
                    exit;

                } else {
					

                    $wc_os_settings = get_option('wc_os_settings', array());
                    $wc_os_vendors = array_key_exists('wc_os_vendors', $wc_os_settings) ? $wc_os_settings['wc_os_vendors'] : array();
					//pree($wc_os_vendors);exit;

                    $wc_os_vendor_role_selection = ($_POST['wc_os_vendor_role_selection'] ==  'false' ? '' : sanitize_wc_os_data($_POST['wc_os_vendor_role_selection']));
                    $wc_os_all_user_with_role = isset($_POST['wc_os_all_user_with_role']) && $_POST['wc_os_all_user_with_role'] ==  'true' ? true : false;
					
					//pree($_POST);pree($wc_os_all_user_with_role);exit;
                    $wc_os_user_ids = wc_os_user_ids_by_vendor($wc_os_vendor_role_selection);

                    if(!empty($wc_os_vendors)){

                        $new_os_vendors = array();

                        foreach ($wc_os_vendors as $group => $users){

                            if($group !== 0){

                                $users =  array_intersect($wc_os_user_ids, $users);


                            }

                            if(!empty($users)){

                                $new_os_vendors[$group] = $users;

                            }

                        }

                        $wc_os_settings['wc_os_vendors'] = $new_os_vendors;
                        update_option('wc_os_settings', $wc_os_settings);


                    }


                    update_option('wc_os_vendor_role_selection', $wc_os_vendor_role_selection);
                    update_option('wc_os_all_user_with_role', $wc_os_all_user_with_role);
					//pree(get_option('wc_os_all_user_with_role', true));exit;

                }

            }


            wp_die();

        }
    }
	
	add_action( 'init', 'wc_os_init_hook' );
	
	function wc_os_init_hook() {
		
		//wp_ims_delete_checkout_item();
		//wp_ims_update_checkout_item_qty();
		if(isset($_GET['reorder'])){
			
			$order_id = sanitize_wc_os_data($_GET['reorder']);
			if($order_id && is_numeric($order_id)){
				$order = wc_get_order($order_id);
				if(empty($order)){ 
				
					die(__('Invalid Order ID', 'woo-order-splitter'));
				}
				//pree($order);
				//pree($order->get_items());
				WC()->cart->empty_cart();
				WC()->session->set('cart', array());
				
				foreach($order->get_items() as $key=>$val){
					//pree($val->get_id());
					//pree($val->get_product_id());
					//pree($val->get_quantity());
					//pree($val->get_variation_id());
					
					WC()->cart->add_to_cart( $val->get_product_id(), $val->get_quantity(), $val->get_variation_id() );
				}
				
				wp_redirect(wc_get_checkout_url());exit;
			}
			
			//exit;
		}
	}	
			
	if(!function_exists('wc_os_add_funds_used_child')){
		
		function wc_os_add_funds_used_child($original_id, $child_orders){
		
			global $wc_os_general_settings;
	
			$wc_os_settings = get_option('wc_os_settings', array());
			$split_type = $wc_os_settings['wc_os_ie'];
	
			$remove_parent_types = array('io');
	
			$remove_items_from_parents = array_key_exists('wc_os_effect_parent', $wc_os_general_settings);
			
			$args = array(
				
				'post_type' => 'shop_order',
				'post_status' => 'any',
				'numberposts' => -1,
				'include' => array($original_id),
				'meta_query' => array(
					array(
						'key' => '_funds_used',
						'compare' => 'EXIST'
					)
				)
			
			);
			
			$funds_order = get_posts($args);
			$total_funds = get_post_meta($original_id, '_funds_used', true);
			$funds_used = 0;
	
			if(in_array($split_type, $remove_parent_types) && $remove_items_from_parents){
				array_unshift($child_orders,$original_id);
			}
			
			
			
			if(empty($funds_order) || $total_funds <= 0) {return;}
			
			
			
			//	$original_order = new WC_Order($original_id);
			//	$full_total = $original_order->calculate_totals();
			//	$total_after_funds = $full_total - $total_funds;
			// $original_order->set_total($total_after_funds);
			// $original_order->save();
			
			
			
			if(!empty($child_orders)){
			
				foreach ($child_orders as $child_order_id){
				
				
					
					$child_order = new WC_Order($child_order_id);
					$full_total_child = $child_order->get_subtotal();
					
					
					// if($total_funds == 0){
					//
					// delete_post_meta($child_order_id, '_funds_used');
					// delete_post_meta($child_order_id, '_funds_removed');
					//
					//
					// continue;
					// }
					
					if($full_total_child > $total_funds){
					
					
						
						$child_new_total = $full_total_child - $total_funds;
						$funds_used = $total_funds;
						$funds_used_by_current = $total_funds;
						$total_funds = $total_funds - $funds_used;
						
					
					
					}else{
					
					
						$total_funds = $total_funds - $full_total_child;
						$child_new_total = 0;
						$funds_used = $funds_used + $full_total_child;
						$funds_used_by_current = $full_total_child;
						
					}
					
					
					
					$child_order->set_total($child_new_total);
					$child_order->save();
					
					
					update_post_meta($child_order_id, '_funds_used', $funds_used_by_current);
					update_post_meta($child_order_id, '_funds_removed', 1);
				
				
				}
			
			
			
			}
		
		
		}
		
	}

	add_action('woocommerce_analytics_update_order_stats', 'wc_os_update_order_lookup_tables');
    add_action('woocommerce_analytics_update_product', 'wc_os_update_product_lookup_tables', 10, 2);
    add_action('woocommerce_analytics_update_coupon', 'wc_os_update_coupon_lookup_tables', 10, 2);
    add_action('woocommerce_analytics_update_tax', 'wc_os_update_tax_lookup_tables', 10, 2);


    function wc_os_update_lookup_tables($order_id, $table_name_without_prefix){

		global $wpdb, $wc_os_general_settings;	

		$wc_os_settings = get_option('wc_os_settings', array());

		$wc_os_settings['wc_os_additional'] = isset($wc_os_settings['wc_os_additional']) ? $wc_os_settings['wc_os_additional'] : array();

		$is_split_off = in_array('split', $wc_os_settings['wc_os_additional']);

		if($is_split_off){return;}


		$split_type = $wc_os_settings['wc_os_ie'];
		$remove_parent_types = array('io', 'exclusive', 'inclusive');
		$remove_items_from_parents = array_key_exists('wc_os_effect_parent', $wc_os_general_settings);
		$is_parent_effected = in_array($split_type, $remove_parent_types) && $remove_items_from_parents;


		$parent_order_id = get_post_meta($order_id, 'splitted_from', true);
		$parent_order_items = array();

		if($parent_order_id){
			$parent_order = new WC_Order($parent_order_id);
			$parent_order_items = $parent_order->get_items();

			if(empty($parent_order_items)){

				$order_stats_table = $wpdb->prefix.'wc_order_stats';
				$query_order = "DELETE FROM $order_stats_table WHERE order_id = $parent_order_id";
				$wpdb->query($query_order);



				update_post_meta($order_id, '_wc_os_report_included', 'yes');
				update_post_meta($parent_order_id, '_wc_os_report_included', 'no');
				delete_option( '_transient_wc_report_sales_by_date');	

			}



		}

//        $wc_os_parent_order =  get_post_meta($order_id, '_wc_os_parent_order', true);
		$wc_os_child_order =  get_post_meta($order_id, '_wc_os_child_order', true);
		$force_sync =  get_post_meta($order_id, '_wc_os_force_sync', true);


        if(!wc_os_order_removal() && $wc_os_child_order == 'yes' && !$force_sync && !$is_parent_effected && !empty($parent_order_items )){

            $prodcut_lookup_table = $wpdb->prefix.$table_name_without_prefix;
            $query_product = "DELETE FROM $prodcut_lookup_table WHERE order_id = $order_id";
            $result = $wpdb->query($query_product);

        }

    }

    function wc_os_update_order_lookup_tables ($order_id){

		global $wpdb, $wc_os_general_settings;	

		$wc_os_settings = get_option('wc_os_settings', array());

		$wc_os_settings['wc_os_additional'] = isset($wc_os_settings['wc_os_additional']) ? $wc_os_settings['wc_os_additional'] : array();

		$is_split_off = in_array('split', $wc_os_settings['wc_os_additional']);

		if($is_split_off){return;}


		$split_type = $wc_os_settings['wc_os_ie'];
		$remove_parent_types = array('io', 'exclusive', 'inclusive');
		$remove_items_from_parents = array_key_exists('wc_os_effect_parent', $wc_os_general_settings);
		$is_parent_effected = in_array($split_type, $remove_parent_types) && $remove_items_from_parents;
		if($is_parent_effected){

			update_post_meta($order_id, '_wc_os_report_included', 'yes');
			delete_option( '_transient_wc_report_sales_by_date');

		}

		$parent_order_id = get_post_meta($order_id, 'splitted_from', true);
		$parent_order_items = array();

		if($parent_order_id){
			$parent_order = new WC_Order($parent_order_id);
			$parent_order_items = $parent_order->get_items();

			if(empty($parent_order_items)){

				$order_stats_table = $wpdb->prefix.'wc_order_stats';
				$query_order = "DELETE FROM $order_stats_table WHERE order_id = $parent_order_id";
				$wpdb->query($query_order);



				update_post_meta($order_id, '_wc_os_report_included', 'yes');
				update_post_meta($parent_order_id, '_wc_os_report_included', 'no');
				delete_option( '_transient_wc_report_sales_by_date');	

			}



		}

//        $wc_os_parent_order =  get_post_meta($order_id, '_wc_os_parent_order', true);
        $wc_os_child_order =  get_post_meta($order_id, '_wc_os_child_order', true);

	   $force_sync =  get_post_meta($order_id, '_wc_os_force_sync', true);
	   
	  

        if(!wc_os_order_removal() && $wc_os_child_order == 'yes' && !$force_sync && !$is_parent_effected && !empty($parent_order_items)){

            $order_stats_table = $wpdb->prefix.'wc_order_stats';
            $query_order = "DELETE FROM $order_stats_table WHERE order_id = $order_id";
            $wpdb->query($query_order);

        }
		if(class_exists('ReportsCache')){
			ReportsCache::invalidate();
		}


    }

    function wc_os_update_product_lookup_tables ($order_item_id, $order_id){

        wc_os_update_lookup_tables($order_id, 'wc_order_product_lookup');

		if(class_exists('ReportsCache')){
			ReportsCache::invalidate();
		}

    }

    function wc_os_update_coupon_lookup_tables ($coupon_id, $order_id){

        wc_os_update_lookup_tables($order_id, 'wc_order_coupon_lookup');

		if(class_exists('ReportsCache')){
			ReportsCache::invalidate();
		}

    }

    function wc_os_update_tax_lookup_tables ($tax_item_rate_id, $order_id){

        wc_os_update_lookup_tables($order_id, 'wc_order_tax_lookup');

		if(class_exists('ReportsCache')){
			ReportsCache::invalidate();
		}

    }

    add_action('wc_os_after_order_split', 'wc_os_add_order_meta_after_split', 10, 2 );

    function wc_os_add_order_meta_after_split($new_order_ids, $original_order){
		
		global $wc_os_settings, $wpdb;
		$wc_os_ie_selected = $wc_os_settings['wc_os_ie'];

        if($original_order){

			update_post_meta($original_order, '_wc_os_parent_order', 'yes');
			
        }

        if(!empty($new_order_ids)){
			
			global $wc_os_wcfm_installed;
			
            foreach ($new_order_ids as $order_id){

                update_post_meta($order_id, '_wc_os_child_order', 'yes');
                update_post_meta($order_id, '_wc_os_report_included', 'no');
				
				
				
				if ($wc_os_ie_selected=='group_by_vendors'){
					if($wc_os_wcfm_installed) {
						$vendor_shipping_rate = 0;
						
						$newOrder = wc_get_order($order_id);
						//$get_order = wc_get_order($order_id);
						if(!empty($newOrder)){
							//$vendor_shipping_rate = $get_order->get_shipping_total();
							$newOrderData = $newOrder->data;
							$shippingTotal = $newOrderData['shipping_total'];

							$wpdb->query("UPDATE ".$wpdb->prefix."wcfm_marketplace_orders SET shipping='$shippingTotal' WHERE order_id=$order_id");
						}
					}
				}
				
				
				if ($wc_os_ie_selected=='group_by_vendors'){
					if(in_array('wcfm_marketplace_orders', $wpdb->tables)) {
				  
					  $vendor_shipping_rate = 0;
					  
					  $get_order = wc_get_order($order_id);
					  
					  if(!empty($get_order)){
						  $vendor_shipping_rate = $get_order->get_shipping_total();				  
						  $wpdb->query("UPDATE ".$wpdb->prefix."wcfm_marketplace_orders SET shipping='$vendor_shipping_rate' WHERE order_id=$order_id");
					  }					  
					}					  
				}

            }
			
			
        }
		
		

    }

	


    add_action('woocommerce_reports_get_order_report_query', function($query){
		global $wpdb;

        $query['join'] .= " LEFT JOIN $wpdb->postmeta as wc_os_postmeta ON (posts.ID = wc_os_postmeta.post_id AND wc_os_postmeta.meta_key = '_wc_os_report_included' )";
        $query['where'] .= " AND ((wc_os_postmeta.meta_key IN ('_wc_os_report_included') AND wc_os_postmeta.meta_value = 'yes') OR wc_os_postmeta.post_id IS NULL) ";
        return $query;

	});
	

	add_action('wp_trash_post', 'wc_os_update_child_orders_stats');

	function wc_os_update_child_orders_stats($order_id){

		

		$wc_os_parent_order = get_post_meta($order_id, '_wc_os_parent_order', true);
		if($wc_os_parent_order){

				$args = array(

					'numberposts' => -1,
					'post_type' => 'shop_order',
					'post_status' => 'any',
					'fields' => 'ids',
					'meta_query' => array(

						array(

							'key' => 'splitted_from',
							'value' => $order_id,
							'compare' => '=',
						),

					),


				);


				$get_child_ids = get_posts($args);

				if(!empty($get_child_ids)){
					foreach($get_child_ids as $child_id){

						update_post_meta($child_id, '_wc_os_force_sync', true);

						$results = array(


							class_exists('OrdersStatsDataStore')?OrdersStatsDataStore::sync_order( $child_id ):'',
							class_exists('ProductsDataStore')?ProductsDataStore::sync_order_products( $child_id ):'',
							class_exists('CouponsDataStore')?CouponsDataStore::sync_order_coupons( $child_id ):'',
							class_exists('TaxesDataStore')?TaxesDataStore::sync_order_taxes( $child_id ):'',
	
						);

						update_post_meta($child_id, '_wc_os_report_included', 'yes');
						delete_post_meta($child_id, '_wc_os_force_sync');


					}

					update_post_meta($order_id, '_wc_os_report_included', 'no');
					if(class_exists('ReportsCache')){
						ReportsCache::invalidate();
					}
					delete_option( '_transient_wc_report_sales_by_date');

				}

		}

	}
		
	
	if(!function_exists('wos_get_order_name')){
		function wos_get_order_name(){
	
			global $wpdb;
	
			$name = __('order-', 'woo-order-splitter');
			$name .= strftime( _x( '%B-%d-%Y-%I%M-', 'Order date parsed by strftime', 'woo-order-splitter' ) );
			$name .= date('a', time());
	
	//            $name = 'order-November-25-2020-0936-am';
	
			$name_posts = "SELECT * FROM $wpdb->posts WHERE ID = (SELECT MAX(ID) FROM $wpdb->posts WHERE post_name LIKE '$name%')";
			$name_row = $wpdb->get_row($name_posts);
			$prev_name = $name_row ? $name_row->post_name : $name;
			$prev_name_explode = explode('-', $prev_name);
			$prev_name = end($prev_name_explode);
	
	
			if($prev_name != 'am' && $prev_name != 'pm'){
				$prev_name++;
				$name .= '-'.$prev_name;
			}else{
				$name .= '-'.'1';
	
			}
	
			return $name;
		}
	}
	
	
	if(!function_exists('wos_get_post_title')){
	
		function wos_get_post_title() {
			// @codingStandardsIgnoreStart
			/* translators: %s: Order date */
			return __( 'Order', 'woo-order-splitter' ).' &ndash; '.sprintf( '%s', strftime( _x( '%b %d, %Y @ %I:%M %p', 'Order date parsed by strftime', 'woo-order-splitter' ) ) );

			// @codingStandardsIgnoreEnd
		}
	
	}
	
	if(!function_exists('wos_insert_post')){
		function wos_insert_post($postarr, $wp_error = false){
			global $wpdb;
	
			$unsanitized_postarr = $postarr;
	
			$user_id = get_current_user_id();
	
			$defaults = array(
				'post_author'           => $user_id,
				'post_date'             => current_time( 'mysql' ),
				'post_date_gmt'         => current_time( 'mysql' , 1),
				'post_content'          => '',
				'post_title'            => wos_get_post_title(),
				'post_excerpt'          => '',
				'post_status'           => 'draft',
				'comment_status'        => 'open',
				'ping_status'           => '',
				'post_password'         => '',
				'post_name'             => wos_get_order_name(),//
				'to_ping'               => '',
				'pinged'                => '',
				'post_modified'         => current_time( 'mysql' ),
				'post_modified_gmt'     => current_time( 'mysql', 1 ),
				'post_content_filtered' => '',
				'post_parent'           => 0,
				'guid'                  => '',//
				'menu_order'            => 0,
				'post_type'             => 'post',
				'post_mime_type'        => '',
				'comment_count'         => 0,
	
			);
	
	
	
			$postarr = wp_parse_args( $postarr, $defaults );
	
			unset( $postarr['filter'] );
	
			$postarr = sanitize_post( $postarr, 'db' );
	
			unset( $postarr['filter'] );
			unset( $postarr['ID'] );
	
	
			$data = $postarr;
	
	
			if ( false === $wpdb->insert( $wpdb->posts, $data ) ) {
				if ( $wp_error ) {
	
					$message = __( 'Could not insert post into the database.' );
	
					return new WP_Error( 'db_insert_error', $message, $wpdb->last_error );
				} else {
					return 0;
				}
			}
	
			$post_ID = (int) $wpdb->insert_id;
	
			$where = array( 'ID' => $post_ID );
	
	
			$current_guid = get_post_field( 'guid', $post_ID );
	
			// Set GUID.
			if ('' === $current_guid ) {
				$wpdb->update( $wpdb->posts, array( 'guid' => get_permalink( $post_ID ) ), $where );
			}
	
			return $post_ID;
	
		}
	}
	
	if(!function_exists('wos_update_post')){
	
		function wos_update_post( $postarr = array(), $wp_error = false ) {
	
			global $wpdb;
	
			if ( is_object( $postarr ) ) {
				// Non-escaped post was passed.
				$postarr = get_object_vars( $postarr );
				$postarr = wp_slash( $postarr );
			}
	
	
			// First, get all of the original fields.
			$post = get_post( $postarr['ID'] );
	
			if ( is_null( $post ) ) {
				if ( $wp_error ) {
					return new WP_Error( 'invalid_post', __( 'Invalid post ID.' ) );
				}
				return 0;
			}
			$post = (array) $post;
	
			unset($post['filter']);
	
	
			// Escape data pulled from DB.
			$post = wp_slash( $post );
	
	
			$postarr = array_merge( $post, $postarr );
	
	
			$where = array( 'ID' => $postarr['ID'] );
	
			if ( false === $wpdb->update( $wpdb->posts, $postarr, $where ) ) {
				if ( $wp_error ) {
	
					  $message = __( 'Could not update post in the database.' );
	
	
					return new WP_Error( 'db_update_error', $message, $wpdb->last_error );
				} else {
					return 0;
				}
			}else{
				return $postarr['ID'];
			}
	
	
		}
	
	
	}	
	
	function wc_os_logger($type='email', $data=array()){
		$wc_os_logger = array();
		switch($type){
			case 'email':
				$wc_os_logger = get_option('wc_os_logger');
				
				$wc_os_logger = is_array($wc_os_logger)?$wc_os_logger:array();
				
				if(get_option('wc_os_email_log') && $data){
					$wc_os_logger[] = $data;
					update_option('wc_os_logger', $wc_os_logger);
				}
			break;
			case 'order':
				$wc_os_logger = get_option('wc_os_remove_order_log', array());
				$wc_os_logger = is_array($wc_os_logger)?$wc_os_logger:array();
				
				if(get_option('wc_os_order_log') && !empty($data)){
					$wc_os_logger[] = $data;
					update_option('wc_os_remove_order_log', $wc_os_logger);		
				}
			break;
		}
		
		return $wc_os_logger;
	}
	
	if(!function_exists('wc_os_highlighter')){
		function wc_os_highlighter($str, $type = 1){
			
			$str = str_replace(
				
						array(
							'Customer',
							'New'
						),
						array(
							'<span class="wc-os-highlighter-'.$type.'">Customer</span>',
							'<span class="wc-os-highlighter-2">New</span>'
						),
						$str
						
					);
			
			
			return $str;
		}
	}
	add_action('admin_init', function(){
		if(isset($_GET['wc_os_clear_order_log'])){
			wc_os_clear_order_log(true);
		}
	});