<?php if ( ! defined( 'ABSPATH' ) ) exit;




    class wc_os_order_splitter {
		
		/** @var original order ID. */
		public $original_order_id;
		public $processing;
		public $auto_split;
		public $exclude_items;
		public $include_items;
		public $include_items_qty;
		public $general_array;
		public $cron_in_progress;
		public $clone_in_progress;
		public $force_clone_in_progress;
		
	
		/**
		 * Fire clone_order function on clone request.
		 */
		
		function __construct() {
			
			$this->processing = true;
			$this->auto_split = false;
			$this->exclude_items = array();
			$this->include_items = array();
			$this->include_items_qty = array();
			$this->general_array = array();
			$this->cron_in_progress = false;
			$this->clone_in_progress = false;
			$this->meta_keys_intersection = array();
			
			add_action( 'plugins_loaded', array($this, 'duplicationCheck') );
			add_action( 'plugins_loaded', array($this, 'splitCheck') );
			
			
		}
		
		
		
		
				
		public function duplicationCheck() {
			
			if (isset($_GET['clone']) && $_GET['clone'] == 'yes' && isset($_GET['_wpnonce'])){// && isset($_GET['clone-session']) && $_GET['clone-session'] == date('Ymhi')) {
				
				if ( is_user_logged_in() ) {
				
					if( current_user_can('manage_woocommerce') && wc_os_order_cloning()) {
				
						add_action('init', array($this, 'clone_order'));
						
					
					} else {
						
						wp_die(__('You do not have permission to complete this action.', 'woo-order-splitter'));
						
					}
					
				} else {
				
					wp_die(__('You have to be logged in to complete this action', 'woo-order-splitter'));
					
				}
				
			}
			
		}
		
		public function splitCheck($split='', $nonce='', $order_id=0, $quick_split=false) {
			
			
			$split = (isset($_GET['split'])?sanitize_wc_os_data($_GET['split']):$split);
			$nonce = (isset($_GET['_wpnonce'])?sanitize_wc_os_data($_GET['_wpnonce']):$nonce);
			$order_id = (isset($_GET['order_id'])?sanitize_wc_os_data($_GET['order_id']):$order_id);
			
			//pree($split);pree($nonce);pree($order_id);pree($quick_split);exit;
			
			if ($split == 'init' && $nonce){// && isset($_GET['split-session']) && $_GET['split-session'] == date('Ymhi')) {
				
				if ( is_user_logged_in() ) {
				
					if( current_user_can('manage_woocommerce') && wc_os_order_split()) {
						
						global $wc_os_settings;
						
						//wc_os_pree($wc_os_settings);exit;
						//pree($wc_os_settings['wc_os_ie']);exit;
						
						switch($wc_os_settings['wc_os_ie']){
							default:								

								$originalorderid = $order_id;
								//pree($originalorderid);
								$split_status = get_post_meta($originalorderid, 'split_status', true);
								if(!$split_status){
									update_post_meta($originalorderid, 'wc_os_order_splitter_cron', true);
								}
								//pree(get_post_meta($originalorderid, 'wc_os_order_splitter_cron', true));exit;
							break;
							case 'default':
								//wc_os_pree($order_id);
								
								
								//
								add_action('init', array($this, 'split_order'));
								
							break;								
						}
												
					
					} else {
						
						wp_die(__('You do not have permission to complete this action...', 'woo-order-splitter'));
						
					}
					
				} else {
				
					wp_die(__('You have to be logged in to complete this action', 'woo-order-splitter'));
					
				}
				
			}
			
		}	
		
		
		
		
		/**
		 * Create replicated order post and initiate cloned_order_data function.
		 */
	  
						
		public function clone_order($originalorderid = null, $force=false){
			//pree($this->cron_in_progress);exit;
			global $wc_os_shipping_cost;
			
			if($this->cron_in_progress && !$force){
				return false;
			}
			
			$_wos_cloned = get_post_meta($originalorderid, '_wos_cloned', true);
			
			if($_wos_cloned){
				return false;
			}
			//$currentUser = wp_get_current_user();
			
			$original_order = new WC_Order($originalorderid);
			
			$user_id = $original_order->get_user_id();
			
			$order_data =  array(
				'post_type'     => 'shop_order',
				'post_status'   => 'publish',
				'ping_status'   => 'closed',
				'post_author'   => $user_id,
				'post_password' => uniqid( 'order_' ),
			);
			//clone_order
			$order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
			
			//update_post_meta($order_id, 'testing_position', 'clone_order');
			//wc_os_pree('clone_order/order_id'. $order_id);
	
			if ( is_wp_error( $order_id ) ) {
				
				if(!$this->cron_in_progress)
				add_action( 'admin_notices', array($this, 'clone__error'));
			} else {
				$this->clone_in_progress = true;
				$this->force_clone_in_progress = true;
				
				$this->cloned_order_data($order_id, $originalorderid, true, false, true);//clone_order
				if($force){	
					update_post_meta($originalorderid, '_wos_cloned', true);
				}
			}
			
			return $order_id;
			
			
		}
		
		
		
		public function products_with_actions($filter=''){
			
			$ret = array();
			
			global $wc_os_settings;
			
			$wc_os_products = $wc_os_settings['wc_os_products'];
			
			if(!empty($wc_os_products)){
				$current_keys = array_keys($wc_os_products);
				if(is_numeric(current($current_keys))){
					if(!empty($wc_os_products)){
						foreach($wc_os_products as $product_id){
								if($filter=='' || ($filter!='' && $filter==$wc_os_settings['wc_os_ie'])){
									$ret[$product_id] = $wc_os_settings['wc_os_ie'];
								}
						}
					}					
				}else{
					if(!empty($wc_os_products)){
						foreach($wc_os_products as $action=>$products){
							
							/*wc_os_pree('$action');
							wc_os_pree($action);
							wc_os_pree('$products');
							wc_os_pree($products);*/
							
							foreach($products as $product_id){
								
								$product_id_arr = (is_array($product_id)?$product_id:array($product_id));
								
								foreach($product_id_arr as $product_id){
									if($filter=='' || ($filter!='' && $filter==$action)){
										$ret[$product_id] = $action;
									}
								}
							}
						}
					}					
				}
				
			}
			
			return $ret;
			
		}
		
		/*
			START - 
			07 January 2019
			Automatic Settings Added 
		*/
			
		public function split_order_logic($originalorderid = null, $wc_os_cart = false, $return_ids = false){
			
			
			
			//pree($wc_os_cart);
			
			global $woocommerce, $wc_os_settings, $wc_os_pro, $wc_os_debug, $wc_os_shipping_cost, $wc_os_effect_parent, $wc_os_general_settings, $wc_os_tax_cost;

			$wc_os_packages_overview = array_key_exists('wc_os_packages_overview', $wc_os_general_settings);
			$consider_action_for_all = false;
			$new_order_ids = array();
			$new_order_ids_qty = array();
			$order_id = 0;
			
			//pree($wc_os_packages_overview);
			
			//pree($wc_os_settings['wc_os_ie']);exit;
			//pree($originalorderid.' && '.$_GET['order_id'].' && '.$_GET['split'].' && '.$_GET['_wpnonce']);exit;
			//pree(is_numeric($this->auto_split));
			if($originalorderid==0 && isset($_GET['order_id']) && isset($_GET['split']) && $_GET['split'] == 'init' && isset($_GET['_wpnonce'])){
				$originalorderid = sanitize_wc_os_data($_GET['order_id']);
				$this->processing = false;								
			}
			$this->auto_split = $wc_os_settings['wc_os_ie'];
			//wc_os_pree($wc_os_settings['wc_os_ie']);exit;
			//wc_os_pree($this->auto_split);exit;
			//$currentUser = wp_get_current_user();
			//pre(get_post(10099));
			//pre(get_post($originalorderid));
			
			
			$split_status = ($originalorderid?get_post_meta($originalorderid, 'split_status', true):false);
			$_order_key = ($originalorderid?get_post_meta($originalorderid, '_order_key', true):false);
			
			$split_lock = (isset($wc_os_settings['wc_os_additional']['split_lock'])?$wc_os_settings['wc_os_additional']['split_lock']:array());
			$split_lock = is_array($split_lock)?$split_lock:array();
			
			
			//pree(($split_status?'split_status':'').' OR '.(!$_order_key?'!$_order_key':''));
			//wc_os_pree('split_order_logic-1');
			//wc_os_pre($split_status);//exit;
			if($split_status || (!$wc_os_cart && !$_order_key)){
				return false;
			}
			
			
			//wc_os_pree('split_order_logic-2');exit;
			//wc_os_pree($originalorderid);exit;
			//wc_os_pree($split_status);exit;
			//wc_os_pre($this->auto_split);
			//exit;
			
			$original_order = array();
			$user_id = is_user_logged_in()?get_current_user_id():0;
			if($originalorderid){
				$original_order = new WC_Order($originalorderid);
				$user_id = $original_order->get_user_id();
			}
			//wc_os_pre($original_order);
			//exit;
			//wc_os_pree($split_lock);
			//wc_os_pree($original_order->has_status($split_lock));
			//wc_os_pree($original_order->get_status());exit;
			
			
			$wc_os_order_statuses = wc_get_order_statuses(); 
			$wc_os_order_statuses_keys = array_keys($wc_os_order_statuses);		
			$wc_os_order_statuses_keys = array_unique($wc_os_order_statuses_keys);			
			

			$status_lock_released = empty($split_lock);
			
			//wc_os_logger('email', '$status_lock_released: '.$status_lock_released);
			
			if(!empty($split_lock) && !empty($original_order)){
				//wc_os_logger('email', '$split_lock: '.implode(' - ', $split_lock));
				foreach($split_lock as $split_lock_i){				
					if(!$status_lock_released){
						$status_lock_released = $original_order->has_status($split_lock_i);
					}
				}
			}			
			
			//wc_os_logger('email', '$status_lock_released: '.$status_lock_released);
						
			//pre($status_lock_released);
			//pre($original_order);
			if((empty($original_order) || !$status_lock_released) && !$wc_os_cart){
				return false;
			}
			//wc_os_pre($original_order);//exit;
			
			
			//wc_os_pree($original_order);//exit;
			
			$wc_os_all_products = (isset($wc_os_settings['wc_os_all_product']) && $wc_os_settings['wc_os_all_product']) ? true : false; //flag indicating to all products are subject to splitting
			$wc_os_products = $wc_os_settings['wc_os_products'];
			//pree($wc_os_products);
			$products_with_actions = $this->products_with_actions($this->auto_split);//23/10/2019 > from > $this->products_with_actions();
			//wc_os_pree($products_with_actions);exit;
			
			$wc_order_items = array();
			$wc_order_items_variations = array();
			$wc_order_items_qty_split = array();
			$wc_order_items_qty = array();
			$this->include_items_qty = array();
			//wc_os_pree('split_order_logic-2.1');exit;
			//pree($original_order->get_items());
			
			//pre('$original_order->get_items()');
			if(!empty($original_order) && empty($original_order->get_items()) && !$wc_os_cart){
				return false;
			}
			//wc_os_pre('split_order_logic-2.1');
			
			if(array_key_exists('wc_os_auto_clone', $wc_os_general_settings) && $originalorderid){
				
				//$this->clone_order($originalorderid, true);
					
				$cloned_order_id = $this->clone_order($originalorderid, true);
				
				
				if($cloned_order_id){
					$auto_cloned_status = wc_os_get_auto_clone_status();
					if($auto_cloned_status){
						wc_os_update_order_status($cloned_order_id, $auto_cloned_status);
					}
				}					
			
				//pree($originalorderid);
			}
			
			
			if(!empty($original_order)){
				foreach($original_order->get_items() as $item_id=>$item_data){
					//wc_os_pree($item_id);exit;
					//wc_os_pree($item_data->get_meta_data());
					//wc_os_pree($item_data);
					$formatted_meta_data = $item_data->get_formatted_meta_data();
					$formatted_meta_data = empty($formatted_meta_data)?$item_data->get_meta_data():$formatted_meta_data;
					//_reduced_stock
					//wc_os_pree($formatted_meta_data);//exit;
					//wc_os_pree($item_meta_data);
					$product_item_id = 0;
					
					//pree($item_data->get_variation_id());
					
					if($item_data->get_variation_id()){
						$product_item_id = $item_data->get_variation_id();
						$wc_order_items_variations[$item_data->get_product_id()][] = $item_data->get_variation_id();
					}else{
						$product_item_id = $item_data->get_product_id();
						$wc_order_items_variations[$item_data->get_product_id()][] = 0;
					}
					$wc_order_items[] = $product_item_id;
					$wc_order_items_qty_split[] = $item_data->get_product_id();
					
					$wc_order_items_qty[$product_item_id] = $item_data->get_quantity();
					
					//wc_os_pree($wc_order_items_qty);
					
					if(!empty($formatted_meta_data)){
						$formatted_meta_data = current($formatted_meta_data);
						$formatted_meta_data = (array)$formatted_meta_data;
						//wc_os_pree($formatted_meta_data);
						if(!empty($formatted_meta_data) && !array_key_exists('key', $formatted_meta_data)){
							$formatted_meta_data = current($formatted_meta_data);
						}
						//wc_os_pree($formatted_meta_data);	
						if(!empty($formatted_meta_data) && array_key_exists('key', $formatted_meta_data)){
								
							extract($formatted_meta_data);
							$key = strtolower($key);
							//$key = str_replace(array('*data', '*current_data'), 'key', $key);
							//wc_os_pree($key);
							
							switch($wc_os_settings['wc_os_ie']){
								
								default:
									switch($key){
										case 'backordered':
										case '_reduced_stock':
											//pree('backordered + _reduced_stock');
											//wc_os_pree($key);
											//wc_os_pree($value);	
											//$wc_order_items_qty[$item_data->get_product_id()] = 
											$this->include_items_qty[$product_item_id] = $value;
										break;							
										default:
											//pree('include_items_qty (backordered + _reduced_stock)');
											$this->include_items_qty[$product_item_id] = $wc_order_items_qty[$product_item_id];
										break;
									}
								break;
								
								case 'io':	
									$this->include_items_qty[$product_item_id] = $wc_order_items_qty[$product_item_id];
								break;
							}
								
						
						}
					}
					
					
					//wc_os_pree($item_data->get_product_id());
				}
			}elseif($wc_os_cart && !is_null($woocommerce->cart)){
				global $woocommerce;
				$items = $woocommerce->cart->get_cart();	
				foreach($items as $item => $values) { 
				
					
				
					$item_data = $values['data'];
					$product_attributes = ($item_data->get_attributes());
					$_product =  wc_get_product( $item_data->get_id()); 
					

					//pree($values['product_id'].' - '.$values['variation_id']);//exit;
					$product_item_id = 0;
					
					if($values['variation_id']){
						$product_item_id = $values['variation_id'];
						$wc_order_items_variations[$values['product_id']][] = $values['variation_id'];
					}else{
						$product_item_id = $values['product_id'];
						$wc_order_items_variations[$values['product_id']][] = 0;
					}
					$wc_order_items[$item] = $product_item_id;
					
					$wc_order_items_qty_split[$item] = $values['product_id'];					
					$wc_order_items_qty[$product_item_id] = $values['quantity'];					
					
					if(!empty($product_attributes) && is_array($product_attributes) && !is_object(current($product_attributes))){
						//pree($values['product_id'].' - '.$values['variation_id']);
						//pree($product_attributes);
					}				
					
					switch($wc_os_settings['wc_os_ie']){
						case 'io':
							$this->include_items_qty[$product_item_id] = $wc_order_items_qty[$product_item_id];
						break;
					}
					
				}	
				//pree($wc_order_items);
				//pree($wc_order_items_variations);
				//pree($wc_os_cart);exit;
			}
			
			//wc_os_pree('split_order_logic-2.2');exit;
			//exit;
			if($wc_os_debug)
			wc_os_pree($this->include_items_qty);
			//wc_os_pree($wc_order_items_qty);exit;
			
			//wc_os_pree($wc_os_all_products);exit;
			//pree($products_with_actions);
			//pree($wc_order_items);pree($products_with_actions);pree($wc_order_items_variations);exit;
			
			//pree($this->auto_split);exit;
			
			switch($this->auto_split){ //06/05/2019	
				case 'exclusive':
				case 'inclusive':
				case 'shredder':
					if(!empty($wc_order_items) && !empty($wc_order_items_variations)){
						//pree($wc_order_items);pree($wc_order_items_variations);
						foreach($wc_order_items_variations as $main_product_id=>$product_variations){
							foreach($wc_order_items as $possible_variation_id){
								if(in_array($possible_variation_id, $product_variations)){
									//pree($main_product_id.' - '.$possible_variation_id);
									if(array_key_exists($main_product_id, $products_with_actions)){
										$products_with_actions[$possible_variation_id] = $products_with_actions[$main_product_id];
									}
								}
							}
						}
					}
				break;
			}
	
			
			//pree($this->auto_split);
			//pree($products_with_actions);
			//exit;
			
			if($wc_os_all_products){
				$wc_order_items_diff = array();
				$wc_order_items_matched = $wc_order_items;
			}else{
				$wc_order_items_diff = array_diff($wc_order_items, array_keys($products_with_actions));
				$wc_order_items_diff = array_filter($wc_order_items_diff);
				
				//pree($wc_order_items_matched);
				$wc_order_items_matched = array_intersect(array_keys($products_with_actions), $wc_order_items);
				$wc_order_items_matched = array_filter($wc_order_items_matched);
				//pree($wc_order_items_matched);
				
			}
			//exit;
			//wc_os_pree($wc_os_settings['wc_os_ie']);exit;
			//wc_os_pree($wc_os_products);
			//wc_os_pree($wc_order_items);
			//wc_os_pree($products_with_actions);
			//wc_os_pree($wc_order_items_diff);
			//wc_os_pree($wc_order_items_matched);exit;
			
			
			
			
			
			if(!empty($wc_os_products) && !empty($wc_order_items_diff)){
				//echo ':)';
			}
			
			


			if(!empty($wc_order_items)){
				
				$wos_forced_ie = ($originalorderid?get_post_meta($originalorderid, 'wos_forced_ie', true):false);	
				
				//pree($wos_forced_ie);
				//pree($wc_os_settings['wc_os_ie']);
				//pree($wc_os_ie_selected);
				//pree($this->auto_split);exit;
				
				if($this->auto_split=='cats' || $this->auto_split=='group_cats'){			
					$wc_os_ie_selected = $this->auto_split;
				}else{
					//pree($this->auto_split);
					$actions_arr = array();
					if(!empty($wc_order_items_matched)){
						foreach($wc_order_items_matched as $matched_items){					
							if(array_key_exists($matched_items, $products_with_actions)){
								$actions_arr[] = $products_with_actions[$matched_items];
							}
						}
					}
					//pree($actions_arr);exit;
					//$actions_arr[] = 'exclusive';
					$actions_arr = array_unique($actions_arr);
					//pree($actions_arr);exit;
					$wc_os_ie_selected = $wc_os_settings['wc_os_ie'];
					//pree($wc_os_ie_selected);
					//echo $expected_orders;
					//wc_os_pree((count($wc_order_items) - count($wc_order_items_matched)));exit;
					if(count($actions_arr)==0){ //BACKWARDS COMPATIBILITY
						$consider_action_for_all = true;
					}elseif(count($actions_arr)==1){ //REGULAR/VALID/NORMAL CASE
						$wc_os_ie_selected = current($actions_arr);
					}elseif(count($actions_arr)>1){ //EXPECTED/INVALID/CONFLICT CASE
						if($wos_forced_ie){
							$wc_os_ie_selected = $wos_forced_ie;
						}else{
							//pree($actions_arr);
							//pree($wc_os_ie_selected);exit;
							switch($wc_os_ie_selected){
								case 'groups':
								break;
								default:
									
									if($originalorderid){								
										update_post_meta($originalorderid, 'conflict_status', true);
										update_post_meta($originalorderid, 'split_status', true);
										return;
									}
								break;
							}
						}
					}
					
				}
				
				
				$n_plus_1 = (count($wc_order_items) - count($wc_order_items_matched));
				
				//pre('auto_split: '.$this->auto_split);
				//pree('$wc_os_ie_selected: '.$wc_os_ie_selected);exit;
				
				//pree($wc_os_ie_selected);exit;
				//pree($wc_os_cart);exit;
				
				//pree($this->auto_split);exit;
				//if(get_current_user_id()==98){
					//pree($wc_os_ie_selected);
				//}
				
				//pre($this->auto_split);
				//pree($wc_os_ie_selected);exit;

				if($this->auto_split){
					switch($wc_os_ie_selected){ //06/05/2019
						default:
						case 'default':
							//wc_os_pree($order_id);
							//
							if($wc_os_cart){
								//if(get_current_user_id()==1){
									//wc_os_pree($wc_order_items);//exit;
								//}
								foreach($wc_order_items as $item_key=>$order_item){
									$new_order_ids[] = array($item_key=>$order_item);
								}
							}
							
						break;	
						case 'exclusive':
						
							//pree($this->auto_split.' - '.$wc_os_ie_selected.' - '.$wc_os_cart);exit;
						
							//wc_os_pree('exclusive1');
							//pree('$n_plus_1: '.$n_plus_1);
							//pree('count($wc_order_items): '.count($wc_order_items));
							//pree('$wc_order_items_matched:');
							//pree($wc_order_items_matched);exit;
							$wc_order_items_unique = array_unique($wc_order_items);
							//if(count($wc_order_items)<=1 || empty($wc_order_items_matched)){ //03/11/2020
							if(count($wc_order_items_unique)<=1 || empty($wc_order_items_matched)){	
								if($originalorderid){
									update_post_meta($originalorderid, 'split_status', true);
								}
								return;
							}
							//pree($wc_order_items);
							$this_include_items = array();

							$this->exclude_items = array();
							
							//wc_os_pree($wc_order_items_matched);
							
							$diff_array = array_diff($wc_order_items_unique, $wc_order_items_matched);
							//pree($diff_array);
						
							
							if(!empty($wc_order_items_matched)){
								
								foreach($wc_order_items_matched as $item){
									
									//wc_os_pree($item);
									
									$this->include_items = array();
									
									$this->include_items[] = $item;
									
									$this_include_items[] = $item;
									
									//wc_os_pree($this->include_items);//
									
									if($wc_os_cart){
										
										$new_order_ids[] = array($item);
										
									}else{
										
										$order_data =  array(
											'post_type'     => 'shop_order',
											'post_status'   => 'publish',
											'ping_status'   => 'closed',
											'post_author'   => $user_id,
											'post_password' => uniqid( 'order_' ),
										);
										//exclusive
										$order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
										//update_post_meta($order_id, 'testing_position', 'exclusive');
										//wc_os_pree('order_id:'.$order_id);
								
										if ( is_wp_error( $order_id ) ) {
											
											if(!$this->cron_in_progress)
											add_action( 'admin_notices', array($this, 'clone__error'));
										} else {
											$this->cloned_order_data($order_id, $originalorderid, true, false, $wc_os_shipping_cost);//split_order_logic	
											
											update_post_meta($order_id, 'split_status', true);
											
											$new_order_ids[] = $order_id;
										}	
											
									}
								}
								
								if($wc_os_cart){
									$new_order_ids[] = $diff_array;
								}
							}else{
								//wc_os_pree('exclusive3');
							}
							
							//pree($new_order_ids);							 
							 
							//if($wc_os_pro && class_exists('wc_os_bulk_order_splitter') && $wc_os_effect_parent){
							if($wc_os_effect_parent){
								
								if($originalorderid){
									$this->wos_remove_order_item($originalorderid, $this_include_items);
									//$classObj = new wc_os_bulk_order_splitter;
									//$classObj->wos_delete_order_item($originalorderid, $this_include_items);
								}
								
							}else{
							 
								if($n_plus_1){
									
									
									//exit;
									$this->exclude_items = array();
									$this->include_items = array();
									
									foreach($wc_order_items_matched as $item){
										$this->exclude_items[] = $item;
									}
									
									//wc_os_pree($this->exclude_items);//exit;
									
									if($wc_os_cart){
										
										$this_exclude_items = array();
										//pree($wc_order_items);
										foreach($wc_order_items as $item){
											
											if(!in_array($item, $wc_order_items_matched)){
												$this_exclude_items[] = $item;
											}
										}
										
										//$new_order_ids[] = $this_exclude_items;
										
									}else{
									
										$order_data =  array(
											'post_type'     => 'shop_order',
											'post_status'   => 'publish',
											'ping_status'   => 'closed',
											'post_author'   => $user_id,
											'post_password' => uniqid( 'order_' ),
										);
									
										$order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
										//update_post_meta($order_id, 'testing_position', 'exclusive2');
										//wc_os_pree($order_data);exit;
										
										//wc_os_pree('order_id:'.$order_id);
								
										if ( is_wp_error( $order_id ) ) {									
											
											
											
											if(!$this->cron_in_progress)
											add_action( 'admin_notices', array($this, 'clone__error'));
											
											
											
										} else {
											$this->cloned_order_data($order_id, $originalorderid, true, false, $wc_os_shipping_cost);//split_order_logic
											
											update_post_meta($order_id, 'split_status', true);
											
											$new_order_ids[] = $order_id;
										}	
									
									}
									
								}else{
									//wc_os_pree('exclusive2');
								}
								
							}
							
							//pree($new_order_ids);exit;
							

							
							//wc_os_pree('exclusive4');
							//wc_os_pree($this->include_items);exit;
							
						break;	
						case 'inclusive':
							//wc_os_pree('inclusive');exit;
							//pree($wc_order_items_matched);exit;
							if(count($wc_order_items)<=1 || empty($wc_order_items_matched)){
								if($originalorderid){
									update_post_meta($originalorderid, 'split_status', true);
								}
								return;
							}	

							$this->exclude_items = array();
							$this->include_items = array();
							
							if(!empty($wc_order_items_matched)){
								
								foreach($wc_order_items_matched as $item){
									
									$this->include_items[] = $item;
									
								}
								//pree($this->include_items);exit;
								if($wc_os_cart){
									
									$new_order_ids[] = $this->include_items;
									
								}else{
									
									$order_data =  array(
										'post_type'     => 'shop_order',
										'post_status'   => 'publish',
										'ping_status'   => 'closed',
										'post_author'   => $user_id,
										'post_password' => uniqid( 'order_' ),
									);
									//inclusive
									$order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
									//update_post_meta($order_id, 'testing_position', 'inclusive');
									//wc_os_pree('inclusive/order_id'. $order_id);
							
									if ( is_wp_error( $order_id ) ) {
										
										if(!$this->cron_in_progress)
										add_action( 'admin_notices', array($this, 'clone__error'));
									} else {
										$this->cloned_order_data($order_id, $originalorderid, true, false, $wc_os_shipping_cost);//split_order_logic		
										
										update_post_meta($order_id, 'split_status', true);
										
										$new_order_ids[] = $order_id;
										
									}	
									//pree($new_order_ids);//exit;
									
								}
							}
														
							
							//if($wc_os_pro && class_exists('wc_os_bulk_order_splitter') && $wc_os_effect_parent){
							//pree($wc_os_effect_parent.' - '.$n_plus_1);exit;
							if($wc_os_effect_parent){
								
								if($originalorderid){
									//$classObj = new wc_os_bulk_order_splitter;
									//$classObj->wos_delete_order_item($originalorderid, $this->include_items);
									$this->wos_remove_order_item($originalorderid, $this->include_items);
								}
								
								
							}else{
							 							
								if($n_plus_1){
									
									$this->exclude_items = array();
									$this->include_items = array();
									
									/*foreach($wc_order_items_matched as $item){
										$this->exclude_items[] = $item;
									}*/
									foreach($wc_order_items as $item){
										
										if(!in_array($item, $wc_order_items_matched)){
											$this->include_items[] = $item;
										}
									}
								
									if($wc_os_cart){
										
										$this_exclude_items = array();
										//pree($wc_order_items);
										foreach($wc_order_items as $item){
											
											if(!in_array($item, $wc_order_items_matched)){
												$this_exclude_items[] = $item;
											}
										}
										
										$new_order_ids[] = $this_exclude_items;
										
									}else{
										
										
										
										$order_data =  array(
											'post_type'     => 'shop_order',
											'post_status'   => 'publish',
											'ping_status'   => 'closed',
											'post_author'   => $user_id,
											'post_password' => uniqid( 'order_' ),
										);
									
										$order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
										//update_post_meta($order_id, 'testing_position', 'inclusive2');
										//wc_os_pree('inclusive/order_id'. $order_id);exit;
								
										if ( is_wp_error( $order_id ) ) {
											
											if(!$this->cron_in_progress)
											add_action( 'admin_notices', array($this, 'clone__error'));
										} else {
											$this->cloned_order_data($order_id, $originalorderid, true, false, $wc_os_shipping_cost);//split_order_logic		
											
											update_post_meta($order_id, 'split_status', true);
											
											$new_order_ids[] = $order_id;
										}	
									}
									//pree($new_order_ids);exit;
									
								}
								
							}
							
							

							

							//exit;
							
							
							
						break;	
						
						
						case 'shredder':
						
							
							//if(count($wc_order_items)<=1 || empty($wc_order_items_diff)){
								//update_post_meta($originalorderid, 'split_status', true);
								//return;
							//}		
							
												
							if($n_plus_1){
								
								$this->exclude_items = array();
								$this->include_items = array();
								
								foreach($wc_order_items_diff as $item){
									$this->exclude_items[] = $item;
								}
								
								//wc_os_pree($this->exclude_items);//exit;
								
								if($wc_os_cart){
									
									$this_exclude_items = array();
									
									foreach($wc_order_items as $item){
										if(!in_array($item, $wc_order_items_diff)){
											$this_exclude_items[] = $item;
										}
									}
									if(!empty($this_exclude_items)){
										$new_order_ids[] = $this_exclude_items;
									}
									
									//pree($new_order_ids);
									
									
								}elseif(!empty($this_exclude_items)){
								
									$order_data =  array(
										'post_type'     => 'shop_order',
										'post_status'   => 'publish',
										'ping_status'   => 'closed',
										'post_author'   => $user_id,
										'post_password' => uniqid( 'order_' ),
									);
								
									$order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
									//update_post_meta($order_id, 'testing_position', 'shredder2');
									//wc_os_pree('order_id:'.$order_id);
							
									if ( is_wp_error( $order_id ) ) {									
										if(!$this->cron_in_progress)
										add_action( 'admin_notices', array($this, 'clone__error'));
									} else {
										$this->cloned_order_data($order_id, $originalorderid, true, false, $wc_os_shipping_cost);//split_order_logic	
										
										update_post_meta($order_id, 'split_status', true);
										
										$new_order_ids[] = $order_id;	
									}	
									
								}
								
							}
						
						
							
							
								
							$this->exclude_items = array();
							$this_include_items = array();
							
							//wc_os_pree($wc_order_items_matched);
							
							//pree($wc_order_items_diff);
							
							foreach($wc_order_items_diff as $item){
								
								//wc_os_pree($item);
								
								$this->include_items = array();
								
								$this->include_items[] = $item;
								
								$this_include_items[] = $item;
								
								//wc_os_pree($this->include_items);//
								
								if($wc_os_cart){
									
									$new_order_ids[] = array($item);
									
								}else{ //other items > new order items for each item
									
									$order_data =  array(
										'post_type'     => 'shop_order',
										'post_status'   => 'publish',
										'ping_status'   => 'closed',
										'post_author'   => $user_id,
										'post_password' => uniqid( 'order_' ),
									);
								
									$order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
									//update_post_meta($order_id, 'testing_position', 'shredder');
									//wc_os_pree('order_id:'.$order_id);
							
									if ( is_wp_error( $order_id ) ) {
										
										if(!$this->cron_in_progress)
										add_action( 'admin_notices', array($this, 'clone__error'));
									} else {
										$this->cloned_order_data($order_id, $originalorderid, true, false, $wc_os_shipping_cost);//split_order_logic	
										
										update_post_meta($order_id, 'split_status', true);
										
										$new_order_ids[] = $order_id;
									}	
									
								}
																
							}
							
							if($originalorderid){
								

								
								if($wc_os_effect_parent){
                                    $this->wos_remove_order_item($originalorderid, $this_include_items);

								}else{

                                    if($n_plus_1){

                                        $this->exclude_items = array();
                                        $this->include_items = array();

                                        foreach($wc_order_items_matched as $item){
                                            //$this->exclude_items[] = $item;
											$this->include_items[] = $item;
                                        }

                                        if($wc_os_cart){

                                            $this_exclude_items = array();
                                            //pree($wc_order_items);
                                            foreach($wc_order_items as $item){

                                                if(!in_array($item, $wc_order_items_matched)){
                                                    $this_exclude_items[] = $item;
                                                }
                                            }

                                            $new_order_ids[] = $this_exclude_items;

                                        }elseif(!empty($this->include_items)){

                                            $order_data =  array(
                                                'post_type'     => 'shop_order',
                                                'post_status'   => 'publish',
                                                'ping_status'   => 'closed',
                                                'post_author'   => $user_id,
                                                'post_password' => uniqid( 'order_' ),
                                            );

                                            $order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
                                            //update_post_meta($order_id, 'testing_position', 'inclusive2');
                                            //wc_os_pree('inclusive/order_id'. $order_id);exit;

                                            if ( is_wp_error( $order_id ) ) {

                                                if(!$this->cron_in_progress)
                                                    add_action( 'admin_notices', array($this, 'clone__error'));
                                            } else {
                                                $this->cloned_order_data($order_id, $originalorderid, true, false, $wc_os_shipping_cost);//split_order_logic

                                                update_post_meta($order_id, 'split_status', true);

                                                $new_order_ids[] = $order_id;
                                            }
                                        }

                                    }

//									$this->wos_remove_order_item($originalorderid, $this_include_items);
								}
								
							
								
							}
														
							
						break;		
						
						
						case 'io':
							
							if($wc_os_pro && class_exists('wc_os_bulk_order_splitter')){
								
								//global $wpdb;
								
								$classObj = new wc_os_bulk_order_splitter;
								
								//pree($wc_order_items);
								$items_io = $classObj->separate_io_items($wc_order_items, $this->include_items_qty, $wc_os_cart);

								//pree($items_io, 3);exit;
								
								$this->exclude_items = array();
								$this->include_items = array();
								$backorder_only = array();
								
								$save_quantity = $this->include_items_qty;
														

								// || $consider_action_for_all
								
								if(($items_io['in_stock'] && !empty($items_io['in_stock']))){ //create order of in-stock items
									
									//set items to include in order
									$this->include_items = $items_io['in_stock']['items'];
									
									//set quantities for items
									$this->include_items_qty = $items_io['in_stock']['quantity'];
									
									//pree($this->include_items);pree($this->include_items_qty);exit;
									
									if($wc_os_cart){
										
										if(!empty($this->include_items_qty) && !empty($this->include_items)){
											$this->include_items = array();
											foreach($this->include_items_qty as $include_item=>$include_item_qty){
												if($include_item_qty>0){
													$this->include_items[] = array('product_id'=>$include_item, 'quantity'=>$include_item_qty);
												}
											}
										}
										
										$new_order_ids['in_stock'] = $this->include_items;
										
									}elseif($originalorderid){
										
										if($wc_os_effect_parent){
											$classObj->wos_update_order_item($originalorderid, $this->include_items, $this->include_items_qty);
										}else{
                                            if($items_io['in_stock'] && !empty($items_io['in_stock'])){
												
                                                $split_status_value = wc_os_order_split_status_action();

												//set items to include in order
												$this->include_items = $items_io['in_stock']['items'];

												//set quantities for items
												$this->include_items_qty = $items_io['in_stock']['quantity'];

												//create post order data
												
												//pree($this->include_items);pree($this->include_items_qty);exit;


                                                $order_data =  array(
                                                    'post_type'     => 'shop_order',
                                                    'post_status'   => 'publish',
                                                    'ping_status'   => 'closed',
                                                    'post_author'   => $user_id,
                                                    'post_password' => uniqid( 'order_' ),
                                                );

                                                //save order to database
                                                if(!$wc_os_debug)
                                                    $order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
                                                //update_post_meta($order_id, 'testing_position', 'io+backorder');

                                                if ( is_wp_error( $order_id ) ) {

                                                    if(!$this->cron_in_progress)
                                                        add_action( 'admin_notices', array($this, 'clone__error'));
                                                } else { //add data to new post
                                                    if(!$wc_os_debug) //save order
                                                        $this->cloned_order_data($order_id, $originalorderid, true, false, $wc_os_shipping_cost);//split_order_logic

                                                    update_post_meta($order_id, 'split_status', true);
                                                    update_post_meta($order_id, '_wos_in_stock', true);

                                                    $new_order_ids['in_stock'] = $order_id;

                                                    $outofstock_order = wc_get_order( $order_id );
                                                    if($split_status_value){
                                                        //wp_update_post(array('ID'=>$order_id, 'post_status'=>$split_status_value));
														wc_os_set_order_status($order_id, $split_status_value);
														//update_wcfm_order_status($order_id, $split_status_value);
                                                    }else{
                                                        //$outofstock_order->update_status('on-hold');
                                                       // wp_update_post(array('ID'=>$order_id, 'post_status'=>'wc-on-hold'));
														wc_os_set_order_status($order_id, 'wc-on-hold');
														//update_wcfm_order_status($order_id, 'wc-on-hold');
                                                    }
                                                }	
												
											}
										}
										
									}
									
									
									
									if(isset($items_io['backorder'])){
										$backorder_items = (isset($items_io['backorder']['items'])?$items_io['backorder']['items']:array());
										$backorder_only = array_diff($backorder_items, $items_io['in_stock']['items']);
									}
									
									//pree($backorder_only);exit;

									
								}
								//pree($items_io['backorder']);
								//pree($items_io);
								//exit;
				
								if($items_io['backorder'] && !empty($items_io['backorder'])) //create order of backorder items
								{
									$split_status_value = wc_os_order_split_status_action();
									
									if($items_io['backorder_split_required']){
										//set items to include in order
										$this->include_items = $items_io['backorder']['items'];
										
										//set quantities for items
										$this->include_items_qty = $items_io['backorder']['quantity'];
										
										//pree($this->include_items);pree($this->include_items_qty);exit;
										
										//create post order data
										
										if($wc_os_cart){
											//pree($this->include_items);
											//$this->include_items[0] = array('product_id'=>17,'quantity'=>45);
											//pree($this->include_items_qty);
											if(!empty($this->include_items_qty) && !empty($this->include_items)){
												$this->include_items = array();
												foreach($this->include_items_qty as $include_item=>$include_item_qty){
													if($include_item_qty>0){
														$this->include_items[] = array('product_id'=>$include_item, 'quantity'=>$include_item_qty);
													}
												}
											}
											
											$new_order_ids['out_stock'] = $this->include_items;
										
										}else{
										
											$order_data =  array(
												'post_type'     => 'shop_order',
												'post_status'   => 'publish',
												'ping_status'   => 'closed',
												'post_author'   => $user_id,
												'post_password' => uniqid( 'order_' ),
											);
											
											//save order to database
											if(!$wc_os_debug){
												$order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
											}
											//update_post_meta($order_id, 'testing_position', 'io+backorder');
											
											if ( is_wp_error( $order_id ) ) {
											
												if(!$this->cron_in_progress)
												add_action( 'admin_notices', array($this, 'clone__error'));
											} else { //add data to new post
												if(!$wc_os_debug) //save order
												$this->cloned_order_data($order_id, $originalorderid, true, false, $wc_os_shipping_cost);//split_order_logic
												
												
												
												update_post_meta($order_id, 'split_status', true);
												update_post_meta($order_id, '_wos_out_of_stock', true);
												
												
												
												
												$new_order_ids['out_stock'] = $order_id;
												
												$outofstock_order = wc_get_order( $order_id );
												if($split_status_value){
													//wp_update_post(array('ID'=>$order_id, 'post_status'=>$split_status_value));
													wc_os_set_order_status($order_id, $split_status_value);
													//update_wcfm_order_status($order_id, $split_status_value);
												}else{
													//$outofstock_order->update_status('on-hold');
													//wp_update_post(array('ID'=>$order_id, 'post_status'=>'wc-on-hold'));
													wc_os_set_order_status($order_id, 'wc-on-hold');
													//update_wcfm_order_status($order_id, 'wc-on-hold');
												}
											}
											
										}
									}else{
										
										if($originalorderid){
											update_post_meta($originalorderid, '_wos_out_of_stock', true);
											//$original_order->update_status('on-hold');
											//wp_update_post(array('ID'=>$order_id, 'post_status'=>'wc-on-hold'));
											
											wc_os_set_order_status($order_id, 'wc-on-hold');
											//update_wcfm_order_status($order_id, 'wc-on-hold');
											
										}
									}
								}
								
									
								//exit;							
				
								//restore saved quantity
								$this->include_items_qty = $save_quantity;								
								

								if($originalorderid){
									if(!empty($backorder_only)){
										if($wc_os_effect_parent){
										    $classObj->wos_delete_order_item($originalorderid, $backorder_only);
									    }else{


                                            if($items_io['in_stock'] && !empty($items_io['in_stock'])) //create order of backorder items
                                            {
                                                $split_status_value = wc_os_order_split_status_action();

												//set items to include in order
												$this->include_items = $items_io['in_stock']['items'];

												//set quantities for items
												$this->include_items_qty = $items_io['in_stock']['quantity'];

												//create post order data
												
												//pree($this->include_items);pree($this->include_items_qty);exit;


                                                $order_data =  array(
                                                    'post_type'     => 'shop_order',
                                                    'post_status'   => 'publish',
                                                    'ping_status'   => 'closed',
                                                    'post_author'   => $user_id,
                                                    'post_password' => uniqid( 'order_' ),
                                                );

                                                //save order to database
                                                if(!$wc_os_debug)
                                                    $order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
                                                //update_post_meta($order_id, 'testing_position', 'io+backorder');

                                                if ( is_wp_error( $order_id ) ) {

                                                    if(!$this->cron_in_progress)
                                                        add_action( 'admin_notices', array($this, 'clone__error'));
                                                } else { //add data to new post
                                                    if(!$wc_os_debug) //save order
                                                        $this->cloned_order_data($order_id, $originalorderid, true, false, $wc_os_shipping_cost);//split_order_logic

                                                    update_post_meta($order_id, 'split_status', true);
                                                    update_post_meta($order_id, '_wos_in_stock', true);

                                                    $new_order_ids['in_stock'] = $order_id;

                                                    $outofstock_order = wc_get_order( $order_id );
                                                    if($split_status_value){
                                                        //wp_update_post(array('ID'=>$order_id, 'post_status'=>$split_status_value));
														wc_os_set_order_status($order_id, $split_status_value);
														//update_wcfm_order_status($order_id, $split_status_value);
                                                    }else{
                                                        //$outofstock_order->update_status('on-hold');
                                                        //wp_update_post(array('ID'=>$order_id, 'post_status'=>'wc-on-hold'));
														wc_os_set_order_status($order_id, 'wc-on-hold');
														//update_wcfm_order_status($order_id, 'wc-on-hold');
                                                    }
                                                }


                                            }



                                        }
									}
									update_post_meta($originalorderid, '_wos_calculate_totals', true);
									
								}
							
							
							}
						break;

						case 'quantity_split':


							if(!$wc_os_pro){ return; }


							$qty_split_option = (in_array($wc_os_settings['wc_os_qty_split_option'], array('custom', 'default', 'eric_logic'))?$wc_os_settings['wc_os_qty_split_option']:'custom');//$consider_action_for_all < 12/05/2020
						
							//pree($qty_split_option);exit;


							if($wc_os_all_products){

								$wc_order_items_matched = $wc_order_items_qty_split;

							}else{

								$wc_order_items_matched = array_intersect(array_keys($products_with_actions), $wc_order_items_qty_split);
								$wc_order_items_matched = array_filter($wc_order_items_matched);
							}




							if($wc_os_pro && class_exists('wc_os_bulk_order_splitter')){

								$classObj = new wc_os_bulk_order_splitter;



								$qty_split_group = array('parent_group'=>array(), 'child_group'=>array());
								
								
								
								if($wc_os_cart){
																		
									if (!empty($wc_order_items_matched)) {
										foreach($wc_order_items_matched as $matched_item) {
									
											if (array_key_exists($matched_item, $wc_order_items_qty)) {
									
												$items_qty = $wc_order_items_qty[$matched_item];
									
												switch ($qty_split_option) {
													default:
													case 'default':
									
														for ($i = 1; $i <= $items_qty; $i++) {
															$new_order_ids[] = array($matched_item);
															$new_order_ids_qty[] = array($matched_item => 1);
														}
									
														break;
													case 'custom':
													case 'eric_logic':
									
														break;
												}
											}
										}
									
										if (!empty($wc_order_items_diff)) {
									
											$new_order_ids[] = $wc_order_items_diff;
									
										}
									
									}
									elseif(!empty($wc_order_items_diff)) {
									
										foreach($wc_order_items_diff as $dif_item) {
									
											if (array_key_exists($dif_item, $wc_order_items_qty)) {
									
												$items_qty = $wc_order_items_qty[$dif_item];
									
												switch ($qty_split_option) {
													default:
													case 'default':
									
														for ($i = 1; $i <= $items_qty; $i++) {
															$new_order_ids[] = array($dif_item);
														}
									
														break;
													case 'custom':
													case 'eric_logic':
									
														break;
												}
											}
										}
									
									
									}
									
						
									
								}else{
									
									//pree($consider_action_for_all);
									//pree(count($original_order->get_items()));exit;
									foreach($original_order->get_items() as $item_key=>$item_values){
	
										$order_item_id = $item_values->get_id();
										$order_item_total = $item_values->get_total();

	
	
										$pid = $item_values->get_product_id();
										$vid = $item_values->get_variation_id();
										$product_item = $vid?$vid:$pid;
	
										$order_id_new = 0;
										if(($item_values->get_product_id() && (in_array($item_values->get_product_id(), $wc_order_items_matched)) || $consider_action_for_all)){ //$consider_action_for_all < 23/10/2019
	
											$qty = $item_values->get_quantity();
											$qty_split_arr = $classObj->get_qty_split_arr($qty_split_option, $item_key, $qty);
											
											//pree($qty_split_arr);//continue;

											switch($qty_split_option){
												case 'custom':
													if(empty($qty_split_arr)){ continue 2; }
												break;
											}
	
											$item = $item_values->get_data();
											$product_id = $item['product_id'];
											$variation_id = $item['variation_id'];
	
											if ($variation_id != 0) {
												$product = new WC_Product_Variation($variation_id);
	
											} else {
												$product = new WC_Product($product_id);
											}
											
											//pree($product->get_id().' - '.$item_values['total'].' == '.$product->get_price());exit;
	
	
											//if($item_values['total']==$product->get_price()){
												//$unit_price = $product->get_price();
											//}else{
												$unit_price = ($item_values['total']/$qty); //06 March 2019 - with Sean Owen
											//}
											//11 May 2021 - with Bertjan Hopster to resolve wholesale price thing woocommerce-wholesale-prices-premium
											
											//pree($product->get_id().' - '.$item_values['total'].' / '.$qty.' = '.($item_values['total']/$qty));exit;
	
											$order_data = array(
												'post_type' => 'shop_order',
												'post_status' => 'publish',
												'ping_status' => 'closed',
												'post_author' => $user_id,
												'post_password' => uniqid( 'order_' ),
											);
	
	
											$wc_pos_order_type = get_post_meta($originalorderid, 'wc_pos_order_type', true);
											$wc_pos_order_type = ($wc_pos_order_type?$wc_pos_order_type:'online');
											
											//pree($qty_split_option);exit;
	

											switch($qty_split_option){
												case 'custom':
												case 'eric_logic':
											

		
													if(empty($qty_split_arr)){
														
														//$qty_split_group['parent_group'][$product_item] = array('qty'=>array($qty), 'item_key'=>$item_key, 'item_values'=>$item_values, 'product'=>$product);
														
													}else{
														
														//pree(count($qty_split_arr));continue;
		
														if(count($qty_split_arr)==1){
															$qty_split_group['child_group'][$product_item] = array('qty'=>$qty_split_arr, 'item_key'=>$item_key, 'item_values'=>$item_values, 'product'=>$product);
															$remaining = ($qty - array_sum($qty_split_arr));
															if($remaining>0){
																$qty_split_group['parent_group'][$product_item] = array('qty'=>array($remaining), 'item_key'=>$item_key, 'item_values'=>$item_values, 'product'=>$product);
															}
														}elseif(count($qty_split_arr)>1){
															$iter = 0;
															//pree($qty_split_arr);
															foreach($qty_split_arr as $split_figure){ $iter++;
															
																//$item_values = $product = array(); 

																if($iter==1){
																	$qty_split_group['parent_group'][$product_item] = array('qty'=>array($split_figure), 'item_key'=>$item_key, 'item_values'=>$item_values, 'product'=>$product);
																}else{
																	$qty_split_group['child_group'][$product_item][] = array('qty'=>array($split_figure), 'item_key'=>$item_key, 'item_values'=>$item_values, 'product'=>$product);
																}
																
																//pree($product_item.' - '.$split_figure);continue;
															}
														}
		
		
													}
	
	
												break;
												default:
	
	
												if($qty<=1 && count($original_order->get_items())==1){ //22/08/2019 - Added this condition while talking to Paul Rodarte
													continue 2;
												}
	
	

												if(!empty($qty_split_arr)){
	
													foreach($qty_split_arr as $qty_split){
	

														$order_id_new = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );

														update_post_meta($order_id_new, 'wc_pos_order_type', sanitize_wc_os_data($wc_pos_order_type)); // NO QTY. SPLIT
														update_post_meta($order_id_new, 'qty_splitted', true);
	
														if ( is_wp_error( $order_id_new ) ) {
	
															if(!$this->cron_in_progress)
																add_action( 'admin_notices', array($this, 'split__error'));
														} else {															

															$this->splitted_order_data($order_id_new, $originalorderid, $product_id, $variation_id, $qty_split, $unit_price);
	
	
															$valid_process = true;
	
															if(method_exists($this, 'ywpo_add_order_item_meta')){
																$this->ywpo_add_order_item_meta($item_key, $product);
															}
														}
	
	//}
													}
												}else{
	
													for($q=1; $q<=$qty; $q++){
	
														$order_id_new = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );

	
														update_post_meta($order_id_new, 'wc_pos_order_type', sanitize_wc_os_data($wc_pos_order_type)); // YES QTY. SPLIT
														update_post_meta($order_id_new, 'qty_splitted', true);
	
														if ( is_wp_error( $order_id_new ) ) {
	
															if(!$this->cron_in_progress)
																add_action( 'admin_notices', array($this, 'split__error'));
														} else {

															
															$this->splitted_order_data($order_id_new, $originalorderid, $product_id, $variation_id, 1, $unit_price, false, $order_item_id);

															$valid_process = true;
	
															if(method_exists($this, 'ywpo_add_order_item_meta')){
																$this->ywpo_add_order_item_meta($item_key, $product);
															}
														}
	
	
														$new_order_ids[] = $order_id_new;
			
	
													}
	
												
	
												}
												
												break;
	
											}
											
											//pree($order_id_new);exit;
	
	
											if($order_id_new){
												
												if(!in_array($order_id_new, $new_order_ids)){
													$new_order_ids[] = $order_id_new;
												}
	
												$classObj->wos_delete_order_item($originalorderid, array($item_values->get_product_id())); //REMOVING SPLITTED ITEMS FROM ORIGINAL ORDER 19/10/2019
												$order_data_updated = wc_get_order( $originalorderid );
												$order_data_updated->calculate_totals();
												delete_post_meta($order_id_new, 'wc_os_order_splitter_cron'); //in case this meta_key was inherited from parent order
												update_post_meta($order_id_new, 'split_status', true); //23/10/2109 so no further split
	
											}
										}
										
										
									}
									
								
								}
								//exit;
								if(!is_admin()){

								}

								if($wc_os_cart){
								}else{
									if(!empty($qty_split_group)){
										//pree($qty_split_group);exit;
										
										$parent_group = $qty_split_group['parent_group'];
										
										if(!empty($parent_group)){
											
											//MOVED INSIDE CONDITION ON BUG REPORTED BY "ryonwhyte" ON 22/11/2019
											$new_order_ids = $classObj->split_order_by_qty_split_groups($qty_split_group, $originalorderid, $order_data);
											//pree($new_order_ids);exit;
											
											$modify_original_order = wc_get_order($originalorderid);
											//pree('ORDER: '.$modify_original_order->get_id());
											foreach($modify_original_order->get_items() as $cart_item_key=>$cart_item_data){
												$pid = $cart_item_data->get_product_id();
												$vid = $cart_item_data->get_variation_id();	
												$product_item = $vid?$vid:$pid;											
												//pree($cart_item_data['total'].' - '.$cart_item_data['quantity']);
												if(array_key_exists($product_item, $parent_group)){
													$group_item_data = $parent_group[$product_item];
													$product = $group_item_data['product'];
													//pree($group_item_data);
													//pree('Before: '.$cart_item_data['quantity']);
													$cart_item_data['quantity'] = array_sum($group_item_data['qty']); //uncommented on 03/06/2021 - Bhupinder Gill
													//pree('After: '.$cart_item_data['quantity']);
													//$unit_price = $product->get_price();
													$unit_price = ($cart_item_data['total']/$cart_item_data['quantity']);
													//11 May 2021 - with Bertjan Hopster to resolve wholesale price thing woocommerce-wholesale-prices-premium
													//pree($product_item.' - '.$unit_price);exit;
													$cart_item_data['subtotal'] = $unit_price*$cart_item_data['quantity'];
													$cart_item_data['total'] = $cart_item_data['subtotal'];
													
													//pree($cart_item_data['quantity']);
													$modify_original_order->save();
												}
											}
											//$modify_original_order->calculate_totals();
											//update_post_meta($originalorderid, '_wos_calculate_totals', true);
										}
										
									}
								}
								
								//pree($qty_split_group);
								//exit;
								
								
								if($originalorderid){
									
									$order_data_check = wc_get_order( $originalorderid );
									$order_data_check->calculate_totals();
									if(count($order_data_check->get_items())<1){
										wos_clone_order_notes($originalorderid, $new_order_ids);
										if(wc_os_order_removal()){
											wc_os_trash_post($originalorderid);
										}
									}
								}
								
							}
							if(!is_admin()){
								//exit;
							}
							//pree($new_order_ids);exit;
				
							
						break;	
						case 'subscription_split':

							if(!$wc_os_pro){ return; }
							
							$qty_split_option = 'default';
							
							
							if($wc_os_all_products){

								$wc_order_items_matched = $wc_order_items_qty_split;

							}else{

								$wc_order_items_matched = array_intersect(array_keys($products_with_actions), $wc_order_items_qty_split);
								$wc_order_items_matched = array_filter($wc_order_items_matched);
							}
							
							
							//$wc_os_logger_str = 'subscription_split > '.date('d M, Y H:i:s A').' IS CART '.($wc_os_cart?'YES':'NO');
							//wc_os_logger('email', $wc_os_logger_str);
							
							//pree($wc_order_items_matched);exit;



							if($wc_os_pro && class_exists('wc_os_bulk_order_splitter')){

								$classObj = new wc_os_bulk_order_splitter;
								$qty_split_group = array('parent_group'=>array(), 'child_group'=>array());
								
								if($wc_os_cart){
																		
									if (!empty($wc_order_items_matched)) {
										foreach($wc_order_items_matched as $matched_item) {
									
											if (array_key_exists($matched_item, $wc_order_items_qty)) {
									
												$items_qty = $wc_order_items_qty[$matched_item];

												for ($i = 1; $i <= $items_qty; $i++) {
													$new_order_ids[] = array($matched_item);
													$new_order_ids_qty[] = array($matched_item => 1);
												}

											}
										}
									
										if (!empty($wc_order_items_diff)) {
									
											$new_order_ids[] = $wc_order_items_diff;
									
										}
									
									}
									elseif(!empty($wc_order_items_diff)) {
									
										foreach($wc_order_items_diff as $dif_item) {
									
											if (array_key_exists($dif_item, $wc_order_items_qty)) {
									
												$items_qty = $wc_order_items_qty[$dif_item];
												for ($i = 1; $i <= $items_qty; $i++) {
													$new_order_ids[] = array($dif_item);
												}

											}
										}
									
									
									}
									
						
									
								}else{
									//pree($original_order->get_items());exit;
									//pree($consider_action_for_all);exit;
									
									foreach($original_order->get_items() as $item_key=>$item_values){
	
										$order_item_id = $item_values->get_id();
										$order_item_total = $item_values->get_total();
	
										$pid = $item_values->get_product_id();
										$vid = $item_values->get_variation_id();
										$product_item = $vid?$vid:$pid;
	
										$order_id_new = 0;
										if($item_values->get_product_id() && (in_array($item_values->get_product_id(), $wc_order_items_matched) || $consider_action_for_all)){ //$consider_action_for_all < 23/10/2019
	
											$qty = $item_values->get_quantity();
											//pree($qty_split_option);pree($item_key);pree($qty);exit;
											$qty_split_arr = $classObj->get_qty_split_arr($qty_split_option, $item_key, $qty);
											
											
												
											$item = $item_values->get_data();
											$product_id = $item['product_id'];
											$variation_id = $item['variation_id'];
	
											if ($variation_id != 0) {
												$product = new WC_Product_Variation($variation_id);
	
											} else {
												$product = new WC_Product($product_id);
											}
	
	
											if($item_values['total']==$product->get_price()){
												$unit_price = $product->get_price();
											}else{
												$unit_price = ($item_values['total']/$qty); //06 March 2019 - with Sean Owen
											}
											//$unit_price = 0;
	
											$order_data = array(
												'post_type' => 'shop_order',
												'post_status' => 'publish',
												'ping_status' => 'closed',
												'post_author' => $user_id,
												'post_password' => uniqid( 'order_' ),
											);
	
	
											$wc_pos_order_type = get_post_meta($originalorderid, 'wc_pos_order_type', true);
											$wc_pos_order_type = ($wc_pos_order_type?$wc_pos_order_type:'online');
											
											//pree($qty_split_option);exit;
											//pree($qty_split_arr);exit;
	
											switch($qty_split_option){
												
												default:
	
	
												if($qty<=1 && count($original_order->get_items())==1){ //22/08/2019 - Added this condition while talking to Paul Rodarte
													continue 2;
												}
												
												//pree($qty_split_arr);exit;
	
	

												if(!empty($qty_split_arr)){
	
													foreach($qty_split_arr as $qty_split){
	

														$order_id_new = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
														update_post_meta($order_id_new, 'wc_pos_order_type', sanitize_wc_os_data($wc_pos_order_type)); // NO QTY. SPLIT
														update_post_meta($order_id_new, 'qty_splitted', true);
	
														if ( is_wp_error( $order_id_new ) ) {
	
															if(!$this->cron_in_progress)
																add_action( 'admin_notices', array($this, 'split__error'));
														} else {
															$this->splitted_order_data($order_id_new, $originalorderid, $product_id, $variation_id, $qty_split, $unit_price);
	
	
															$valid_process = true;
	
															if(method_exists($this, 'ywpo_add_order_item_meta')){
																$this->ywpo_add_order_item_meta($item_key, $product);
															}
															
															$new_order_ids[] = $order_id_new;

															delete_post_meta($order_id_new, 'wc_os_order_splitter_cron'); //in case this meta_key was inherited from parent order
															update_post_meta($order_id_new, 'split_status', true); //23/10/2109 so no further split															
															
														}
														
														
	
													}
												}else{
													
													//pree($qty);exit;
	
													for($q=1; $q<=$qty; $q++){
	
														$order_id_new = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
	
														update_post_meta($order_id_new, 'wc_pos_order_type', sanitize_wc_os_data($wc_pos_order_type)); // YES QTY. SPLIT
														update_post_meta($order_id_new, 'qty_splitted', true);
	
														if ( is_wp_error( $order_id_new ) ) {
	
															if(!$this->cron_in_progress)
																add_action( 'admin_notices', array($this, 'split__error'));
														} else {
															
															//wc_os_logger('email', '$this->splitted_order_data > #'.$order_id_new.' < #'.$originalorderid);
															$this->splitted_order_data($order_id_new, $originalorderid, $product_id, $variation_id, 1, $unit_price, false, $order_item_id);
	
	
															$valid_process = true;
	
															if(method_exists($this, 'ywpo_add_order_item_meta')){
																$this->ywpo_add_order_item_meta($item_key, $product);
															}
															
															$new_order_ids[] = $order_id_new;
															
															delete_post_meta($order_id_new, 'wc_os_order_splitter_cron'); //in case this meta_key was inherited from parent order
															update_post_meta($order_id_new, 'split_status', true); //23/10/2109 so no further split															
														}
	
	

														//wc_os_logger('email', '#'.$order_id_new.' < #'.$originalorderid);
	
													}
	
												
	
												}
												
												break;
	
											}
	
	
											//if($order_id_new){
												
											//	if(!in_array($order_id_new, $new_order_ids)){
											//		$new_order_ids[] = $order_id_new;
											//	}
	
											//	$classObj->wos_delete_order_item($originalorderid, array($item_values->get_product_id())); //REMOVING SPLITTED ITEMS FROM ORIGINAL ORDER 19/10/2019
											//	$order_data_updated = wc_get_order( $originalorderid );
											//	$order_data_updated->calculate_totals();
												
	
											//}
											
											//pree($new_order_ids);exit;
										}
									}
								
								}
								//exit;
								//pree($new_order_ids);
								
								if($originalorderid){
									
									$order_data_check = wc_get_order( $originalorderid );
									$order_data_check->calculate_totals();
									if(count($order_data_check->get_items())<1){
										wos_clone_order_notes($originalorderid, $new_order_ids);
										if(wc_os_order_removal()){
											wc_os_trash_post($originalorderid);
										}
									}
								}
								
							}
				
							
						break;
						case 'cats':
						
							if(!$wc_os_pro){ return; }
							if($wc_os_pro && class_exists('wc_os_bulk_order_splitter')){
								
								$classObj = new wc_os_bulk_order_splitter;
								
								if(!$wc_os_cart){
									$new_order_ids = $classObj->split_order_by_category_qty($original_order->get_items(), $originalorderid, $user_id, $wc_os_cart, $split_status);
								}else{
									//pree($wc_order_items);
									//pree($originalorderid);
									//pree($user_id);
									//pree($wc_os_cart);
									$new_order_ids = $classObj->split_order_by_category_qty($wc_order_items, $originalorderid, $user_id, $wc_os_cart);
									//pree($new_order_ids);
								}
								
							}
							
							
						break;										
						case 'cats_only':			
						
							if(!$wc_os_pro){ return; }
							
							
							if($wc_os_pro && class_exists('wc_os_bulk_order_splitter')){
								
								$classObj = new wc_os_bulk_order_splitter;
								
								$wos_forced_ie = get_post_meta($originalorderid, 'wos_forced_ie', true);
								$wos_delete_order = get_post_meta($originalorderid, 'wos_delete_order', true);
								
								if($wos_forced_ie && $wos_delete_order){
									//pree($originalorderid);
									//pree($wc_os_ie_selected);
									//wc_os_pree($this->auto_split);//exit;
									//wc_os_pree($wc_os_settings['wc_os_ie']);
									$wc_os_ie_selected = $wos_forced_ie;
									//delete_post_meta($originalorderid, 'wos_forced_ie');
									//pree($wc_os_ie_selected);exit;
									//pree($n_plus_1);
									
									$new_order_ids = $classObj->split_order_by_category($wos_forced_ie, $wc_order_items, $originalorderid, $user_id);
									
									if(!empty($new_order_ids)){
										$original_cloned_from = get_post_meta($originalorderid, 'cloned_from', true);
										$original_splitted_from = get_post_meta($originalorderid, 'splitted_from', true);
										foreach($new_order_ids as $new_ordder_id){
											update_post_meta($new_ordder_id, 'cloned_from', $original_cloned_from);
											update_post_meta($new_ordder_id, 'splitted_from', $original_splitted_from);
											delete_post_meta($new_ordder_id, 'wos_delete_order');
											delete_post_meta($new_ordder_id, 'wos_forced_ie');
										}
										//delete_post_meta($originalorderid, 'wos_delete_order');								
										//wc_os_trash_post($originalorderid);
										$originalorderid = $original_cloned_from;
									}
									
	
									
								}else{			
								
									$wc_os_cats = $wc_os_settings['wc_os_cats'];
									$wc_os_cats_arr = array();
									foreach($wc_os_cats as $item_group=>$cat_items){								
										foreach($cat_items as $cat_item){
											$wc_os_cats_arr[$cat_item] = $item_group;
										}
									} 
									//pree($wc_os_cats_arr);
								
									$category_arr = array();
									foreach($wc_order_items as $item){
										
										$product_cats = get_the_terms ( $item, 'product_cat' );								
										foreach($product_cats as $product_cat){
											$category_arr[$product_cat->term_id][] = $item;
										}
									}
									
									
									
									if(!empty($category_arr)){
										foreach($category_arr as $cat_group=>$items_arr){
											
											$order_split_action = (array_key_exists($cat_group, $wc_os_cats_arr)?$wc_os_cats_arr[$cat_group]:'');
											
											$this->exclude_items = array();
											$this->include_items = array();									
											foreach($items_arr as $item_id){
												$this->include_items[] = $item_id;
											}		
											//pree($this->include_items);
											$order_data =  array(
												'post_type'     => 'shop_order',
												'post_status'   => 'publish',
												'ping_status'   => 'closed',
												'post_author'   => $user_id,
												'post_password' => uniqid( 'order_' ),
											);
											//pree($this->include_items);//exit;
											
											$order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
											//update_post_meta($order_id, 'testing_position', 'cats');
											//wc_os_pree('inclusive/order_id'. $order_id);
									
											if ( is_wp_error( $order_id ) ) {
												
												if(!$this->cron_in_progress)
												add_action( 'admin_notices', array($this, 'clone__error'));
											} else {
												$this->cloned_order_data($order_id, $originalorderid, true, false, $wc_os_shipping_cost);//split_order_logic	
												
												if($order_split_action && count($this->include_items)>1){
													update_post_meta($order_id, 'wos_forced_ie', $order_split_action);
													update_post_meta($order_id, 'wos_delete_order', true);
													//update_post_meta($order_id, 'conflict_status', true);											
													update_post_meta($order_id, 'wc_os_order_splitter_cron', true);
												}else{
													update_post_meta($order_id, 'split_status', true);
												}
												
												
												$new_order_ids[] = $order_id;
												
											}	
										}
									}
									
								}
								
							}
							//exit;
						break;
						case 'groups':
							//pree('GROUPS');exit;
							if(!$wc_os_pro){ return; }
							
							if($wc_os_pro && class_exists('wc_os_bulk_order_splitter')){
								
								$classObj = new wc_os_bulk_order_splitter;
								
								$is_bundle = false;
								
								
								
								if($originalorderid && count($original_order->get_items())==1){
									foreach($original_order->get_items() as $item_id=>$item_values){
										$pid = $item_values->get_product_id();
										$vid = $item_values->get_variation_id();
										$product_item = $vid?$vid:$pid;				
										$product = wc_get_product($product_item);
										$is_bundle = (method_exists($product, 'get_type') && $product->get_type()=='bundle');
									}
								}		

								//pree($wc_order_items);exit;
								if(count($wc_order_items)>1){
									//pree($wc_order_items_variations);
									$new_order_ids = $classObj->split_order_by_groups($wc_order_items, $originalorderid, $user_id, $wc_order_items_variations, $wc_os_cart);
									//exit;
									if($originalorderid){
										$order_data_check = wc_get_order($originalorderid);			
										//pree(($order_data_check->get_items()));exit;
										if(count($order_data_check->get_items())<1){
											wos_clone_order_notes($originalorderid, $new_order_ids);
											if(wc_os_order_removal()){
												wc_os_trash_post($originalorderid);
											}
										}
									}
								}elseif(count($wc_order_items)==1 && $is_bundle){
									//pree($wc_order_items);exit;
								}
								
							}
							//exit;
							
						break;	
						case 'group_cats':
							
							if(!$wc_os_pro){ return; }
							//pree(class_exists('wc_os_bulk_order_splitter'));exit;
							//pre($wc_order_items);
							
							if($wc_os_pro && class_exists('wc_os_bulk_order_splitter') && count($wc_order_items)>1){
								
								$classObj = new wc_os_bulk_order_splitter;
								//pree($classObj);exit;
								//pree($originalorderid);pree($user_id);pree($wc_order_items);pree($classObj);exit;
								//pree('$classObj->split_order_by_group_cats');
								$new_order_ids = $classObj->split_order_by_group_cats($wc_order_items, $originalorderid, $user_id, $wc_os_cart);
								//pree($new_order_ids);exit;
							}
							
						break;	
						case 'group_by_vendors':
						
							if(!$wc_os_pro){ return; }
							
							if($wc_os_pro && class_exists('wc_os_bulk_order_splitter') && count($wc_order_items)>1){
								
								$classObj = new wc_os_bulk_order_splitter;
								//if(get_current_user_id()==98){
									//pree($user_id);
								//}
								$new_order_ids = $classObj->split_order_by_vendor_groups($wc_order_items, $originalorderid, $user_id, $wc_os_cart);
								
								//if(get_current_user_id()==98){
								//	pree($new_order_ids);
								//}
								
							}
							//pree($new_order_ids);//exit;
							if($originalorderid){
								
								$order_data_check = wc_get_order( $originalorderid );
								
								$order_data_check->calculate_totals();
								
								if(count($order_data_check->get_items())<1){
									wos_clone_order_notes($originalorderid, $new_order_ids);
									if(wc_os_order_removal()){
										wc_os_trash_post($originalorderid);
									}
								}	
									
							}
							
						break;			
                       case 'group_by_woo_vendors':

                            if(!$wc_os_pro){ return; }

                            if($wc_os_pro && class_exists('wc_os_bulk_order_splitter') && count($wc_order_items)>1){

                                $classObj = new wc_os_bulk_order_splitter;

                                $new_order_ids = $classObj->split_order_by_woo_vendor_groups($wc_order_items, $originalorderid, $user_id, $wc_os_cart);

                            }

                            if($originalorderid){

                                $order_data_check = wc_get_order( $originalorderid );

                                $order_data_check->calculate_totals();

                                if(count($order_data_check->get_items())<1){
                                    wos_clone_order_notes($originalorderid, $new_order_ids);
                                    if(wc_os_order_removal()){
                                        wc_os_trash_post($originalorderid);
                                    }
                                }

                            }

						break;												
						case 'group_by_attributes_only':
						
							if(!$wc_os_pro){ return; }
							if($wc_os_pro && class_exists('wc_os_bulk_order_splitter') && count($wc_order_items)>1){
								
								$classObj = new wc_os_bulk_order_splitter;
								
								$new_order_ids = $classObj->split_order_by_attributes_groups($wc_order_items, $originalorderid, $user_id, $wc_os_cart);
								
								
								
							}
						break;
						case 'group_by_attributes_value':
						
							if(!$wc_os_pro){ return; }
							if($wc_os_pro && class_exists('wc_os_bulk_order_splitter') && count($wc_order_items)>1){
								
								$classObj = new wc_os_bulk_order_splitter;
								
								$new_order_ids = $classObj->split_order_by_attributes_values_grouped($wc_order_items, $originalorderid, $user_id, $wc_os_cart);
								
							}
						break;
                        case 'group_by_acf_group_fields':
                            //pree('GROUPS');exit;
                            if(!$wc_os_pro){ return; }

                            if(class_exists('wc_os_bulk_order_splitter')){

                                $classObj = new wc_os_bulk_order_splitter;

                                $is_bundle = false;

                                if($originalorderid && count($original_order->get_items())==1){
                                    foreach($original_order->get_items() as $item_id=>$item_values){
                                        $pid = $item_values->get_product_id();
                                        $vid = $item_values->get_variation_id();
                                        $product_item = $vid?$vid:$pid;
                                        $product = wc_get_product($product_item);
                                        $is_bundle = (method_exists($product, 'get_type') && $product->get_type()=='bundle');
                                    }
                                }

                                if(count($wc_order_items)>1){
                                    //pree($wc_order_items_variations);
                                    $new_order_ids = $classObj->split_order_acf_fields_values($wc_order_items, $originalorderid, $user_id, $wc_order_items_variations, $wc_os_cart);
									//$new_order_ids = array();
                                    //exit;
                                    if($originalorderid){
                                        $order_data_check = wc_get_order($originalorderid);
                                        //pree(($order_data_check->get_items()));exit;
                                        if(count($order_data_check->get_items())<1){
                                            wos_clone_order_notes($originalorderid, $new_order_ids);
                                            if(wc_os_order_removal()){
                                                wc_os_trash_post($originalorderid);
                                            }
                                        }
                                    }
                                }elseif(count($wc_order_items)==1 && $is_bundle){
                                    //pree($wc_order_items);exit;
                                }

                            }
                            //exit;
							//pre($new_order_ids);

                        break;
						
                       	case 'group_by_partial_payment':
                            if(!$wc_os_pro){ return; }

                            if(class_exists('wc_os_bulk_order_splitter')){

                                $classObj = new wc_os_bulk_order_splitter;

                                $is_bundle = false;

                                if($originalorderid && count($original_order->get_items())==1){
                                    foreach($original_order->get_items() as $item_id=>$item_values){
                                        $pid = $item_values->get_product_id();
                                        $vid = $item_values->get_variation_id();
                                        $product_item = $vid?$vid:$pid;
                                        $product = wc_get_product($product_item);
                                        $is_bundle = (method_exists($product, 'get_type') && $product->get_type()=='bundle');
                                    }
                                }

                                if(count($wc_order_items)>1){
                                    //pree($wc_order_items_variations);
                                    $new_order_ids = $classObj->split_order_partial_payment($wc_order_items, $originalorderid, $user_id, $wc_order_items_variations, $wc_os_cart);
                                    //exit;
                                    if($originalorderid){
                                        $order_data_check = wc_get_order($originalorderid);
                                        //pree(($order_data_check->get_items()));exit;
                                        if(count($order_data_check->get_items())<1){
                                            wos_clone_order_notes($originalorderid, $new_order_ids);
                                            if(wc_os_order_removal()){
                                                wc_os_trash_post($originalorderid);
                                            }
                                        }
                                    }
                                }elseif(count($wc_order_items)==1 && $is_bundle){
                                    //pree($wc_order_items);exit;
                                }

                            }
                            //exit;

                        break;						
					}		
				}				
				
				
				
				if($originalorderid){
					
					update_post_meta($originalorderid, 'split_status', true);
					delete_post_meta($originalorderid, 'wc_os_order_splitter_cron');


										
					if(!empty($new_order_ids)){
						
						update_post_meta($originalorderid, '_wos_calculate_totals', true);
						//update_post_meta($originalorderid, 'order_splitted', date('H:i:s A'));
						wos_clone_order_notes($originalorderid, $new_order_ids);
						//pree($new_order_ids);pree($originalorderid);exit;
						//wos_email_notification(array('new'=>$new_order_ids, 'original'=>$originalorderid), 'split');
						do_action('wc_os_after_order_split', $new_order_ids, $originalorderid);
						
						foreach($new_order_ids as $order_id){
	
							$_customer_user_agent = get_post_meta($originalorderid, '_customer_user_agent', true);
							update_post_meta($order_id, 'splitted_from', $originalorderid);
							//pree($order_id.', splitted_from, '.$originalorderid);
							
							if($_customer_user_agent)
							update_post_meta( $order_id, '_customer_user_agent',  $_customer_user_agent);
							
							if(!$wc_os_tax_cost)
							update_post_meta($order_id, 'wos_remove_taxes', true);
							
							if(function_exists('wc_os_order_remove_fee')){
								wc_os_order_remove_fee($order_id, '_line_total');
							}							
							if(function_exists('wc_os_add_shipping_fee')){
							
								wc_os_add_shipping_fee($order_id);
							}								
						}	
						
						if(function_exists('wc_os_order_remove_fee')){
							wc_os_order_remove_fee($originalorderid, '_line_total');
						}		
						if(function_exists('wc_os_add_shipping_fee')){
							
							wc_os_add_shipping_fee($originalorderid, false, true);
							//pree('wc_os_add_shipping_fee($originalorderid, false);');
							//exit;
						}												
					}else{
						
						
					}
					
					if(function_exists('wc_os_set_empty_order_status')){
						wc_os_set_empty_order_status($originalorderid);
						//update_post_meta($originalorderid, 'order_empty', date('H:i:s A'));
					}
										
				}elseif($wc_os_pro && $wc_os_packages_overview && $wc_os_cart && !empty($new_order_ids)){
					
					if($return_ids){
						return $new_order_ids;
					}else{
						wc_os_packages_overview($new_order_ids, $new_order_ids_qty);
					}
					
				}

				//pree($wc_os_pro.' && '.$wc_os_packages_overview.' && '.$wc_os_cart.' && '.!empty($new_order_ids));exit;
				if($wc_os_cart){
					WC()->session->set( 'wc_os_expected_child_orders', count($new_order_ids));
				}

			}else{
				
				//06 March 2019 - with Sean Owen
				$split_qty = wc_os_order_qty_split();
				
				if($split_qty && $originalorderid){
					$this->split_order($originalorderid, $wc_os_products);
					
					update_post_meta($originalorderid, 'split_status', true);
				//wc_os_pree('split_order_logic-3');
				}
			}
			
			
			
			
			return true;
		}		
		
		
		/*
			- END
			07 January 2019
			Automatic Settings Added 
		*/			
			
		public function wos_remove_order_item($originalorderid, $product_ids){
			
			global $wc_os_order_items;
			//pree($product_ids);
			$wc_os_ps = (array_key_exists('wc_os_ps', $_POST)?$_POST['wc_os_ps']:array());
			$product_ids = is_array($product_ids)?$product_ids:array($product_ids);
			//wc_os_pree($product_ids);exit;
			$original_order = wc_get_order($originalorderid);
			foreach($original_order->get_items() as $item_id=>$item_data){
				//
				//$product_id = $item_data->get_product_id();
				if($item_data->get_variation_id()){
					$product_id = $item_data->get_variation_id();
				}else{
					$product_id = $item_data->get_product_id();
				}				
								
				//pree($product_id.' | '.$item_id);
				//pree($item_id);				
				
				if(empty($wc_os_ps) && in_array($product_id, $product_ids)){
					wc_delete_order_item( $item_id );
					update_post_meta($originalorderid, '_wc_os_effected_order', true);
				}
		
				if(!empty($wc_os_ps) && in_array($item_id, $_POST['wc_os_ps'])){
					wc_delete_order_item( $item_id );
					update_post_meta($originalorderid, '_wc_os_effected_order', true);
				}				
			}	
			$original_order = wc_get_order($originalorderid);
			$wc_os_order_items = (empty($original_order->get_items())?array('empty'):$wc_os_order_items);
			
		}
	  
		public function split_order($originalorderid = null, $wc_os_products=array()){
			global $wc_os_effect_parent, $wc_os_settings;
			//$originalorderid = 2453;
			//return;
			//wc_os_pree($_POST);exit;
			//wc_os_pree($originalorderid);
			//wc_os_pree(wc_os_order_split());exit;
			if(!wc_os_order_split())
			return;
			

			$split_lock = (isset($wc_os_settings['wc_os_additional']['split_lock'])?$wc_os_settings['wc_os_additional']['split_lock']:array());
			$split_lock = is_array($split_lock)?$split_lock:array();
			
			$status_lock_released = empty($split_lock);			
			
							
			
			$new_order_ids = array();	
			$proceed = true;
			$wc_os_all_products = (isset($wc_os_settings['wc_os_all_product']) && $wc_os_settings['wc_os_all_product']) ? true : false; //flag indicating to all products are subject to splitting
			
			//wc_os_pree($originalorderid);exit;
			
			if($originalorderid==0){
				$originalorderid = sanitize_wc_os_data($_GET['order_id']);
				$this->processing = false;
			}
			
			
			//wc_os_pree($originalorderid);exit;
			
			if($originalorderid>0){
				$order_data = wc_get_order( $originalorderid );
				
				//pree($order_data);exit;
				if(empty($order_data))
				return;
				
				
				if(!empty($split_lock) && !empty($order_data)){
					//wc_os_logger('email', '$split_lock: '.implode(' - ', $split_lock));
					foreach($split_lock as $split_lock_i){				
						if(!$status_lock_released){
							$status_lock_released = $order_data->has_status($split_lock_i);
						}
					}
				}	
				
				
				if(!$status_lock_released)
				return;
				
				$split_qty = wc_os_order_qty_split();
				//wc_os_pree($split_qty);exit;
				
				
				$user_id = get_post_meta($originalorderid, '_customer_user', true);
				//pree($user_id);
				$split_status = get_post_meta($originalorderid, 'split_status', true);
				$qty_splitted = get_post_meta($originalorderid, 'qty_splitted', true);
				
				//wc_os_pree($split_status);
				//wc_os_pree($qty_splitted);exit;
				
				$qty_split_check = ($split_qty && !$qty_splitted);//true;
				
				//wc_os_pree($order_data->get_item_count());exit;
				//wc_os_pree(count($order_data->get_items()));
				//wc_os_pree($split_status);exit;
				//wc_os_pree(count($order_data->get_items()));exit;
				$multiple_items_check = (count($order_data->get_items())>1 && !$split_status);
				
				
				
					
				
				//wc_os_pree($qty_split_check);
				//wc_os_pree($multiple_items_check);exit;
				
				if($qty_split_check || $multiple_items_check){
					
				}else{
					//$order_qty = 0;
					//foreach ($order_data->get_items() as $item_id => $item_data) {
					//	$order_qty += $item_data->get_quantity();
					//}
					//wc_os_pree($order_qty);exit;
					//if($order_qty<=1){
						return;
					//}else{
						//$qty_split_check = true;
					//}
				}
				
				
				//wc_os_pree($_POST['wc_os_ps']);
				//wc_os_pree($order_data->get_items());exit;		
				//pree($wc_os_products);
				if($wc_os_all_products);
		        else{
					foreach( $order_data->get_items() as $item_key => $item_values ){
						
						if(!$proceed)
						continue;
						
						if($this->processing){
							if(in_array($item_values->get_product_id(), $wc_os_products)){
							}else{
								$proceed = false;
							}
						}				
					}
				}
				
				$valid_process = false;
				
				//pree($_POST['wc_os_ps']);exit;
				//wc_os_pree($order_data->get_items());exit;
				
				//wc_os_pree($proceed);exit;
				//pree(count($order_data->get_items()));exit;	
				$item_counter = 0;			
				foreach( $order_data->get_items() as $item_key => $item_values ){
					$item_counter++;

					if($item_values->get_product_id() && (empty($_POST['wc_os_ps']) || (!empty($_POST['wc_os_ps']) && in_array($item_key, $_POST['wc_os_ps'])))){
						//pree($item_values->get_product_id());					
						//pree($item_values->get_quantity());
						
						$qty = $item_values->get_quantity();
						
						$qty_check = ($qty_split_check && $qty>1);
						
						
						//wc_os_pree(($multiple_items_check || $qty_check));exit;
						
						if($multiple_items_check || $qty_check){
						}else{
							continue;
						}
						
						//wc_os_pree('$multiple_items_check || '.$multiple_items_check);
						//wc_os_pree('$qty_check || '.$qty_check);
						//exit;
						
						
						$item = $item_values->get_data();
						$product_id = $item['product_id'];
						$variation_id = $item['variation_id'];
						//pree($item);exit;

						
						if ($variation_id != 0) {
							$product = new WC_Product_Variation($variation_id);
			
						} else {
							$product = new WC_Product($product_id);	
						}	
								
                        if(empty($_POST['wc_os_ps']) && $wc_os_effect_parent && $item_counter == 1){
                            continue;
                        }else{
                            $this->include_items[] = $product->get_id();
                        }						
						//wc_os_pree($product->get_price());exit;
						//wc_os_pree('$item_values[\'total\']==$product->get_price()');
						//wc_os_pree($item_values['total'].' == '.$product->get_price());
						//exit;
						if($item_values['total']==$product->get_price()){
							$unit_price = $product->get_price();
						}else{
							$unit_price = ($item_values['total']/$qty); //06 March 2019 - with Sean Owen
						}
						//wc_os_pree($unit_price);exit;
						
									
						$order_data =  array(
							'post_type'     => 'shop_order',
							'post_status'   => 'publish',
							'ping_status'   => 'closed',
							'post_author'   => $user_id,
							'post_password' => uniqid( 'order_' ),
						);
						
						
						$wc_pos_order_type = get_post_meta($originalorderid, 'wc_pos_order_type', true);
						$wc_pos_order_type = ($wc_pos_order_type?$wc_pos_order_type:'online');
						
						
						if($qty_check){
							
							//wc_os_pree('split_order/order_id');wc_os_pree($qty);exit;
							
							for($q=1; $q<=$qty; $q++){
								$order_id_new = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
								//update_post_meta($order_id_new, 'testing_position', 'split_order');
								//wc_os_pree('split_order/order_id'. $order_id);exit;
								
								update_post_meta($order_id_new, 'wc_pos_order_type', sanitize_wc_os_data($wc_pos_order_type)); // NO QTY. SPLIT
								update_post_meta($order_id_new, 'qty_splitted', true);
						
								if ( is_wp_error( $order_id_new ) ) {
									
									if(!$this->cron_in_progress)
									add_action( 'admin_notices', array($this, 'split__error'));
								} else {
									//wc_os_pree($unit_price);
									//wc_os_pree('split_order1');exit;
									$this->splitted_order_data($order_id_new, $originalorderid, $product_id, $variation_id, 1, $unit_price, false, $item_key);		
									
									
									$valid_process = true;
									
									if(method_exists($this, 'ywpo_add_order_item_meta')){
										$this->ywpo_add_order_item_meta($item_key, $product);
									}
								}			
												
							}
							
						}elseif($multiple_items_check && $qty){
							
								//pree($order_data);exit;
								$order_id_new = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data), true );
								//update_post_meta($order_id_new, 'testing_position', 'multiple_items_check');
								//wc_os_pree('split_order/multiple_items_check/order_id'. $order_id);
								
								update_post_meta($order_id_new, 'wc_pos_order_type', sanitize_wc_os_data($wc_pos_order_type)); // NO QTY. SPLIT
								if ( is_wp_error( $order_id_new ) ) {
									
									if(!$this->cron_in_progress)
									add_action( 'admin_notices', array($this, 'split__error'));
								} else {
									//wc_os_pree('split_order2');exit;
									$this->splitted_order_data($order_id_new, $originalorderid, $product_id, $variation_id, $qty, $unit_price, false, $item_key);
									
									$valid_process = true;
									
									update_post_meta($order_id_new, 'split_status', true);
									
									
									
									if(method_exists($this, 'ywpo_add_order_item_meta')){
										$this->ywpo_add_order_item_meta($item_key, $product);
									}


								}	
								
								global $yith_pre_order;							
								
								if($yith_pre_order && function_exists('wos_update_orders_again'))				
								wos_update_orders_again($order_id_new, $originalorderid);
						}else{
							
						}
					
						$new_order_ids[] = $order_id_new;
						
						
						
						
											
					}
				}


//				exit;
				if($valid_process){
					
//					wc_os_pree($originalorderid);exit;
					delete_post_meta($originalorderid, 'wc_os_order_splitter_cron');

                    if(!empty($this->include_items) && $wc_os_effect_parent){

                        $this->wos_remove_order_item($originalorderid, $this->include_items);
                    }
										
					update_post_meta($originalorderid, 'split_status', true);
	
					$order_data = wc_get_order( $originalorderid );
					$order_data->calculate_totals();
									
					if(!empty($new_order_ids)){
						//pree($new_order_ids);//exit;
						do_action('wc_os_after_order_split', $new_order_ids, $originalorderid);
					}				
						
					if(wc_os_order_removal() && empty($_POST['wc_os_ps'])){
						//wc_os_pree($multiple_items_check);
						//wc_os_pree($originalorderid);
						//exit;
						//pree($order_id.' removed through split order');//exit;
						wc_os_trash_post($originalorderid);
					}else{
						
					}
					
					if(is_admin() && !$this->cron_in_progress){
						wp_redirect('edit.php?post_type=shop_order');exit;
					}
				}
				
			}
			
			//return true;
		}	
		/**
		 * Create new WC_Order and clone all exisiting data
		 */
		
		public function cloned_order_data($order_id, $originalorderids = null, $clone_order=true, $reduce_stock=false, $clone_shipping=true, $parent_iter=''){
			
			//wc_os_logger('email', ' $order_id > '.$order_id.' > cloned_order_data');
			//pree(array_key_exists('wc_os_shipping_cost', get_option('wc_os_general_settings', array())));
			//pree('$order_id: '.$order_id);pree('$originalorderids: '.$originalorderids);pree('$clone_order: '.$clone_order);pree('$reduce_stock: '.$reduce_stock);pree('$clone_shipping: '.$clone_shipping);exit;

			global $yith_pre_order, $wc_os_debug, $wc_os_pro, $wc_os_general_settings, $wc_os_settings;
			$order_status_directed = '';
			$order = new WC_Order($order_id);
		
			$originalorderids = (is_array($originalorderids)?$originalorderids:array($originalorderids));
			
			
			//wc_os_pree($order_id);wc_os_pree($originalorderids);exit;
			$iter = 0;
			foreach( $originalorderids as $originalorderid ) {	$iter++;
			
				
				
				if ($originalorderid) {
					$this->original_order_id = $originalorderid;
				} else {
					$this->original_order_id = sanitize_wc_os_data($_GET['order_id']);
				}
				
				
				if(!$wc_os_debug){
					
					$this->wos_update_post_meta($order_id, 'cloned_from', $this->original_order_id);
					if(!$this->clone_in_progress)				
					$this->wos_update_post_meta($order_id, 'splitted_from', $this->original_order_id);
				}
				//pree($this->original_order_id);exit;
				$original_order = new WC_Order($this->original_order_id);
				
				
				$order_status = $original_order->get_status();
				
				// Check if Sequential Numbering is installed
				
				if ( class_exists( 'WC_Seq_Order_Number_Pro' ) ) {
					
					// Set sequential order number 
					
					$setnumber = new WC_Seq_Order_Number_Pro;
					$setnumber->set_sequential_order_number($order_id);
					
				}
				
				if(!$wc_os_debug){
				
					$this->clone_order_header($order_id);
					$this->clone_order_billing($order_id);
					
					

					
					if(!array_key_exists('wc_os_remove_fees_from_child', $wc_os_general_settings)){
					
						$this->clone_order_fees($order, $original_order);
					
					}						
					
					$this->clone_order_coupons($order, $original_order);
				
				}
				
				add_filter( 'woocommerce_can_reduce_order_stock','wos_filter_woocommerce_can_reduce_order_stock', 10, 2 );
				
			
							
								
								
				if($clone_order){
					//pree($original_order->get_items());					
					//$this->clone_order_items($order, $original_order);//pree('clone_order_items');
					
					if($wc_os_settings['wc_os_ie'] == 'group_by_partial_payment'){

				        $this->auto_split = $wc_os_settings['wc_os_ie'];

                        $this->clone_order_items_by_item($order, $original_order);//pree('clone_order_items');

                    }else{

				        $this->clone_order_items($order, $original_order);//pree('clone_order_items');

                    }					
					
					
				}elseif($wc_os_pro && class_exists('wc_os_bulk_order_splitter')){
					
					$classObj = new wc_os_bulk_order_splitter;
					//wc_os_pree($this->include_items);wc_os_pree($classObj->include_items);exit;
					
					//wc_os_pree($classObj->general_array);exit;
					if(method_exists($classObj, 'add_order_items')){
						$classObj->include_items = (empty($classObj->include_items)?$this->include_items:$classObj->include_items);
						$classObj->general_array = (empty($classObj->general_array)?$this->general_array:$classObj->general_array);
						
						$classObj->add_order_items($order);
						
						//$order = new WC_Order($order_id);
						//$order->calculate_totals();
						//wc_os_pree('add_order_items');wc_os_pree($order);exit;
					}
				}
//				exit;
				
				if(!$wc_os_debug){
					$this->wos_update_post_meta( $order_id, '_payment_method', get_post_meta($this->original_order_id, '_payment_method', true) );
					$this->wos_update_post_meta( $order_id, '_payment_method_title', get_post_meta($this->original_order_id, '_payment_method_title', true) );
				}
				
				//pree('cloned_order_data');
				
				// Reduce Order Stock
				//if($reduce_stock)
				//wc_reduce_stock_levels($order_id);
				
				// POSSIBLE CHANGE? - Set status to on hold as payment is not received		
				if(!$wc_os_debug){
					
					
					$order->calculate_totals();
					$this->clone_order_shipping_items($order_id, $original_order, false, $clone_shipping);//exit;
					$order = new WC_Order($order_id);
					$order->calculate_totals();
					
					delete_post_meta($order_id, '_order_shipping_tax');
					$shipping_items = $order->get_items('shipping');
					foreach($shipping_items as $order_key => $values){ //CLEARING ALL TAXES ON SHIPPING WHEN CLONING					
						wc_update_order_item_meta($order_key, 'total_tax', 0);
						wc_update_order_item_meta($order_key, 'taxes', array());					
					}					
					
				}
				// Set order note of original cloned order
				
				
	
				//pree($this->original_order_id);exit;
				if(function_exists('wos_update_orders_again')){
					if($yith_pre_order){
						wos_update_orders_again($order_id, $this->original_order_id);
					}else{
						if($clone_order){
							wos_clone_order_notes($this->original_order_id, $order_id);
						}
					}
				}
	
				
				$this->meta_keys_clone_from_to($order_id, $this->original_order_id);//exit;
				
				$order->add_order_note(__('Parent Order').' #'.$this->original_order_id.'');
				
				$debug_backtrace = debug_backtrace();
				$function = $debug_backtrace[1]['function'];
				//pree($debug_backtrace);exit;
				
				//pree($order->get_items());

				
				
				if($wc_os_pro){
					$classObj = new wc_os_bulk_order_splitter;
					//pree($function);
					//wc_os_logger('email', 'cloned_order_data: '. $order_id.' : '.count($order->get_items()).' : '.$function);
					$order_status_directed = $classObj->get_order_status_by_rule($order_id);
					//pree($order_status_directed);

				}
				
				//wc_os_logger('email', ' $order_id > '.$order_id.' > '.$order_status_directed);
				
				switch($function){
					default:					
						$order_status_directed = ($order_status_directed?$order_status_directed:wc_os_order_split_status_action());
					break;
					case 'clone_order':
					
					break;
				}
				
				//wc_os_logger('email', ' $order_id > '.$order_id.' > '.$order_status_directed);
				//pree($order_status_directed);pree($order_status);pree($order_id);
				
				//exit;
				sleep(1);
				
				//wc_os_logger('email', ' $order_id > '.$order_id);
				//wc_os_logger('email', ' $order_status_directed > '.$order_status_directed.', $order_id > '.$order_id);
				//wc_os_logger('email', ' split_status > '.get_post_meta($order_id, 'split_status', true));
				//wc_os_logger('email', ' _order_shipping > '.get_post_meta($order_id, '_order_shipping', true));
				
				if($order_status_directed){ //10/02/2020 - resolving Ryan's issue regarding splitted order change status					
					//wp_update_post(array('ID'=>$order_id, 'post_status'=> $order_status_directed));
					wc_os_set_order_status($order_id, $order_status_directed);
					wc_os_update_ignored_cron_array($order_id);
					//update_wcfm_order_status($order_id, $order_status_directed);
				}else{			
					//$order->update_status($order_status);
					//wp_update_post(array('ID'=>$order_id, 'post_status'=>'wc-'.$order_status));
					wc_os_set_order_status($order_id, 'wc-'.$order_status);
					//update_wcfm_order_status($order_id, 'wc-'.$order_status);
				}
				

				
				// Returns success message on clone completion
				if(!$this->cron_in_progress)
				add_action( 'admin_notices', array($this, 'clone__success'));

			
			}
		}
		
		public function wos_update_post_meta($post_id, $key, $val){
			//if(is_array(get_post_custom_keys($post_id)) && !in_array($key, get_post_custom_keys($post_id))){
				update_post_meta($post_id, $key, $val);
			//}
		}
		
		
		public function meta_keys_clone_from_to($order_id_to=0, $order_id_from=0){
			
			global $wpdb, $wc_os_meta_handling_arr, $is_wc_booking;
			
			//pree('$order_id_from: '.$order_id_from.' && $order_id_to: '.$order_id_to);

			if($order_id_from && $order_id_to){
				
				
				$this->wos_update_post_meta( $order_id_to, '_billing_address_index', get_post_meta($order_id_from, '_billing_address_index', true) );
				$this->wos_update_post_meta( $order_id_to, '_shipping_address_index', get_post_meta($order_id_from, '_shipping_address_index', true) );
				
				
				
				//$this->meta_keys_intersection = wc_os_meta_keys_array('group_cats', 'a');
				$diff_key_arr = array('wc_os_order_splitter_cron', 'wos_update_status');
				if(function_exists('WC_Order_Barcodes')){
					$diff_key_arr[] = '_barcode_text';
					$diff_key_arr[] = '_barcode_image';
				}
				
				$order_id_to_meta = get_post_meta($order_id_to);
				$order_id_to_keys = array_keys($order_id_to_meta);
				
				$order_id_from_meta = get_post_meta($order_id_from);
				$order_id_from_keys = array_keys($order_id_from_meta);
				
				$arr_diff = array_diff($order_id_from_keys, $order_id_to_keys);
				
				//pree($arr_diff);
				
				if(!empty($arr_diff)){
					foreach($arr_diff as $diff_key){
						//wc_os_pree($order_id_from_meta[$diff_key]);exit;

                        $diff_key_check = 'order_meta|'.$diff_key;
						if(array_key_exists($diff_key, $order_id_from_meta)){
							$diff_value = current($order_id_from_meta[$diff_key]);
							
							
							
							if(
									!in_array($diff_key, $diff_key_arr) 
								&& 
									(
											empty($this->meta_keys_intersection)
										||
											
											(
													!empty($this->meta_keys_intersection)
												&&
												
													(
															!in_array('none', $this->meta_keys_intersection)
														&&												
															in_array($diff_key_check, $this->meta_keys_intersection)
													)
													
											)
									)
							){
								
										$diff_value = maybe_unserialize($diff_value);
										

										update_post_meta($order_id_to, $diff_key, $diff_value);

                            }elseif(in_array($diff_key, $diff_key_arr)){
								switch($diff_key){
									case '_barcode_text':	
																			
									break;
									case '_barcode_image':
										if(class_exists('WooCommerce_Order_Barcodes') && function_exists('wos_barcode')){
											$WooCommerce_Order_Barcodes  = new WooCommerce_Order_Barcodes;
											if( 'yes' == $WooCommerce_Order_Barcodes->barcode_enable ) {
												$barcode_string = $WooCommerce_Order_Barcodes->get_barcode_string();
												$_barcode_text = update_post_meta($order_id_to, '_barcode_text', $barcode_string);
												//pree($_barcode_text);pree($WooCommerce_Order_Barcodes->barcode_type);
												$diff_value = wos_barcode($_barcode_text, $WooCommerce_Order_Barcodes->barcode_type);	
												//pree($diff_value);exit;
												update_post_meta($order_id_to, $diff_key, $diff_value);		
												
											}
										}
									break;									
								}
							}
						}
					}
				}
				
				//pree($order_id_from);
				$original_order = wc_get_order($order_id_from);
				$new_order = wc_get_order($order_id_to);
				//pree('$order_id_from: '.$order_id_from.' && $order_id_to: '.$order_id_to);
				
				//pree('$original_order->get_items(): '.count($original_order->get_items()));
				//pree('$new_order->get_items(): '.count($new_order->get_items()));
				
				
				$old_order_items = array();
				$old_order_items_by_item = array();
				if(!empty($original_order->get_items())){

				    foreach($original_order->get_items() as $item_id=>$item_data){
						//$item_meta = wc_get_order_item_meta($item_id);
	
						$item_meta = $this->wc_os_get_order_item_meta($item_id);
						//pree($item_id);pree($item_meta);
						
						$pid = $item_data->get_product_id();
						$vid = $item_data->get_variation_id();	
						
						$old_order_items_by_item[$item_id] = $item_meta;
						
						$old_order_items[$pid][$vid] = $item_meta;
										
					
					}

                }
				
				$order_items = array();

				if(!empty($new_order->get_items())){
					
					//pree('if(!empty($new_order->get_items())){');

				    foreach($new_order->get_items() as $item_id=>$item_data){
						
						
						
                        $pid = $item_data->get_product_id();
                        $vid = $item_data->get_variation_id();
						
						$order_items[] = ($vid?$vid:$pid);
						//pree($pid);pree($order_items);pree($old_order_items);
						
						//pree($old_order_items);pree($pid);pree($old_order_items);
						//pree($pid);pree($vid);
						if(in_array($this->auto_split, $wc_os_meta_handling_arr)){

							$old_meta_id = $item_data->get_meta('_old_item_id');
							
							if($is_wc_booking && !empty($this->booking_ids)){
							    $current_booking_id = array_key_exists($old_meta_id, $this->booking_ids) ? $this->booking_ids[$old_meta_id] : 0;

							    if($current_booking_id){
							        update_post_meta($current_booking_id, '_bkap_order_item_id', $item_id);
                                }
                            }							

                            if($old_meta_id && !empty($old_order_items_by_item) && array_key_exists($old_meta_id, $old_order_items_by_item)){

                                $item_meta = $old_order_items_by_item[$old_meta_id];
                                foreach($item_meta as $key=>$value){

                                    $diff_key_check = 'line_item_meta|'.$key;
                                    $value = (is_array($value)?current($value):$value);

                                    //pree($diff_key_check);
                                    //pree($value);

                                    //pree($item_id.', '.$key.', '.$value);//exit;


                                    $existing_value = wc_get_order_item_meta($item_id, $key, true);

                                    //pree($this->meta_keys_intersection);
                                    //pree($diff_key_check);
                                    //pree($existing_value);

                                    if(empty($this->meta_keys_intersection)){

                                        //pree($existing_value);

                                        if($existing_value==''){

                                            //$mval = is_array($value)?current($value):$value;

                                            $mval = maybe_unserialize($value);

                                            //pree($mval);
											
											//pree('A: ');pree($item_id);pree($key);pree($mval);
                                            wc_update_order_item_meta($item_id, $key, $mval);

                                            //pree('wc_update_order_item_meta('.$item_id.', '.$key.', '.$mval.');');

                                        }

                                    }elseif (



                                        !empty($this->meta_keys_intersection)
                                        &&
                                        (
                                            !in_array('none', $this->meta_keys_intersection)
                                            &&
                                            in_array($diff_key_check, $this->meta_keys_intersection)
                                        )

                                    ){

                                        //$mval = is_array($value)?current($value):$value;

                                        $mval = maybe_unserialize($value);
										//pree('B: ');pree($item_id);pree($key);pree($mval);
                                        wc_update_order_item_meta($item_id, $key, $mval);

                                        //pree('wc_update_order_item_meta('.$item_id.', '.$key.', '.$mval.');');

                                    }





                                }


                            }

                            //$item_data->delete_meta_data('_old_item_id');
                            //$item_data->save();
														
						}elseif(!empty($old_order_items) && array_key_exists($pid, $old_order_items)){
							
							//pree($vid);
							//pree($old_order_items[$pid]);
							
							
						    if(array_key_exists($vid, $old_order_items[$pid])){
                                $item_meta = $old_order_items[$pid][$vid];
    							//wc_os_pree($item_meta);
                                foreach($item_meta as $key=>$value){

                                    $diff_key_check = 'line_item_meta|'.$key;
                                    $value = (is_array($value)?current($value):$value);
									
									//pree($diff_key_check);
									//pree($value);
									
									//pree($item_id.', '.$key.', '.$value);//exit;


                                    $existing_value = wc_get_order_item_meta($item_id, $key, true);
									
									//pree($this->meta_keys_intersection);
									//pree($diff_key_check);
									//pree($existing_value);

                                    if(empty($this->meta_keys_intersection)){
										
										//pree($existing_value);

                                        if($existing_value==''){

											//$mval = is_array($value)?current($value):$value;
	
											$mval = maybe_unserialize($value);
											
											//pree($mval);
											//pree('C: ');pree($item_id);pree($key);pree($mval);
                                            wc_update_order_item_meta($item_id, $key, $mval);
											
											//pree('wc_update_order_item_meta('.$item_id.', '.$key.', '.$mval.');');

                                        }

                                    }elseif (
									
										

                                        !empty($this->meta_keys_intersection)
                                        &&
                                        (
                                            !in_array('none', $this->meta_keys_intersection)
                                            &&
                                            in_array($diff_key_check, $this->meta_keys_intersection)
                                        )

                                    ){
										
										//$mval = is_array($value)?current($value):$value;
										

										$mval = maybe_unserialize($value);										
										//pree('D: ');pree($item_id);pree($key);pree($mval);
                                        wc_update_order_item_meta($item_id, $key, $mval);
										
										//pree('wc_update_order_item_meta('.$item_id.', '.$key.', '.$mval.');');

                                    }


							    }
						    }
					    }
						$item_data->delete_meta_data('_old_item_id');
						$item_data->save();

				    }
                }
				
				//exit;	
				
				$shipping_items = "SELECT p.* FROM `".$wpdb->prefix."woocommerce_order_items` p WHERE p.order_item_type = 'shipping' AND p.order_id=".$order_id_from;
				//wc_os_pree($shipping_items);
				$shipping_items_unique_keys = $wpdb->get_results($shipping_items);
				//wc_os_pree($shipping_items_unique_keys);exit;
				
				if(!empty($shipping_items_unique_keys)){
					foreach($shipping_items_unique_keys as $shipping_item_meta){			
					
				
						$shipping_itemmeta_query = 'SELECT * FROM `'.$wpdb->prefix.'woocommerce_order_itemmeta` WHERE order_item_id IN ('.$shipping_item_meta->order_item_id.')';	
						//wc_os_pree($shipping_itemmeta_query);
						$shipping_itemmeta_result = $wpdb->get_results($shipping_itemmeta_query);
						//wc_os_pree($shipping_itemmeta_result);exit;
						if(!empty($shipping_itemmeta_result)){
//						    wc_os_pree($shipping_itemmeta_result);
                            $method_id = 0;
                            $cost = 0;
							foreach($shipping_itemmeta_result as $k=>$itemmeta_row){

							    if($itemmeta_row->meta_key == 'method_id' ){
							        $method_id = $itemmeta_row->meta_value;
                                }
                                if($itemmeta_row->meta_key == 'cost' ){
                                    $cost = $itemmeta_row->meta_value;
                                }
								$itemmeta_row_arr = maybe_unserialize($itemmeta_row->meta_value);
								if(is_array($itemmeta_row_arr) && array_key_exists('items', $itemmeta_row_arr) ){
								    foreach ($itemmeta_row_arr['items'] as $product_item => $flag){
								        if($flag && in_array($product_item, $order_items)){

//                                            wc_os_pree($itemmeta_row_arr);

                                            $order_shipping_data = array(
                                                'order_item_name'       => $shipping_item_meta->order_item_name,
                                                'order_item_type'       => 'shipping'
                                            );
                                            $item_id = wc_add_order_item( $order_id_to, $order_shipping_data );
											
											//pree($order_id_to);pree($item_id);pree($method_id);pree($cost);


                                            if ( $item_id ) {

                                                wc_add_order_item_meta( $item_id, 'method_id', $method_id );
                                                wc_add_order_item_meta( $item_id, 'cost',  $cost );
												
												update_post_meta($order_id_to, '_wos_keep_shipping', $item_id);
                                            }


                                        }
                                    }

								}
							}
						}
						//exit;
						
					}
					
				}
				
				//wc_os_pree($this->meta_keys_intersection);exit;
//				exit;



				$this->meta_keys_intersection = array();
			}			
		}
		
		function wc_os_get_order_item_meta($item_id){
			$obj = array();
			if($item_id){
				global $wpdb;
				$results = $wpdb->get_results('SELECT * FROM `'.$wpdb->prefix.'woocommerce_order_itemmeta` WHERE order_item_id='.$item_id);
				if(!empty($results)){
					foreach($results as $result){
						$obj[$result->meta_key] = $result->meta_value;//array($result->meta_value);//
					}
				}
			}
			return $obj;
		}

	    public function splitted_order_data($order_id=0, $originalorderid = null, $product_id=0, $variation_id=0, $qty=false, $_order_total=false, $reduce_stock=false, $order_item_id=0){
			
			
			//wc_os_logger('email', ' $order_id > '.$order_id.' > splitted_order_data');
			
		    global $wc_os_pro, $yith_pre_order, $wc_os_general_settings, $wc_os_tax_cost;
			
			$product_item = $variation_id?$variation_id:$product_id;			

		    if($wc_os_pro){
			    $classObj = new wc_os_bulk_order_splitter;
		    }

		    $order = new WC_Order($order_id);

		    if ($originalorderid != null) {
			    $this->original_order_id = $originalorderid;
		    } else {
			    $this->original_order_id = sanitize_wc_os_data($_GET['order_id']);
		    }


		    $original_order = new WC_Order($this->original_order_id);

// Check if Sequential Numbering is installed

		    if ( class_exists( 'WC_Seq_Order_Number_Pro' ) ) {

// Set sequential order number

			    $setnumber = new WC_Seq_Order_Number_Pro;
			    $setnumber->set_sequential_order_number($order_id);

		    }

//pree($order_id.', splitted_from, '.$originalorderid);

		    update_post_meta($order_id, 'splitted_from', $originalorderid);

		    $this->clone_order_header($order_id, $_order_total);
		    $this->clone_order_billing($order_id);
		    $this->clone_order_shipping($order_id);

		    if ($variation_id != 0) {
			    $product = new WC_Product_Variation($variation_id);

		    } else {
			    $product = new WC_Product($product_id);
		    }

//wc_os_pree('$is_virtual');
//wc_os_pree($product->is_virtual('yes'));exit;
		    $is_virtual = ($product->is_virtual('yes'));//($product->virtual=='yes');

//wc_os_pree('$is_virtual: '.$is_virtual);exit;




			
			if(!array_key_exists('wc_os_remove_fees_from_child', $wc_os_general_settings)){
			
				$this->clone_order_fees($order, $original_order);
			
			}			

		    $this->clone_order_coupons($order, $original_order);

		    $this->splitted_order_items($order, $original_order, $product_id, $variation_id, $qty, $_order_total, $order_item_id);



		    if(!$is_virtual) //14/11/2018
			    $this->clone_order_shipping_items($order_id, $original_order, $qty);

		    if(!$original_order->get_total_tax()){
			    delete_post_meta($order_id, 'vat_compliance_country_info');
			    delete_post_meta($order_id, 'wceuvat_conversion_rates');
			    delete_post_meta($order_id, 'vat_compliance_vat_paid');
//delete_post_meta($order_id, 'wc_pos_order_type');
//$order->set_total(0);
				if(!$wc_os_tax_cost)
			    update_post_meta($order_id, 'wos_remove_taxes', true);


		    }
//vat_compliance_country_info
//wc_os_pree(get_post_meta($originalorderid));
//wc_os_pree($original_order->get_total_tax());
//wc_os_pree($order->get_total_tax());
//wc_os_pree(get_post_meta($order_id));
//exit;



		    update_post_meta( $order_id, '_payment_method', get_post_meta($this->original_order_id, '_payment_method', true) );
		    update_post_meta( $order_id, '_payment_method_title', get_post_meta($this->original_order_id, '_payment_method_title', true) );

// Reduce Order Stock
//if($reduce_stock)
//wc_reduce_stock_levels($order_id);

// POSSIBLE CHANGE? - Set status to on hold as payment is not received
		    $order_status = $original_order->get_status();

			//wc_os_pree($order_status);
//wc_os_pree($wc_os_pro);

			$order_status_directed = '';
		    if($wc_os_pro){


				//START >> 05 January 2019 - THIS SECTION IS ADDED TO CONTROL DIFFERENT ORDER STATUSES WITH PRODUCT BASED META KEYS AND VALUES



			    $order_status_by_rule = $classObj->get_order_status_by_rule($order_id, $product_item);
				//wc_os_logger('email', 'splitted_order: '. $order_id.' : '.$product_item.' : '.$order_status_by_rule);			

				
				if($order_status_by_rule){
				
					$order_status_directed = $order_status_by_rule?'wc-'.str_replace('wc-', '', $order_status_by_rule):'';
					
				}else{
				
				//pree($order_status_by_rule);

				    //$order_status = ($order_status_by_rule?$order_status_by_rule:$order_status);
					
				}
				
				//pree($order_status);
				
				

				//wc_os_pree($order_status);
				
				//END << 05 January 2019 - THIS SECTION IS ADDED TO CONTROL DIFFERENT ORDER STATUSES WITH PRODUCT BASED META KEYS AND VALUES

		    }

			//wc_os_logger('email', $order_id.' > '.$order_status_directed);
		    $order_status_directed = ($order_status_directed?$order_status_directed:wc_os_order_split_status_action());
			//wc_os_logger('email', $order_id.' > '.$order_status_directed);
			//pree($order_status_directed);
//pree($order_status);exit;

			//pree($order_id);



		    $order->add_order_note(__('Cloned Order from').' #'.$this->original_order_id.'');


		    $order->calculate_totals();
		    $_order_total = $order->calculate_totals();
		    update_post_meta( $order_id, '_order_total', $_order_total);
// Returns success message on clone completion

		    if(!$this->cron_in_progress){
			    add_action( 'admin_notices', array($this, 'split__success'));
			}

			//pree('$this->meta_keys_clone_from_to('.$order_id.', '.$originalorderid.');');
		    $this->meta_keys_clone_from_to($order_id, $originalorderid);
			
		    if($wc_os_pro){
			    $classObj->wos_clone_order_item_meta_data($order_id, $product_id, $variation_id, $order_item_id);
		    }
			
			sleep(1);
		    if($order_status_directed){
			    //wp_update_post(array('ID'=>$order_id, 'post_status'=>$order_status_directed));
				wc_os_set_order_status($order_id, $order_status_directed);
				wc_os_update_ignored_cron_array($order_id);
				//update_wcfm_order_status($order_id, $order_status_directed);
				//wc_os_logger('email', $order_id.' > '.$order_status_directed);
		    }else{
//$order->update_status($order_status);
				$update_post = array('ID'=>$order_id, 'post_status'=>'wc-'.$order_status);
				
				//pree($update_post);
			    //wp_update_post($update_post);
				
				wc_os_set_order_status($order_id, 'wc-'.$order_status);
				//update_wcfm_order_status($order_id, 'wc-'.$order_status);
		    }

			//exit;
	    }

		/**
		 * Duplicate Order Header meta
		 */
		
		public function clone_order_header($order_id, $_order_total=false){
			
			
			//pree($_order_total);
			if($_order_total){
				
			}else{
				
				$_order_total = get_post_meta($this->original_order_id, '_order_total', true);
				
			}
			
			//pree($_order_total);exit;
			//wc_os_logger('email', '_order_shipping > '.get_post_meta($this->original_order_id, '_order_shipping', true));
			
			update_post_meta( $order_id, '_order_shipping', get_post_meta($this->original_order_id, '_order_shipping', true) );
			update_post_meta( $order_id, '_order_discount', get_post_meta($this->original_order_id, '_order_discount', true) );
			update_post_meta( $order_id, '_cart_discount', get_post_meta($this->original_order_id, '_cart_discount', true) );
			update_post_meta( $order_id, '_order_tax', get_post_meta($this->original_order_id, '_order_tax', true) );
			update_post_meta( $order_id, '_order_shipping_tax', get_post_meta($this->original_order_id, '_order_shipping_tax', true) );
			update_post_meta( $order_id, '_order_total',  sanitize_wc_os_data($_order_total));
	
			update_post_meta( $order_id, '_order_key', 'wc_' . apply_filters('woocommerce_generate_order_key', uniqid('order_') ) );
			update_post_meta( $order_id, '_customer_user', get_post_meta($this->original_order_id, '_customer_user', true) );
			update_post_meta( $order_id, '_order_currency', get_post_meta($this->original_order_id, '_order_currency', true) );
			update_post_meta( $order_id, '_prices_include_tax', get_post_meta($this->original_order_id, '_prices_include_tax', true) );
			update_post_meta( $order_id, '_customer_ip_address', get_post_meta($this->original_order_id, '_customer_ip_address', true) );
			update_post_meta( $order_id, '_customer_user_agent', get_post_meta($this->original_order_id, '_customer_user_agent', true) );
			
	
			$_tribe_tickets_meta = get_post_meta($this->original_order_id, '_tribe_tickets_meta', true);
			if($_tribe_tickets_meta)
			update_post_meta( $order_id, '_tribe_tickets_meta', get_post_meta($this->original_order_id, '_tribe_tickets_meta', true) );
			
		}
		
		/**
		 * Duplicate Order Billing meta
		 */
		
		public function clone_order_billing($order_id){
	
			update_post_meta( $order_id, '_billing_city', get_post_meta($this->original_order_id, '_billing_city', true));
			update_post_meta( $order_id, '_billing_state', get_post_meta($this->original_order_id, '_billing_state', true));
			update_post_meta( $order_id, '_billing_postcode', get_post_meta($this->original_order_id, '_billing_postcode', true));
			update_post_meta( $order_id, '_billing_email', get_post_meta($this->original_order_id, '_billing_email', true));
			update_post_meta( $order_id, '_billing_phone', get_post_meta($this->original_order_id, '_billing_phone', true));
			update_post_meta( $order_id, '_billing_address_1', get_post_meta($this->original_order_id, '_billing_address_1', true));
			update_post_meta( $order_id, '_billing_address_2', get_post_meta($this->original_order_id, '_billing_address_2', true));
			update_post_meta( $order_id, '_billing_country', get_post_meta($this->original_order_id, '_billing_country', true));
			update_post_meta( $order_id, '_billing_first_name', get_post_meta($this->original_order_id, '_billing_first_name', true));
			update_post_meta( $order_id, '_billing_last_name', get_post_meta($this->original_order_id, '_billing_last_name', true));
			update_post_meta( $order_id, '_billing_company', get_post_meta($this->original_order_id, '_billing_company', true));
			
			do_action('clone_extra_billing_fields_hook', $order_id, $this->original_order_id);
			
		}
		
		/**
		 * Duplicate Order Shipping meta
		 */
		
		public function clone_order_shipping($order_id){
	
			update_post_meta( $order_id, '_shipping_country', get_post_meta($this->original_order_id, '_shipping_country', true));
			update_post_meta( $order_id, '_shipping_first_name', get_post_meta($this->original_order_id, '_shipping_first_name', true));
			update_post_meta( $order_id, '_shipping_last_name', get_post_meta($this->original_order_id, '_shipping_last_name', true));
			update_post_meta( $order_id, '_shipping_company', get_post_meta($this->original_order_id, '_shipping_company', true));
			update_post_meta( $order_id, '_shipping_address_1', get_post_meta($this->original_order_id, '_shipping_address_1', true));
			update_post_meta( $order_id, '_shipping_address_2', get_post_meta($this->original_order_id, '_shipping_address_2', true));
			update_post_meta( $order_id, '_shipping_city', get_post_meta($this->original_order_id, '_shipping_city', true));
			update_post_meta( $order_id, '_shipping_state', get_post_meta($this->original_order_id, '_shipping_state', true));
			update_post_meta( $order_id, '_shipping_postcode', get_post_meta($this->original_order_id, '_shipping_postcode', true));
			
			do_action('clone_extra_shipping_fields_hook', $order_id, $this->original_order_id);
			
					
		
		
		}
		
		
		/**
		 * Duplicate Order Fees
		 */
		
		public function clone_order_fees($order, $original_order){
	
			$fee_items = $original_order->get_fees();
	 
			if (empty($fee_items)) {
				
			} else {
				
				foreach($fee_items as $fee_key => $fee_value){
					
					$fee_item  = new WC_Order_Item_Fee();
	
					$fee_item->set_props( array(
						'name'        => $fee_item->get_name(),
						'tax_class'   => $fee_value['tax_class'],
						'tax_status'  => $fee_value['tax_status'],
						'total'       => $fee_value['total'],
						'total_tax'   => $fee_value['total_tax'],
						'taxes'       => $fee_value['taxes'],
					) );

					$order->add_item( $fee_item );	 
					
				}
				
			}
	   
		}
		
		/**
		 * Duplicate Order Coupon
		 */

        public function clone_order_coupons($order, $original_order){

            if(is_object($original_order) && method_exists($original_order, 'get_coupon_codes')) {

                $coupon_items = $original_order->get_coupon_codes();
				$wc_os_skip_default_coupon = get_post_meta($original_order->get_id(), '_wc_os_skip_default_coupon', true);

                if ( empty( $coupon_items ) || $wc_os_skip_default_coupon) {

                } else {

                    foreach ( $original_order->get_items( 'coupon' ) as $coupon_key => $coupon_values ) {

                        $coupon_item = new WC_Order_Item_Coupon();

                        $coupon_item->set_props( array(
                            'name'         => $coupon_values['name'],
                            'code'         => $coupon_values['code'],
                            'discount'     => $coupon_values['discount'],
                            'discount_tax' => $coupon_values['discount_tax'],
                        ) );

                        $order->add_item( $coupon_item );

                    }

                }

            }

        }


		
		/**
		 * Clone Items - v 1.3
		 */
		
		public function clone_order_items($order, $original_order){
			
			//if(is_admin()){ return; }
			
			global $wc_os_pro, $yith_pre_order, $wc_os_debug, $wc_os_tax_cost, $wc_os_meta_handling_arr;
			
			$order_id = $order->get_order_number();
			$order_status = $original_order->get_status();
			
			//pree($original_order->get_id());
			//pree($this->exclude_items);pree($this->include_items);
			$original_order_coupon = $original_order->get_items('coupon');					
			foreach($original_order->get_items() as $order_key => $values){
				//pree($values->get_product_id());
				//pree($values->get_variation_id());
				//exit;
				//pree($values);
				
				if($values->get_variation_id()){
					$applied_product_id = $values->get_variation_id();
				}else{
					$applied_product_id = $values->get_product_id();
				}	
				
				
				if(!empty($this->exclude_items) && (in_array($applied_product_id, $this->exclude_items))){ //07 January 2019 - So we can clone, slice, partially clone and/or partially split an order
					continue;
				}
				
				if(!empty($this->include_items) && (!in_array($applied_product_id, $this->include_items))){ //07 January 2019 - So we can clone, slice, partially clone and/or partially split an order
					continue;
				}				
				
				//wc_os_pree($values['product_id']);
					
		
				//$order->update_status(($this->processing?'completed':$order_status));
				if($wc_os_pro){
					//START >> 05 January 2019 - THIS SECTION IS ADDED TO CONTROL DIFFERENT ORDER STATUSES WITH PRODUCT BASED META KEYS AND VALUES	
					
					$meta_kv = get_post_meta($applied_product_id);
					$meta_kv = (is_array($meta_kv)?$meta_kv:array());
					if($yith_pre_order){
							
						if(array_key_exists('_ywpo_preorder', $meta_kv)){						
							$order_status = 'wc-on-hold';
							update_post_meta( $order_id, '_order_has_preorder', $meta_kv['_ywpo_preorder'][0]);
						}

					}
					//wc_os_pree($wc_os_rules);
					//wc_os_pree($meta_kv);
					
					//wc_os_pree('$cross_match');
					//wc_os_pree($cross_match);
					
					
					// wc_os_logger('email', 'clone_order_items: '. $order_id.' : '.$applied_product_id.' : '.$order_status);			
	
					//END << 05 January 2019 - THIS SECTION IS ADDED TO CONTROL DIFFERENT ORDER STATUSES WITH PRODUCT BASED META KEYS AND VALUES
					
				}
				
				if ($values['variation_id'] != 0) {
					$product = new WC_Product_Variation($values['variation_id']);
				
				} else {
					$product = new WC_Product($values['product_id']);	
				}
				
				//wc_os_pree($product->is_type( 'variation' )?'variation':'product');
				
				$product_id = (method_exists($product, 'get_type') && $product->get_type()=='variation') ? $product->get_parent_id() : $product->get_id();
				$qty_item_id = (method_exists($product, 'get_type') && $product->get_type()=='variation' ? $product->get_id():$values['product_id']);
				
				//wc_os_pree($product->get_parent_id().' - '.$product->get_id());
				
				$unit_price = $product->get_price();
				
				$item                       = new WC_Order_Item_Product();
				$item->legacy_values        = $values;
				$item->legacy_cart_item_key = $order_key;
				
				//wc_os_pree($this->include_items_qty);
				
				//wc_os_pree($product_id);
				//wc_os_pree($qty_item_id);
				
				$product_qty = ((is_array($this->include_items_qty) && (array_key_exists($qty_item_id, $this->include_items_qty)))?$this->include_items_qty[$qty_item_id]:$values['quantity']);
				
				if(in_array($this->auto_split , $wc_os_meta_handling_arr)){	

                    $product_qty = $values['quantity'];

                }

				//wc_os_pree($product_qty);
				
				//pree(($product_qty.' <= '.$values['quantity'].' ? '.$product_qty.' : '.$values['quantity']));
				
				//wc_os_pree('$unit_price: '.$unit_price.', line_subtotal: '.$values['line_subtotal'].', quantity: '.$values['quantity']);
				
				
				$line_price = ($values['quantity']>=1?($values['line_total']/$values['quantity']):$values['line_total']);
				$discount_price = ($values['subtotal'] - $values['total']);
                $line_price = (!empty($original_order_coupon) && $discount_price > 0 ? $line_price + $discount_price : $line_price);
				
				
				$set_props = array(
					'quantity'     => $product_qty,
					//'quantity'     => ($product_qty<=$values['quantity']?$product_qty:$values['quantity']),//24/10/2019 because new provided qty should be within ordered qty.
					'variation'    => $values['variation'],					
					'subtotal_tax' => 0,
					'total_tax'    => 0,
					'taxes'        => array(),
				);
				
				if($wc_os_tax_cost){
					$set_props['subtotal_tax'] = $values['line_subtotal_tax'];
					$set_props['total_tax'] = $values['line_tax'];
					$set_props['taxes'] = $values['line_tax_data'];
				}	
								
				//pree('clone_order_items');exit;
				if($line_price!=$unit_price){
					$total = $line_price*$set_props['quantity'];
				}else{
					$total = false;
				}
				//pree($total);
				//wc_os_pree('$unit_price: '.$unit_price.', '.'$product_qty: '.$product_qty.', quantity: '.$values['quantity'].', line_total: '.$values['line_total'].', price: '.$line_price.', $total: '.$total);
				
				$set_props['subtotal'] = ($total?$total:$unit_price*$set_props['quantity']);
				$set_props['total'] = ($total?$total:$unit_price*$set_props['quantity']);
				
				//wc_os_pree($set_props);
				$item->set_props($set_props);
				
				//pree($product->get_name().' - '.$values->get_name());
				
				if ( $product ) {
					$item->set_props( array(
						'name'         => $values->get_name(),
						'tax_class'    => $product->get_tax_class(),
						'product_id'   => $product_id,
						'variation_id' => (method_exists($product, 'get_type') && $product->get_type()=='variation') ? $product->get_id() : 0,
					) );
				}
				$item->add_meta_data('_old_item_id', $order_key);
				//wc_os_pree($item);//exit;
				
				//if(array_key_exists($product_id, $this->include_items_qty))
				$item->set_backorder_meta();
				
				if($product_qty){
					
					
					//$wc_get_order_item_meta = wc_get_order_item_meta($order_key, '');
					//pree($wc_get_order_item_meta);
					
					$order->add_item( $item );
					//wc_delete_order_item_meta(, 'split');
				}else{
					//if($wc_os_debug)
					//wc_os_pree('product_qty = '.$product_qty);
				}
			 
			}
			//exit;
			
		}
		
		public function clone_order_items_by_item($order, $original_order){

            //if(is_admin()){ return; }

            global $wc_os_pro, $yith_pre_order, $wc_os_debug, $wc_os_tax_cost, $wc_os_meta_handling_arr;

            $order_id = $order->get_order_number();
            $order_status = $original_order->get_status();


            //pree($original_order->get_id());
            //pree($this->exclude_items);pree($this->include_items);
            $original_order_coupon = $original_order->get_items('coupon');
            foreach($original_order->get_items() as $order_key => $values){
                //pree($values->get_product_id());
                //pree($values->get_variation_id());
                //exit;
                //pree($values);

                if($values->get_variation_id()){
                    $applied_product_id = $values->get_variation_id();
                }else{
                    $applied_product_id = $values->get_product_id();
                }


                if(!empty($this->exclude_items) && (in_array($order_key, $this->exclude_items))){ //07 January 2019 - So we can clone, slice, partially clone and/or partially split an order
                    continue;
                }

                if(!empty($this->include_items) && (!in_array($order_key, $this->include_items))){ //07 January 2019 - So we can clone, slice, partially clone and/or partially split an order
                    continue;
                }

                //wc_os_pree($values['product_id']);




                //$order->update_status(($this->processing?'completed':$order_status));
                if($wc_os_pro){
                    //START >> 05 January 2019 - THIS SECTION IS ADDED TO CONTROL DIFFERENT ORDER STATUSES WITH PRODUCT BASED META KEYS AND VALUES

                    $meta_kv = get_post_meta($applied_product_id);
                    $meta_kv = (is_array($meta_kv)?$meta_kv:array());
					if($yith_pre_order){

						if(array_key_exists('_ywpo_preorder', $meta_kv)){
							$order_status = 'wc-on-hold';
							update_post_meta( $order_id, '_order_has_preorder', $meta_kv['_ywpo_preorder'][0]);
						}

					}
                    //wc_os_pree($wc_os_rules);
                    //wc_os_pree($meta_kv);

                    //wc_os_pree('$cross_match');
                    //wc_os_pree($cross_match);
					
					//wc_os_logger('email', 'clone_order_items_by_item: '. $order_id.' : '.$applied_product_id.' : '.$order_status);

                    //END << 05 January 2019 - THIS SECTION IS ADDED TO CONTROL DIFFERENT ORDER STATUSES WITH PRODUCT BASED META KEYS AND VALUES

                }

                if ($values['variation_id'] != 0) {
                    $product = new WC_Product_Variation($values['variation_id']);

                } else {
                    $product = new WC_Product($values['product_id']);
                }

                //wc_os_pree($product->is_type( 'variation' )?'variation':'product');

                $product_id = (method_exists($product, 'get_type') && $product->get_type()=='variation') ? $product->get_parent_id() : $product->get_id();
                $qty_item_id = (method_exists($product, 'get_type') && $product->get_type()=='variation' ? $product->get_id():$values['product_id']);


                $unit_price = $product->get_price();

                $item                       = new WC_Order_Item_Product();
                $item->legacy_values        = $values;
                $item->legacy_cart_item_key = $order_key;

                $product_qty = $values['quantity'];

                $line_price = ($product_qty>=1?($values['line_total']/$product_qty):$values['line_total']);
                $discount_price = ($values['subtotal'] - $values['total']);
                $line_price = (!empty($original_order_coupon) && $discount_price > 0 ? $line_price + $discount_price : $line_price);


                $set_props = array(
                    'quantity'     => $product_qty,
                    'variation'    => $values['variation'],
                    'subtotal_tax' => 0,
                    'total_tax'    => 0,
                    'taxes'        => array(),
                );

                if($wc_os_tax_cost){
                    $set_props['subtotal_tax'] = $values['line_subtotal_tax'];
                    $set_props['total_tax'] = $values['line_tax'];
                    $set_props['taxes'] = $values['line_tax_data'];
                }

                if($line_price!=$unit_price){
                    $total = $line_price*$set_props['quantity'];
                }else{
                    $total = false;
                }

                $set_props['subtotal'] = ($total?$total:$unit_price*$set_props['quantity']);
                $set_props['total'] = ($total?$total:$unit_price*$set_props['quantity']);

                $item->set_props($set_props);

                if ( $product ) {
                    $item->set_props( array(
                        'name'         => $values->get_name(),
                        'tax_class'    => $product->get_tax_class(),
                        'product_id'   => $product_id,
                        'variation_id' => (method_exists($product, 'get_type') && $product->get_type()=='variation') ? $product->get_id() : 0,
                    ) );
                }
                $item->add_meta_data('_old_item_id', $order_key);
                //wc_os_pree($item);//exit;

                //if(array_key_exists($product_id, $this->include_items_qty))
                $item->set_backorder_meta();



                if($product_qty){
                    $order->add_item( $item );
                }

            }

        }

	    public function splitted_order_items($order, $original_order, $product_id, $variation_id, $qty=false, $total=false, $order_item_id=0){
//pree('splitted_order_items');exit;
			//pree($order_item_id);
			
			global $wc_os_tax_cost, $wc_os_general_settings;
			
			$item_meta_data = array();
			
			if($order_item_id){
				
				$item_meta_data = wc_get_order_item_meta($order_item_id, '');
				//pree($item_meta_data);//exit;
				
				if(!empty($item_meta_data)){
					
					$item_meta_data['_line_total'] = (array_key_exists('_line_total', $item_meta_data)?$item_meta_data['_line_total']:array());
							
					$item_meta_data['_line_total'] = round(current($item_meta_data['_line_total']), 2);
					
					$order_item_uniqueness = base64_encode(serialize($item_meta_data));
					
				}
			
			}
			//echo $order_item_uniqueness;
			//exit;

		    foreach($original_order->get_items() as $order_key => $values){

			    $get_total = round($values->get_total(), 2);
				
				//pree($order_key);


			    


			    if ($values['variation_id'] != 0) {
				    $product = new WC_Product_Variation($values['variation_id']);

			    } else {
				    $product = new WC_Product($values['product_id']);
			    }

			    $unit_price = $product->get_price();

			    if(
				    (
					    ($values['variation_id'] != 0 && $variation_id==$values['variation_id'] && $product_id==$values['product_id'])
					    ||
					    ($values['variation_id'] == 0 && $product_id==$values['product_id'])

				    )

				    &&

                    (
					   $order_item_id == 0 || ($order_item_id > 0 && $item_meta_data['_line_total']==$get_total && $order_item_id==$order_key)
					   
				    )

			    ){
			    }else{
				    continue;
			    }


			    $item = new WC_Order_Item_Product();
			    $item->legacy_values = $values;
			    $item->legacy_cart_item_key = $order_key;



//wc_os_pree($qty);
//wc_os_pree($values);//exit;
//wc_os_pree($unit_price);


			    $line_price = ($values['quantity']>=1?($values['line_total']/$values['quantity']):$values['line_total']);

//wc_os_pree('$unit_price: '.$unit_price.', '.'$qty: '.$qty.', quantity: '.$values['quantity'].', line_total: '.$values['line_total'].', price: '.$line_price.', $total: '.$total);

			    $set_props = array(
				    'quantity' => ($qty?$qty:$values['quantity']),
				    'variation' => $values['variation'],
				    'subtotal_tax' => 0,
				    'total_tax' => 0,
				    'taxes' => array(),
			    );
				
				if($wc_os_tax_cost){
					$set_props['subtotal_tax'] = $values['line_subtotal_tax'];
					$set_props['total_tax'] = $values['line_tax'];
					$set_props['taxes'] = $values['line_tax_data'];
				}				
//pree($set_props);exit;
//pree($total);
//wc_os_pree('$unit_price: '.$unit_price.' != $line_price: '.$line_price);
			    if($line_price!=$unit_price){
				    $total = $line_price*$set_props['quantity'];
			    }else{
				    $total = false;
			    }
//pree($total);

			    $set_props['subtotal'] = ($total?$total:$unit_price*$set_props['quantity']);
			    $set_props['total'] = ($total?$total:$unit_price*$set_props['quantity']);
				
				if(array_key_exists('wc_os_remove_price_from_child', $wc_os_general_settings)){
					$set_props['total'] = $set_props['subtotal'] = 0;
				}

//wc_os_pree($set_props);

			    $item->set_props( $set_props );

			    if ( is_object($product) ) {
				    $set_pros = array(
					    'name' => $product->get_name(),
					    'tax_class' => $product->get_tax_class(),
					    'product_id' => (method_exists($product, 'get_type') && $product->get_type()=='variation') ? $product->get_parent_id() : $product->get_id(),
					    'variation_id' => (method_exists($product, 'get_type') && $product->get_type()=='variation' ) ? $product->get_id() : 0,
				    );
//wc_os_pree($set_pros);exit;
				    $item->set_props( $set_pros );
			    }

			    $item->set_backorder_meta();

//wc_os_pree($item);exit;

			    $order->add_item( $item );

			    /*
				*/


		    }




//exit;
	    }


		/**
		 * Clone success
		 */
		
		function clone__success() {
		
			$class = 'notice notice-success is-dismissible';
			$message = __( 'Order has been updated successfully.', 'woo-order-splitter' );
		
			printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message ); 
	
		}
		
		function split__success() {
		
			$class = 'notice notice-success is-dismissible';
			$message = __( 'Order Splitted.', 'woo-order-splitter' );
		
			printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message ); 
	
		}	
		
		/**
		 * Clone error
		 */
		
		function merge__error() {
			$class = 'notice notice-error';
			$message = __( 'Consolidation Failed an error has occurred.', 'woo-order-splitter' );
		
			printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message ); 
		}
				
		function clone__error() {
			$class = 'notice notice-error';
			$message = __( 'Duplication Failed an error has occurred.', 'woo-order-splitter' );
		
			printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message ); 
		}
		
		
		function split__error() {
			$class = 'notice notice-error';
			$message = __( 'Split Failed an error has occurred.', 'woo-order-splitter' );
		
			printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message ); 
		}
			
		
		/**
		 * Duplicate Shipping Item Meta
		 * v1.4 - Shipping is added with order items
		 */
		
		public function clone_order_shipping_items($order_id=0, $original_order=array(), $qty=false, $clone_shipping=false){
			//pree($order_id);pree($original_order);pree($qty);pree($clone_shipping);
		 	
			if(empty($original_order) && !$order_id){ //TROUBLESHOOTING SECTION
				$order_id = $order_id?$order_id:sanitize_wc_os_data($_GET['post']);
				$parent_order_id = get_post_meta($order_id, 'splitted_from', true);
				//pree($parent_order_id);
				//echo class_exists('WC_Order');
				//pree(function_exists('wc_get_order'));
				$original_order = $parent_order_id?wc_get_order($parent_order_id):$original_order;
				//pree(wc_get_order($parent_order_id));
				//pree($original_order);
			}
			//pree($order_id);
			$original_order_shipping_items = !empty($original_order)?$original_order->get_items('shipping'):array();
			$_vendor_id = get_post_meta($order_id, '_vendor_id', true);
			//pree($_vendor_id);
			$_vendor_id = (is_numeric($_vendor_id)?$_vendor_id:0);
			//pree($_vendor_id);
			
			$vendor_related_items = array();
			$items_data = array();
			//pree($order_id);
			$child_order = wc_get_order($order_id);
			//pree($child_order);
			//pree($child_order->get_items());exit;
			$shipclass_off = '';
			foreach($child_order->get_items() as $cart_key=>$item_values){
				$pid = $item_values->get_product_id();
				$vid = $item_values->get_variation_id();	
				$product_item = $vid?$vid:$pid;
				
				$_product = wc_get_product($product_item);
				$get_shipping_class = $_product->get_shipping_class();
				//pree($shipclass);
				if(!$shipclass_off){
					$shipclass_off = ($get_shipping_class=='');
				}
				
				//pree($product_item.' - '.$shipclass_off);
			}
			
			
			$_clone_shipping = ($shipclass_off=='' || $shipclass_off==false);
			//pree($product_item.' - '.$_clone_shipping);
			$clone_shipping = (($clone_shipping==true && $_clone_shipping==true) || $this->force_clone_in_progress);
			//pree($product_item.' - '.$clone_shipping);
			if($clone_shipping){
				$this->clone_order_shipping($order_id);
				//add_filter('woocommerce_order_is_vat_exempt', function(){ return true; });
				
			}
			//pree($original_order_shipping_items);
			
	
			foreach ( $original_order_shipping_items as $order_item ) {
				$item_id = 0;
				//wc_os_pree($original_order_shipping_item);
				//wc_os_pree(wc_format_decimal($original_order_shipping_item['cost']));exit;
				$cost = wc_format_decimal( $order_item['cost'] );
				//wc_os_pree($cost);
				if($cost && $qty){ //22/05/2019
					$qty_total = wc_order_total_qty($original_order);
					//wc_os_pree($qty_total);
					$per_item_cost = ($cost/$qty_total);
					//wc_os_pree($per_item_cost);
					
					//$qty_total_new = wc_order_total_qty($order);
					//wc_os_pree($qty_total_new);
					
					//$cost = ($qty_total_new*$per_item_cost);
					//wc_os_pree($cost);
					$cost = ($qty*$per_item_cost);
					//wc_os_pree($cost);
				}
				//exit;
				if($clone_shipping){
					//pree('keep');
					$item_id = wc_add_order_item( $order_id, array(
						'order_item_name'       => $order_item['name'],
						'order_item_type'       => 'shipping'
					) );
				}else{
					//pree('delete');
				}
	
				if ( $item_id ) {
					
					
					
					
					
					$order_item_meta = wc_get_order_item_meta( $order_item->get_id(), '');
					
					
					
					
					if(!empty($order_item_meta)){
						
						foreach($order_item_meta as $order_item_key => $order_item_value){
							
							$order_item_value = maybe_unserialize(current($order_item_value));							
							$items_data[$item_id][$order_item_key] = $order_item_value;
							
							switch($order_item_key){
								case 'vendor_id':
									//pree($order_item_value);
									if($_vendor_id && $_vendor_id==$order_item_value){
										$vendor_related_items[$_vendor_id] = $item_id;
									}
								break;
							}
						}
						//wc_add_order_item_meta( $item_id, 'method_id', $original_order_shipping_item['method_id'] );
						//wc_add_order_item_meta( $item_id, 'cost',  $cost );
					}
				}
	
			}
			if(!empty($items_data)){
				//pree($items_data);
				//pree($vendor_related_items);
				if(!empty($vendor_related_items)){
					$items_data_updated = array();
					foreach($vendor_related_items as $vendor_id=>$item_id){						
						$items_data_updated[$item_id] = $items_data[$item_id];
					}
					if(!empty($items_data_updated)){
						$items_data = $items_data_updated;
					}
				}
				//pree($items_data);exit;
				foreach($items_data as $item_id=>$item_data){
					
					if(!empty($item_data)){
						foreach($item_data as $item_key=>$item_value){
							wc_add_order_item_meta( $item_id, $item_key,  $item_value );
						}
					}
					
				}
			}
			//exit;   
			
		}
		
	}
	
	global $wc_os_order_splitter;
	
	
	function wc_os_currency_symbol(){
		return (function_exists('get_woocommerce_currency_symbol')?get_woocommerce_currency_symbol():'$');
	}

	include_once('wos-emails.php');
	
	function sanitize_wc_os_data( $input ) {
		if(is_array($input)){		
			$new_input = array();	
			foreach ( $input as $key => $val ) {
				$new_input[ $key ] = (is_array($val)?sanitize_wc_os_data($val):stripslashes(sanitize_text_field( $val )));
			}			
		}else{
			$new_input = stripslashes(sanitize_text_field($input));			
			if(stripos($new_input, '@') && is_email($new_input)){
				$new_input = sanitize_email($new_input);
			}
			if(stripos($new_input, 'http') || wp_http_validate_url($new_input)){
				$new_input = esc_url($new_input);
			}			
		}	
		return $new_input;
	}	
	
	
	if(!function_exists('wc_os_pre')){
	function wc_os_pre($data){
			if(isset($_GET['debug'])){
				wc_os_pree($data);
			}
		}	 
	} 	
	if(!function_exists('wc_os_pree')){
	function wc_os_pree($data){
				echo '<pre>';
				print_r($data);
				echo '</pre>';	
		
		}	 
	} 
	
	include('functions-inner.php');
	
	function wc_os_is_orders_list(){
		//wp-admin/edit.php?post_type=shop_order
		global $pagenow;
		return (is_admin() && $pagenow=='edit.php' && isset($_REQUEST['post_type']) && $_REQUEST['post_type']=='shop_order');
		
		//(isset($_GET['post_type']) && $_GET['post_type']=='shop_order');
	}
	
	
	function wc_os_update_cron_status_hooks(){
		
		global $wc_os_cron_settings;
		
		$status_hooks = WC_OS_PLUGIN_DIR . '/inc/sections/wc_os_order_status_hooks.php';
		
		
						
		
		$status_hooks_data = '<?php 
		
		';
		
		$order_statuses = function_exists('wc_get_order_statuses')?wc_get_order_statuses():array();
		
		if(in_array('thankyou', $wc_os_cron_settings['statuses'])){
			$status_hooks_data .= '
add_action("woocommerce_thankyou", "wc_os_checkout_order_processed", 10, 1);
				';
		}
		if(in_array('woocommerce_checkout_order_processed', $wc_os_cron_settings['statuses'])){
			$status_hooks_data .= '
add_action("woocommerce_checkout_order_processed", "wc_os_checkout_order_processed", 2, 1);
				';
			
		}
		
		if(!empty($order_statuses)){
			
			foreach($order_statuses as $slug=>$title){ 
				$status = str_replace('wc-', '', $slug);
				if(in_array($status, $wc_os_cron_settings['statuses'])){
					$status_hooks_data .= '
	add_action("woocommerce_order_status_'.$status.'", "wc_os_checkout_order_processed", 10, 1);
					';
				}
			}
			
			try{
				$f = fopen($status_hooks, 'w');
				fwrite($f, $status_hooks_data);
				fclose($f);
			}						
			catch(Exception $e) {
			  echo 'Message: ' .$e->getMessage();
			}
		}
						
	}
	
	function wc_os_settings_update(){

        global $wc_os_general_settings;
		
		//wc_os_pree($_POST);exit;

        /*if(class_exists('wc_os_order_splitter')){
            $wc_os_order_splitter = new wc_os_order_splitter;
            $wc_os_order_splitter->meta_keys_clone_from_to(8565, 8556);exit;
        }*/


		wc_os_crons();

		if(!empty($_POST)){
			//wc_os_pree($_POST);exit;
			//wc_os_pree($_POST);exit;
			global $wc_os_currency, $wc_os_settings, $wc_os_cron_settings;
			$split_action = (isset($_POST['split_action'])?sanitize_wc_os_data($_POST['split_action']):array());
            $products_split_action = isset($_POST['products_split_action']) ? sanitize_wc_os_data($_POST['products_split_action']): array();
            $products_split_action_filtered = array_filter($products_split_action);
			
			//wc_os_pree($split_action);
			//wc_os_pree($_POST);exit;
			//pree($wc_os_settings);exit;
			

			if(!empty($_POST) && isset($_POST['wc_os_statuses'])){

		        if (
			        ! isset( $_POST['wc_os_crons_field'] )
			        || ! wp_verify_nonce( $_POST['wc_os_crons_field'], 'wc_os_crons_action' )
		        ) {

			        _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
			        exit;

		        } else {


					
					$wc_os_cron_settings['statuses'] = sanitize_wc_os_data($_POST['wc_os_statuses']);
					
			        update_option('wc_os_cron_settings', $wc_os_cron_settings);
					
					

		        }
	        }
			
			
			if(!empty($_POST) && isset($_POST['wc_os_settings']) && isset( $_POST['wc_os_settings_field'])){


				$wc_os_currency = wc_os_currency_symbol();

				wc_os_settings_refresh();
				//wc_os_pree($_POST);exit;





				if (! wp_verify_nonce( $_POST['wc_os_settings_field'], 'wc_os_settings_action' )
				) {

				   _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
				   exit;

				} else {

				   // process form data

                    if(array_key_exists('io_options', $_POST['wc_os_settings'])){

                        $io_options = sanitize_wc_os_data($_POST['wc_os_settings']['io_options']);
                        update_option('wc_os_io_options', $io_options);

                    }		
					
                    if(isset($_POST['wc_os_method_options'])){

                        $wc_os_method_options = sanitize_wc_os_data($_POST['wc_os_method_options']);
                        wc_os_update_method_options($wc_os_method_options);

                    }
							   		
						
					if(!isset($_POST['wc_os_general_settings'])) {
												
				   		$wos_valid_product_actions = array_key_exists('wos_valid_product_actions', $_POST)?sanitize_wc_os_data($_POST['wos_valid_product_actions']):array();
						$wos_valid_product_actions = (!empty($wos_valid_product_actions)?explode(',', $wos_valid_product_actions):array());
						$wos_valid_product_actions = array_filter($wos_valid_product_actions);
						
						//pree($wos_valid_product_actions);exit;
				   		$split_action_existing = array();
						if(!empty($wc_os_settings['wc_os_products'])){
							foreach($wc_os_settings['wc_os_products'] as $action_old=>$data_old){
								if(!empty($data_old)){
									//wc_os_pree($split_action_existing);
									foreach($data_old as $item_old){

										$item_old_arr = (is_array($item_old)?$item_old:array($item_old));

										foreach($item_old_arr as $item_old){
											$split_action_existing[$item_old] = $action_old;
										}

										//wc_os_pree($item_old);
										//wc_os_pree($action_old);
									}
								}
							}
						}

						//pree($split_action);
						//wc_os_pree($_POST);exit;
						$wc_os_additional = (isset($_POST['wc_os_settings']['wc_os_additional']));

						$wc_os_settings_updated = sanitize_wc_os_data($_POST['wc_os_settings'] );
						//wc_os_pree($split_action_existing);
						//wc_os_pree($wc_os_settings);

						//wc_os_pree($wc_os_settings_updated);exit;

						$wc_os_settings_updated['wc_os_products'] = (isset($wc_os_settings_updated['wc_os_products']) && is_array($wc_os_settings_updated['wc_os_products']))?$wc_os_settings_updated['wc_os_products']:(isset($wc_os_settings['wc_os_products'])?$wc_os_settings['wc_os_products']:'');
						
						$wc_os_settings_updated['wc_os_group_statuses'] = (array_key_exists('wc_os_group_statuses', $wc_os_settings) ? $wc_os_settings['wc_os_group_statuses'] : array());

						$wc_os_settings_updated['wc_os_ie'] = isset($wc_os_settings_updated['wc_os_ie'])?$wc_os_settings_updated['wc_os_ie']:$wc_os_settings['wc_os_ie'];

						$wc_os_settings_updated['wc_os_cats'] = ((isset($wc_os_settings['wc_os_cats']) && is_array($wc_os_settings['wc_os_cats']))?$wc_os_settings['wc_os_cats']:array());

						$wc_os_settings_updated['wc_os_qty_split_option'] = isset($wc_os_settings_updated['wc_os_qty_split_option'])?$wc_os_settings_updated['wc_os_qty_split_option']:(isset($wc_os_settings['wc_os_qty_split_option'])?$wc_os_settings['wc_os_qty_split_option']:'');

						$wc_os_settings_updated['wc_os_additional'] = (isset($wc_os_settings_updated['wc_os_additional']) && is_array($wc_os_settings_updated['wc_os_additional']))?$wc_os_settings_updated['wc_os_additional']:(isset($wc_os_settings['wc_os_additional'])?$wc_os_settings['wc_os_additional']:'');
						
						$wc_os_settings_updated['wc_os_cats']['split_ratio'] = ((isset($wc_os_settings_updated['wc_os_cats']['split_ratio']) && $wc_os_settings_updated['wc_os_cats']['split_ratio']!='')?$wc_os_settings_updated['wc_os_cats']['split_ratio']:'');

						//pree($wc_os_settings);
						//pree($wc_os_settings_updated);exit;
						//pree('AAA');exit;
						//pree($wc_os_settings_updated['wc_os_ie']);exit;
						//exit;
						/*
						if isset() has more than one variable submitted to it,
						then all variables must return true for for isset to be true.
						So isset($a, $b) is the same as isset($a) && isset($b).
						The reason I am checking both variables is because if
						$wc_os_settings_updated['wc_os_all_product'] is not checked,
						it is not submitted with the form.
						Since it is on the same form as $wc_os_settings_updated['wc_os_ie'],
						I can test to see if that field has been submitted to verify that the form is
						telling us that $wc_os_settings_updated['wc_os_all_product'] is unchecked.
						http://php.net/manual/en/function.isset.php
						*/
						//pree($split_action);
						//pree($wc_os_settings_updated['wc_os_ie']);
						//pree($_POST);exit;
						//pree($wos_valid_product_actions);
						$wc_os_products_existing = $wc_os_settings['wc_os_products'];
						$wc_os_products_groups_existing = array_key_exists('groups', $wc_os_settings['wc_os_products'])?$wc_os_settings['wc_os_products']['groups']:array();
						
						//pree($wc_os_products_groups_existing);
						
						$items_methods = array();
						
						if(!empty($wc_os_products_existing)){
							foreach($wc_os_products_existing as $method=>$items_arr){		
								if(!empty($items_arr)){
									foreach($items_arr as $item_single){						
										if(!is_array($item_single) && $item_single){
											$items_methods[$item_single] = $method;
										}
									}
								}
							}
						}
						
						$items_groups = array();
						//pree($wc_os_products_groups_existing);
						if(!empty($wc_os_products_groups_existing)){
							foreach($wc_os_products_groups_existing as $method=>$items_arr){		
								//pree($method);
								if(is_array($items_arr) && !empty($items_arr)){
									foreach($items_arr as $item_single){						
										if(!is_array($item_single) && $item_single){
											$items_groups[$item_single] = $method;
										}
									}
								}
							}
						}						
						//pree($items_groups);
						/*
						$updated_items_methods = array();
						if(!empty($wc_os_settings_updated['wc_os_products'])){
							foreach($wc_os_settings_updated['wc_os_products'] as $method=>$items_arr){		
								if(!empty($items_arr)){
									foreach($items_arr as $item_single){						
										if(!is_array($item_single) && $item_single){
											$updated_items_methods[$item_single] = $method;
										}
									}
								}
							}
						}		
						*/				
						//pree($items_methods);
						//pree($updated_items_methods);
						
						//$wos_valid_product_actions
						if(!empty($items_methods)){
							foreach($items_methods as $item_key=>$item_method){
								if(!in_array($item_key, $wos_valid_product_actions)){
									$wc_os_settings_updated['wc_os_products'][$item_method][] = $item_key;
								}
							}
						}
						if(!empty($items_groups)){
							foreach($items_groups as $item_key=>$item_method){
								if(!in_array($item_key, $wos_valid_product_actions)){
									$wc_os_settings_updated['wc_os_products']['groups'][$item_method][] = $item_key;
								}
							}
						}						
						//$items_groups
						//pree($wc_os_settings_updated['wc_os_products']);exit;
						
						//exit;
						//pree($wc_os_products_existing);//exit;
						$wc_os_settings_updated['wc_os_all_products'] = isset($wc_os_settings_updated['wc_os_all_product'],$wc_os_settings_updated['wc_os_ie'])?true:(isset($wc_os_settings['wc_os_all_product'])?$wc_os_settings['wc_os_all_product']:'');
						
						$wc_os_settings_updated['wc_os_vendors'] = isset($wc_os_settings['wc_os_vendors'])?$wc_os_settings['wc_os_vendors']:array();
						$wc_os_settings_updated['wc_os_woo_vendors'] = isset($wc_os_settings['wc_os_woo_vendors'])?$wc_os_settings['wc_os_woo_vendors']:array();						
						//wc_os_pree($wc_os_settings_updated['wc_os_products']);
						$wc_os_settings_updated['wc_os_products'] = array_merge($wc_os_products_existing, $wc_os_settings_updated['wc_os_products']);
						//wc_os_pree($wc_os_settings_updated['wc_os_products']);
						$wc_os_settings_updated['wc_os_products'] = (!empty($wc_os_settings_updated['wc_os_products'])?array_filter($wc_os_settings_updated['wc_os_products'], 'is_array'):array());
						
						$wc_os_settings_updated['wc_os_attributes'] = isset($wc_os_settings['wc_os_attributes'])?$wc_os_settings['wc_os_attributes']:array();
						
						$wc_os_settings_updated['wc_os_attributes_values'] = isset($wc_os_settings['wc_os_attributes_values'])?$wc_os_settings['wc_os_attributes_values']:array();
						
						$wc_os_settings_updated['wc_os_attributes_group'] = isset($wc_os_settings['wc_os_attributes_group'])?$wc_os_settings['wc_os_attributes_group']:array();
					
						//pree($_POST);exit;
						
						//pree($wc_os_settings_updated['wc_os_products']);exit;//$wos_valid_product_actions
						//pree($wc_os_settings_updated['wc_os_products']);

						//wc_os_pree($wc_os_settings_updated['wc_os_products']);
						if(!empty($wc_os_settings_updated['wc_os_products'])){ //07-05-2019
							foreach($wc_os_settings_updated['wc_os_products'] as $item_action=>$item_ids){

								//pree($item_action);//pree($item_ids);
								//$wc_os_settings_updated['wc_os_products']
								if(!empty($item_ids)){
									foreach($item_ids as $index=>$item_id_item){
										//wc_os_pree('$index');
										//wc_os_pree($index);
										//wc_os_pree('$item_id');
										//wc_os_pree($item_id_item);
										//wc_os_pree($item_id);
										$item_id_arr = (is_array($item_id_item)?$item_id_item:array($item_id_item));

										//wc_os_pree($item_id_arr);

										foreach($item_id_arr as $item_id){

											//pree($split_action);pree($split_action_existing);

											$item_action_valid = ((is_array($products_split_action_filtered) && isset($products_split_action_filtered[$item_id]))?$products_split_action_filtered[$item_id]:(isset($split_action_existing[$item_id])?$split_action_existing[$item_id]:''));
											//wc_os_pree($item_action_valid.' - '.$item_action);
											//pree($item_action.' && '.$item_action_valid);
											if($item_action_valid==$item_action){
											}elseif($item_action && $item_action_valid){

												//pree($item_action.' && '.$index);
												if(is_numeric($index)){
													unset($wc_os_settings_updated['wc_os_products'][$item_action][$index]);
												}
												$wc_os_settings_updated['wc_os_products'][$item_action_valid][] = $item_id;
											}
										}
									}
								}
							}
							$wc_os_settings_updated['wc_os_products'] = wos_array_unique_recursive($wc_os_settings_updated['wc_os_products']);
						}
						//wc_os_pree($wc_os_settings_updated['wc_os_products']);
						
						

						//exit;
						//wc_os_pree(sanitize_wc_os_data($wc_os_settings_updated));exit;
						//pree($wc_os_settings_updated);//exit;
						//unset($wc_os_settings_updated['wc_os_products']['b']);
						//unset($wc_os_settings_updated['wc_os_products']['c']);
						//wc_os_pree($_POST);exit;
                        if(!empty($wc_os_settings_updated['wc_os_products'])){
						    foreach($wc_os_settings_updated['wc_os_products'] as $method => $method_products){
						        if($method == 'groups'){
						            continue;
                                }

						        if(!empty($method_products)){
						            foreach($method_products as $product_index => $product_id){

						                if(array_key_exists($product_id, $products_split_action) && !$products_split_action[$product_id]){
                                            unset($wc_os_settings_updated['wc_os_products'][$method][$product_index]);
                                        }
                                    }
                                }
                            }
                        }
                        if(function_exists('wc_os_save_group_statuses')){wc_os_save_group_statuses($wc_os_settings_updated);}						
						update_option('wc_os_settings', sanitize_wc_os_data($wc_os_settings_updated));
						//exit;

						//add_action( 'admin_notices', 'wc_os_admin_notice_success' );

						//pree($_POST);
					}
					//pree($wc_os_general_settings);//exit;	
					if(isset($_POST['wc_os_general_settings'])){
												
						
						if(array_key_exists('wc_os_settings', $_POST) && array_key_exists('wc_os_additional', $_POST['wc_os_settings'])){
							
							$wc_os_additional_settings = isset($_POST['wc_os_settings']['wc_os_additional']) ? sanitize_wc_os_data($_POST['wc_os_settings']['wc_os_additional']) : '';
							
							$wc_os_settings['wc_os_additional'] = $wc_os_additional_settings;
							
							update_option('wc_os_settings', $wc_os_settings);
						
						}						
	
						$wc_os_general_settings_post = (isset($_POST['wc_os_general_settings']))?sanitize_wc_os_data($_POST['wc_os_general_settings']):($wc_os_additional?array():get_option('wc_os_customer_permission', array()));
						if(array_key_exists('wc_os_auto_forced', $wc_os_general_settings_post)
							&& array_key_exists('wc_os_customer_permission', $wc_os_general_settings_post)){
	
						}else{
	
							//unset($wc_os_general_settings_post['wc_os_customer_permission']);
	
						}
						
						
						$wc_os_optional_settings_array = array(		
							
							'wc_os_auto_forced',
							'wc_os_customer_permission',
							'wc_os_auto_clone',
							'wc_os_auto_clone_status',
							'wc_os_order_comments_off',
							'wc_os_billing_off',
							'wc_os_shipping_off',
							'wc_os_order_total',
							'wc_os_shipping_cost',
							'wc_os_tax_cost',
							'wc_os_effect_parent',
							'wc_os_display_child',
							'wc_os_display_parent',							
							'wc_os_backorder_mail_notification',
							'wc_os_order_title_splitted',							
							'wc_os_extend_groups',			
							'wc_os_packages_overview',	
							'wc_os_shipping_methods',			
							'wc_os_order_splitf_column',
							'wc_os_order_clonef_column',
							'wc_os_remove_fees_from_child',
							'wc_os_remove_price_from_child',
							'wc_os_show_customer_name_list',
							'wc_os_fa',
							'wcfm_order_status',
							'wcfm_shipping_status',
							'wcfm_commission_status',
							'wo_os_rule_switch',
						);
						$wc_os_general_settings_post = array_merge($wc_os_general_settings, $wc_os_general_settings_post);
						//pree($wc_os_general_settings_post);//exit;
						
						foreach($wc_os_optional_settings_array as $optional_item){
							
							if(array_key_exists($optional_item, $_POST['wc_os_general_settings'])){
								
								if(array_key_exists('wc_os_auto_forced', $_POST['wc_os_general_settings'])){ //26/01/2021 - AUTO SPLIT AND CUSTOMER PERMISSION WILL NOT WORK TOGETHER
									unset($wc_os_general_settings_post['wc_os_customer_permission']);
								}
								
							}elseif(array_key_exists($optional_item, $wc_os_general_settings_post)){
								unset($wc_os_general_settings_post[$optional_item]);
							}
							
						}
						
	
						update_option( 'wc_os_general_settings', $wc_os_general_settings_post );
						$wc_os_general_settings = get_option('wc_os_general_settings', array());

					}


						wc_os_settings_refresh();

				}






			}


			//pree($_POST);exit;

			if(!empty($_POST) && isset($_POST['wos_actions'])){


				if (
					! isset( $_POST['wc_os_cuztomization_field'] )
					|| ! wp_verify_nonce( $_POST['wc_os_cuztomization_field'], 'wc_os_cuztomization' )
				) {

				   _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
				   exit;

				} else {

					//pree($_POST);exit;
					update_option( 'wc_os_cuztomization', sanitize_wc_os_data($_POST['wos_actions']) );
					update_option( 'wc_os_cart_notices', sanitize_wc_os_data($_POST['wos_cart_notices']) );
					update_option( 'wc_os_packages_strings', sanitize_wc_os_data($_POST['wos_packages_strings']) );

				}

			}

			//wc_os_pree($_POST);exit;
            if(!empty($_POST) && isset($_POST['wc_os_child_email_field'])){


                if (                   
                    ! wp_verify_nonce( $_POST['wc_os_child_email_field'], 'wc_os_child_email' )
                ) {

                    _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
                    exit;

                } else {

                    //pree($_POST);exit;

                    $email_option_array = array(

                            'wc_os_order_combine_email',
                            'wc_os_order_split_email',
                            'wc_os_order_created_email',
                            'wc_os_order_created_email_admin',
                            'wc_os_parent_order_email',
							'wc_os_order_created_email_vendor'

                    );
					

					
					if(isset($_POST['wc_os_email_settings'])){

						$email_genral_settings = isset($_POST['wc_os_email_settings']) ? sanitize_wc_os_data($_POST['wc_os_email_settings']) : array();
						
						//pree($_POST);
						//pree($wc_os_general_settings);
						
						foreach ($email_option_array as $email_option){
	
							if(!isset($_POST[$email_option])){
								unset($wc_os_general_settings[$email_option]);
							}
							
						}
						
						//pree($email_genral_settings);
						//pree($wc_os_general_settings);
	
						$wc_os_general_settings = array_merge($wc_os_general_settings, $email_genral_settings);
						
						//pree($wc_os_general_settings);
	
						update_option( 'wc_os_general_settings', $wc_os_general_settings );
						
					}
					
					if(isset($_POST['wc_os_child_email']) && !empty($_POST['wc_os_child_email'])){
						
						$wc_os_child_email = get_option( 'wc_os_child_email');
						$wc_os_child_email = is_array($wc_os_child_email)?$wc_os_child_email:array();
	
					
						foreach($_POST['wc_os_child_email'] as $key=>$val){
							
							$wc_os_child_email[$key] = sanitize_wc_os_data($val);
							
						}
						if(!array_key_exists('co_total', $_POST['wc_os_child_email'])){
							unset($wc_os_child_email['co_total']);
						}							
		                update_option( 'wc_os_child_email', sanitize_wc_os_data($wc_os_child_email) );
					}


                }

            }

			//wc_os_pree($_POST);exit;
			if(!empty($_POST) && isset($_POST['wc_os_cats'])){

				
				if (
					! isset( $_POST['wc_os_cats_field'] )
					|| ! wp_verify_nonce( $_POST['wc_os_cats_field'], 'wc_os_cats_action' )
				) {

				   _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
				   exit;

				} else {
					
					//wc_os_pree($_POST);exit;
					//wc_os_pree($wc_os_settings);exit;
					//pree($wc_os_settings['wc_os_cats']);
					$c_grouped = array();
					$existing_group_cats_set = (array_key_exists('group_cats', $wc_os_settings['wc_os_cats'])?$wc_os_settings['wc_os_cats']['group_cats']:array());
					if(!empty($existing_group_cats_set)){
						foreach($existing_group_cats_set as $group_c=>$arr_c){
							if(!empty($arr_c)){
								foreach($arr_c as $item_c){
									if($item_c){
										$c_grouped[$item_c] = $group_c;
									}
								}
							}
						}
					}
					//pree($c_grouped);exit;
					
					$wos_valid_category_actions = isset($_POST['wos_valid_category_actions'])?sanitize_wc_os_data($_POST['wos_valid_category_actions']):'';
					$wos_valid_category_actions = ($wos_valid_category_actions!=''?explode(',', $wos_valid_category_actions):'');
					$wos_valid_category_actions = !empty($wos_valid_category_actions)?array_filter($wos_valid_category_actions):array();
					//pree($wos_valid_category_actions);		

									
					$wc_os_settings['wc_os_ie'] = (isset($_POST['wc_os_cats']['group_cats'])?'group_cats':'cats');
					//wc_os_pree($wc_os_settings['wc_os_ie']);//exit;
					//wc_os_pree($_POST);pree($wc_os_settings);exit;

					$updated_split_action = array();
					switch($wc_os_settings['wc_os_ie']){
						
						case 'group_cats':
							//wc_os_pree('updated_split_action');
							//wc_os_pree($split_action);
							if(!empty($split_action)){
								foreach($split_action as $sa_name=>$sa_data){
									//wc_os_pree($sa_data);
									foreach($sa_data as $sa_item){
										if(!is_array($sa_item) && $sa_item!=''){
											//pree($sa_item.' - '.$sa_name);
											$updated_split_action[$sa_item] = $sa_name;
										}else{
											//pree($sa_item.' - '.$sa_name);
										}
									}
								}
							}//exit;
							//wc_os_pree($updated_split_action);exit;
						break;
						case 'cats':
							if(!empty($split_action)){
								
								$wc_os_cats = sanitize_wc_os_data($_POST['wc_os_cats']['cats']);
								$wc_os_cats = array_filter($wc_os_cats);
								//pree($wc_os_cats);
								$group_cats = $wc_os_settings['wc_os_cats']['cats'];
								//pree($group_cats);
								$updated_split_action = is_array($group_cats)?$group_cats:array();
								//pree($wos_valid_category_actions);
								//pree($group_cats);
								//pree($updated_split_action);
								foreach($wos_valid_category_actions as $valid_cat){
									$old_entry = wc_os_recursive_array_search($valid_cat, $updated_split_action);
									if($old_entry && !in_array($valid_cat, $wc_os_cats)){
										
										
										if (($key = array_search($valid_cat, $updated_split_action[$old_entry])) !== false) {
											unset($updated_split_action[$old_entry][$key]);
										}										
									}
								}
								$updated_split_action = array_filter($updated_split_action);
								//pree($updated_split_action);
								foreach($split_action as $sa_name=>$sa_data){
									//wc_os_pree($sa_data);
									foreach($sa_data as $sa_cat=>$sa_item){
										if(!is_array($sa_item) && $sa_item!=''){
											//pree($sa_item.' - '.$sa_name);
											$updated_split_action[$sa_item][] = $sa_cat;
											$updated_split_action[$sa_item] = array_unique($updated_split_action[$sa_item]);
										}else{
											//pree($sa_item.' - '.$sa_name);
										}
									}
								}
								//pree($updated_split_action);exit;
							}
						break;
					}
					
					//pree($wc_os_settings['wc_os_cats']);
					
					//wc_os_pree($updated_split_action);exit;
					//exit;
					//wc_os_pree($updated_split_action);exit;
					$split_action_existing = array();
					//pree($wc_os_settings['wc_os_cats']);exit;
					if(!empty($wc_os_settings['wc_os_cats'])){
						//wc_os_pree('split_action_existing');
						//pree($wc_os_settings['wc_os_cats']);
						foreach($wc_os_settings['wc_os_cats'] as $action_old=>$data_old){
							if(is_array($data_old) && !empty($data_old)){
								foreach($data_old as $item_old_item){
									//wc_os_pree($action_old.' - '.$item_old);
									$item_old_arr = (is_array($item_old_item)?$item_old_item:array($item_old_item));

									foreach($item_old_arr as $item_old){
										if($item_old!=''){
											$split_action_existing[$item_old] = $action_old;
										}else{
											//pree($item_old.' - '.$action_old);
										}
									}
								}
							}
						}
						//wc_os_pree($split_action_existing);exit;
					}
					//exit;
					//wc_os_pree($updated_split_action);
					//wc_os_pree($split_action_existing);exit;
					//pree($split_action);
					//pree($wc_os_settings);
					//pree($_POST);exit;
					$wc_os_settings_updated = sanitize_wc_os_data($_POST['wc_os_cats']);
					
					//wc_os_pree($wc_os_settings_updated);exit;
					$wc_os_products_existing = (isset($wc_os_settings['wc_os_cats']) && is_array($wc_os_settings['wc_os_cats']))?$wc_os_settings['wc_os_cats']:array();

					//wc_os_pree($wc_os_products_existing);
					$wc_os_settings_updated['wc_os_cats'] = array_merge($wc_os_products_existing, $wc_os_settings_updated);
					//wc_os_pree($wc_os_settings_updated);exit;
					$wc_os_settings_updated['wc_os_cats'] = (!empty($wc_os_settings_updated['wc_os_cats'])?array_filter($wc_os_settings_updated['wc_os_cats'], 'is_array'):array());
					
					$split_ratio = ((isset($wc_os_settings_updated['split_ratio']))?$wc_os_settings_updated['split_ratio']:$wc_os_products_existing['split_ratio']);


					$wc_os_settings_group_cats = (is_array($wc_os_settings_updated['wc_os_cats']) && array_key_exists('group_cats', $wc_os_settings_updated['wc_os_cats']) ?  $wc_os_settings_updated['wc_os_cats']['group_cats'] : array());
					$wc_os_settings_cats = array_key_exists('cats', $wc_os_settings_updated['wc_os_cats'])?$wc_os_settings_updated['wc_os_cats']['cats']:array();
					
					//pree($split_ratio);
					
					
					
					//wc_os_pree($wc_os_settings_updated);exit;
					//wc_os_pree($wc_os_settings_updated['wc_os_cats']);
					//wc_os_pree($split_action);
					//wc_os_pree($split_action_existing);
					//pree($wc_os_settings_updated['wc_os_products']);//exit;
					if(!empty($wc_os_settings_updated['wc_os_cats'])){ //07-05-2019
						$wc_os_settings_refreshed = array();
						foreach($wc_os_settings_updated['wc_os_cats'] as $item_action=>$item_ids){
							//$wc_os_settings_updated['wc_os_products']
							//wc_os_pree($item_action);
							//wc_os_pree($item_ids);
							if(!empty($item_ids)){
								foreach($item_ids as $index=>$item_id_item){

									$item_id_arr = (is_array($item_id_item)?$item_id_item:array($item_id_item));
									//wc_os_pree($item_id_arr);
									foreach($item_id_arr as $item_id){
										//wc_os_pree($item_action_valid);
										$item_action_valid = ((is_array($split_action) && isset($split_action[$item_id]))?$split_action[$item_id]:(isset($split_action_existing[$item_id])?$split_action_existing[$item_id]:''));
										//$item_action_valid = (isset($split_action[$item_id])?$split_action[$item_id]:'');//:$split_action_existing[$item_id]);
										//wc_os_pree($item_id.' - '.$item_action_valid.' - '.$item_action);
										$wc_os_settings_refreshed[$item_action][] = $item_id;
										/*
										if($item_action_valid==$item_action){
											$wc_os_settings_refreshed[$item_action][]=$item_id;
										}elseif($item_action && $item_action_valid){

											unset($wc_os_settings_updated['wc_os_cats'][$item_action][$index]);

											//pree('$wc_os_settings_updated["wc_os_cats"]['.$item_action.']['.$index.']');
											//if($split_action[$item_id])
											//$wc_os_settings_updated['wc_os_cats'][$item_action_valid][]=$item_id;
										}
										*/

									}
								}
							}
						}

						//wc_os_pree($wc_os_settings_refreshed);
						$wc_os_settings_updated = wos_array_unique_recursive($wc_os_settings_refreshed);

					}
					$wc_os_settings['wc_os_cats'] = (isset($wc_os_settings['wc_os_cats']) && is_array($wc_os_settings['wc_os_cats'])?$wc_os_settings['wc_os_cats']:array());
					$existing_group_cats = array_key_exists('group_cats', $wc_os_settings['wc_os_cats'])?$wc_os_settings['wc_os_cats']['group_cats']:array();
					$existing_cats = array_key_exists('cats', $wc_os_settings['wc_os_cats'])?$wc_os_settings['wc_os_cats']['cats']:array();
					//pree($split_action);
					//wc_os_pree($wc_os_settings_updated);exit;
					//pree($wc_os_settings['wc_os_ie']);
					$wc_os_settings['wc_os_cats'] = $wc_os_settings_updated;
					
					//pree($wc_os_settings['wc_os_cats']['group_cats']);
					//pree($wc_os_settings_updated);
					

					

					
					//pree($wc_os_settings['wc_os_ie']);exit;

					switch($wc_os_settings['wc_os_ie']){
						case 'group_cats':

							$wc_os_settings['wc_os_cats']['cats'] = $existing_cats;
							$wc_os_settings['wc_os_cats']['group_cats'] = $wc_os_settings_group_cats;

						break;

						case 'cats':
						
							//pree($wc_os_settings_cats);//pree($existing_cats);pree($wc_os_settings_group_cats);exit;
							//pree($updated_split_action);exit;

							$wc_os_settings['wc_os_cats']['cats'] = $updated_split_action;
							$wc_os_settings['wc_os_cats']['group_cats'] = $wc_os_settings_group_cats;

						break;
					}
					
					

					//wc_os_pree($_POST);exit;
					//wc_os_pree($wc_os_settings);exit;
					//wc_os_pree(sanitize_wc_os_data($wc_os_settings));exit;
					
					//wc_os_pree($wc_os_settings['wc_os_cats']);
					

					//pree($split_action_group_cats);
					
					if(!empty($c_grouped)){
						//pree($split_action);
						$split_action_group_cats = array_key_exists('group_cats', $split_action)?$split_action['group_cats']:array();
						//pree($split_action_group_cats);
						$missing_items = array();
						if(!empty($split_action_group_cats)){
							
							foreach($split_action_group_cats as $item=>$group){
								if(trim($group)=='' && $item){
									$missing_items[] = $item;
								}
							}
						}
		
						
						foreach($c_grouped as $item_key=>$item_group){
		
							
							if(!in_array($item_key, $wos_valid_category_actions)){
								//pree($item_group.' - '. $item_key);								
								$wc_os_settings['wc_os_cats']['group_cats'][$item_group][] = $item_key;
							}else{
								//pree($item_group.' - '. $item_key);
							}
						}
						
						
						
					}
					//pree($wc_os_settings);exit;
					if(!empty($missing_items) && !empty($wc_os_settings['wc_os_cats']['group_cats'])){
						//pree($wc_os_settings['wc_os_cats']['group_cats']);
						foreach($missing_items as $del_val){
							//pree($del_val);
							foreach($wc_os_settings['wc_os_cats']['group_cats'] as $group=>$items){
								if (($key = array_search($del_val, $wc_os_settings['wc_os_cats']['group_cats'][$group])) !== false) {
									unset($wc_os_settings['wc_os_cats']['group_cats'][$group][$key]);
								}							
							}
							
						}
						//pree($wc_os_settings['wc_os_cats']['group_cats']);
					}
					//pree($missing_items);
					//wc_os_pree($wc_os_settings['wc_os_cats']['group_cats']);
					//exit;
					//pree($wc_os_settings['wc_os_cats']['group_cats']);exit;
					
					//pree($_POST);
					//pree($wc_os_settings);exit;
					$wc_os_settings['wc_os_cats']['split_ratio'] = $split_ratio;
					if(function_exists('wc_os_save_group_statuses')){ wc_os_save_group_statuses($wc_os_settings); }
					update_option('wc_os_settings', sanitize_wc_os_data($wc_os_settings));
					//exit;
					//wc_os_pree(get_option('wc_os_settings'));exit;
				}

			}

			if(!empty($_POST) && isset($_POST['wc_os_vendors'])){

//				wc_os_pree($_POST);exit;
				if (
					! isset( $_POST['wc_os_vendors_field'] )
					|| ! wp_verify_nonce( $_POST['wc_os_vendors_field'], 'wc_os_vendors_action' )
				) {

				   _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
				   exit;

				} else {
					$wc_os_settings['wc_os_ie'] = (array_key_exists('wc_os_vendors', $_POST['split_action'])?'group_by_vendors':$wc_os_settings['wc_os_ie']);
					$wc_os_settings['wc_os_vendors'] = ($wc_os_settings['wc_os_ie']=='group_by_vendors'?sanitize_wc_os_data($_POST['wc_os_vendors']):(isset($wc_os_settings['wc_os_vendors'])?$wc_os_settings['wc_os_vendors']:array()));
					
					//pree($wc_os_settings['wc_os_vendors']);exit;					
					//wc_os_pree($wc_os_settings);
					//pree($_POST);exit;
					if(function_exists('wc_os_save_group_statuses')){ wc_os_save_group_statuses($wc_os_settings); }
					update_option('wc_os_settings', sanitize_wc_os_data($wc_os_settings));
					
					if(isset($_POST['vendors_remaining'])){
						$vendors_remaining =  ($_POST['vendors_remaining'] !=  '' ? $_POST['vendors_remaining'] : 'group');
						//pree($vendors_remaining);exit;
						update_option('wc_os_vendors_remaining', $vendors_remaining);					
					}
										

				}
			}
            if(!empty($_POST) && isset($_POST['wc_os_woo_vendors'])){

                if (
                    ! isset( $_POST['wc_os_woo_vendors_field'] )
                    || ! wp_verify_nonce( $_POST['wc_os_woo_vendors_field'], 'wc_os_woo_vendors_action' )
                ) {

                    _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
                    exit;

                } else {



                    $wc_os_settings['wc_os_ie'] = (array_key_exists('wc_os_woo_vendors', $_POST['split_action'])?'group_by_woo_vendors':$wc_os_settings['wc_os_ie']);
                    $wc_os_settings['wc_os_woo_vendors'] = ($wc_os_settings['wc_os_ie']=='group_by_woo_vendors'?sanitize_wc_os_data($_POST['wc_os_woo_vendors']):(isset($wc_os_settings['wc_os_woo_vendors'])?$wc_os_settings['wc_os_woo_vendors']:array()));
                    //wc_os_pree($wc_os_settings);
					if(function_exists('wc_os_save_group_statuses')){ wc_os_save_group_statuses($wc_os_settings); }
                    update_option('wc_os_settings', sanitize_wc_os_data($wc_os_settings));

                }
            }			
			
			if(!empty($_POST) && isset($_POST['wc_os_attributes'])){

//				wc_os_pree($_POST);exit;
				if (
					! isset( $_POST['wc_os_settings_field'] )
					|| ! wp_verify_nonce( $_POST['wc_os_settings_field'], 'wc_os_settings_action' )
				) {

				   _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
				   exit;

				} else {
					//pree($_POST);
					//pree($wc_os_settings);
					
					//pree($wc_os_settings['wc_os_attributes_values']);
					
					$_POST['split_action'] = isset($_POST['split_action'])?$_POST['split_action']:array();
					$wc_os_settings['wc_os_ie'] = (array_key_exists('wc_os_attributes', $_POST['split_action']) && array_key_exists('wc_os_attributes_group', $_POST['split_action'])?'group_by_attributes_only':$wc_os_settings['wc_os_ie']);
					$wc_os_settings['wc_os_ie'] = (array_key_exists('wc_os_attributes', $_POST['split_action']) && !array_key_exists('wc_os_attributes_group', $_POST['split_action'])?'group_by_attributes_value':$wc_os_settings['wc_os_ie']);
					
					
					$wc_os_attributes_updated = (in_array($wc_os_settings['wc_os_ie'], array('group_by_attributes_only'))?sanitize_wc_os_data($_POST['wc_os_attributes']):(isset($wc_os_settings['wc_os_attributes'])?$wc_os_settings['wc_os_attributes']:array()));
					$wc_os_attributes_updated = array_unique($wc_os_attributes_updated);
					
					$wc_os_attributes_values_updated = (in_array($wc_os_settings['wc_os_ie'], array('group_by_attributes_value'))?sanitize_wc_os_data($_POST['wc_os_attributes_values']):(isset($wc_os_settings['wc_os_attributes_values'])?$wc_os_settings['wc_os_attributes_values']:array()));					
					$wc_os_attributes_values_updated = array_unique($wc_os_attributes_values_updated);
					
					//pree($wc_os_attributes_updated);
					//pree($wc_os_attributes_values_updated);
					
			   		$wos_valid_attrib_actions = array_key_exists('wos_valid_attrib_actions', $_POST)?sanitize_wc_os_data($_POST['wos_valid_attrib_actions']):'';
					$wos_valid_attrib_actions = ($wos_valid_attrib_actions!=''?explode(',', $wos_valid_attrib_actions):array());
					$wos_valid_attrib_actions = !empty($wos_valid_attrib_actions)?array_filter($wos_valid_attrib_actions):array();
					
					//pree($wos_valid_attrib_actions);
					
					
					if(!empty($wos_valid_attrib_actions) && $wc_os_settings['wc_os_ie']=='group_by_attributes_value'){
						foreach($wos_valid_attrib_actions as $valid_attrib){
							if(in_array($valid_attrib, $wc_os_attributes_values_updated) && !in_array($valid_attrib, $wc_os_settings['wc_os_attributes_values'])){
								$wc_os_settings['wc_os_attributes_values'][] = $valid_attrib;
							}elseif(!in_array($valid_attrib, $wc_os_attributes_values_updated) && in_array($valid_attrib, $wc_os_settings['wc_os_attributes_values'])){
								
								if (($attrib_key = array_search($valid_attrib, $wc_os_settings['wc_os_attributes_values'])) !== false) {
									unset($wc_os_settings['wc_os_attributes_values'][$attrib_key]);
								}								
							}
						}
					}
					
					
					if(!empty($wos_valid_attrib_actions) && $wc_os_settings['wc_os_ie']=='group_by_attributes_only'){
						foreach($wos_valid_attrib_actions as $valid_attrib){
							if(in_array($valid_attrib, $wc_os_attributes_updated) && !in_array($valid_attrib, $wc_os_settings['wc_os_attributes'])){
								$wc_os_settings['wc_os_attributes'][] = $valid_attrib;
							}elseif(!in_array($valid_attrib, $wc_os_attributes_updated) && in_array($valid_attrib, $wc_os_settings['wc_os_attributes'])){
								
								if (($attrib_key = array_search($valid_attrib, $wc_os_settings['wc_os_attributes'])) !== false) {
									unset($wc_os_settings['wc_os_attributes'][$attrib_key]);
								}								
							}
						}
					}
										
					
					
					
					$wc_os_settings['wc_os_attributes_group'] = ($wc_os_settings['wc_os_ie']=='group_by_attributes_only'?sanitize_wc_os_data($_POST['wc_os_attributes_group']):(isset($wc_os_settings['wc_os_attributes_group'])?$wc_os_settings['wc_os_attributes_group']:array()));
					
					//pree($wc_os_settings['wc_os_attributes_group']);
					//pree($wc_os_settings['wc_os_attributes_values']);
					
					//$wos_valid_attrib_actions
					
					//wc_os_pree($wc_os_settings);exit;
					//pree($_POST);exit;
					if(function_exists('wc_os_save_group_statuses')){wc_os_save_group_statuses($wc_os_settings);}
					update_option('wc_os_settings', sanitize_wc_os_data($wc_os_settings));
					//exit;

				}
			}

            if(!empty($_POST) && isset($_POST['wc_os_acf_fields'])){

//				wc_os_pree($_POST);exit;
                if (
                    ! isset( $_POST['wc_os_acf_fields_nonce'] )
                    || ! wp_verify_nonce( $_POST['wc_os_acf_fields_nonce'], 'wc_os_acf_fields_action' )
                ) {

                    _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
                    exit;

                } else {

                    $wc_os_acf_settings = sanitize_wc_os_data($_POST['wc_os_acf_fields']);
                    update_option('wc_os_acf_settings', $wc_os_acf_settings);

                }
            }
			
			if(!empty($_POST) && isset($_POST['wc_os_partial_payment'])){

//				wc_os_pree($_POST);exit;
                if (
                    ! isset( $_POST['wc_os_partial_payment_nonce'] )
                    || ! wp_verify_nonce( $_POST['wc_os_partial_payment_nonce'], 'wc_os_partial_payment_action' )
                ) {

                    _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
                    exit;

                } else {

                    $wc_os_partial_payment = sanitize_wc_os_data($_POST['wc_os_partial_payment']);
                    update_option('wc_os_partial_payment', $wc_os_partial_payment);

                }
            }

		}
	}

	add_action('admin_init', 'wc_os_settings_update');
	

	
	$wc_os_order_splitter = new wc_os_order_splitter;


	function wc_os_admin_menu()
	{
		global $wc_os_data;
		
		$title = str_replace('WooCommerce', 'WC', $wc_os_data['Name']);
		add_submenu_page('woocommerce', $title, $title, 'manage_woocommerce', 'wc_os_settings', 'wc_os_settings' );



	}

	function wc_os_settings(){ 



		if ( !current_user_can( 'administrator' ) )  {



			wp_die( __( 'You do not have sufficient permissions to access this page.', 'woo-order-splitter' ) );



		}



		global $wpdb; 

		

			
		include('wc_settings.php');	

		

	}
	
	
	function wc_os_plugin_linx($links) { 

		global $wc_os_premium_copy, $wc_os_pro;


		$settings_link = '<a href="admin.php?page=wc_os_settings">'.__('Settings', 'woo-order-splitter').'</a>';

		
		if($wc_os_pro){
			array_unshift($links, $settings_link); 
		}else{
			 
			$wc_os_premium_link = '<a href="'.$wc_os_premium_copy.'" title="'.__('Go Premium', 'woo-order-splitter').'" target="_blank">'.__('Go Premium', 'woo-order-splitter').'</a>'; 
			array_unshift($links, $settings_link, $wc_os_premium_link); 
		
		}
				
		
		return $links; 
	}
	
	function wc_os_get_products($per_page = 0, $offset = 0){
		$results = array();
		$args = array(
			'post_type' => 'product',
			'posts_per_page' => $per_page?$per_page:-1,
			'orderby'        => 'title',
			'order'          => 'ASC',
			//'offset'		=> 0

			);
		if($offset){
			$args['paged'] = $offset;
		}
		//pree($args);//exit;
		$results = get_posts( $args );		
		//pree($results);
		return $results;
	}		
	
	function wc_os_get_product_categories($offset=0, $wc_os_per_page=0){
	
		$cat_args = array(
			'orderby'    => 'name',
			'order'      => 'ASC',
			'hide_empty' => false,
		);
		
		
		if($offset){
			$cat_args['offset'] = (($offset-1)*$wc_os_per_page); 
		}
		if($wc_os_per_page){
			$cat_args['number'] = $wc_os_per_page;
			
		}
		
		$product_categories = get_terms( 'product_cat', $cat_args );		
		
		return $product_categories;
	}		
		
	function wc_os_settings_refresh(){
		global $wc_os_settings;
		$wc_os_settings = get_option('wc_os_settings', array());		
		//pree($wc_os_settings);
		$wc_os_settings['wc_os_products'] = (isset($wc_os_settings['wc_os_products']) && is_array($wc_os_settings['wc_os_products']))?$wc_os_settings['wc_os_products']:array();
		$wc_os_settings['wc_os_additional'] = (isset($wc_os_settings['wc_os_additional']) && is_array($wc_os_settings['wc_os_additional']))?$wc_os_settings['wc_os_additional']:array();		
		$wc_os_settings['wc_os_ie'] =(isset($wc_os_settings['wc_os_ie']) && $wc_os_settings['wc_os_ie']!=''?$wc_os_settings['wc_os_ie']:'default');
		
		//wc_os_pree($wc_os_settings);
		wc_os_update_cron_status_hooks();
	}
	
	
	
	function wc_os_crons($order_id=0, $split_action=true){
		
		$user_id = is_user_logged_in()?get_current_user_id():0;
		//if($user_id==1){
			//pree($order_id.' - '.$split_action.' - wc_os_crons');exit;
		//}
		//pree($order_id.' - wc_os_crons');
		//pree($split_action);
		//exit;
		//pree(get_post($order_id)->post_status);
		//return;
		
		
		
		global $wc_os_settings, $wc_os_debug, $pagenow, $wc_os_order_splitter;//, $woocommerce;
		
		//pree($pagenow);exit;
		$split_proceed = ($order_id || (!is_admin() || wc_os_is_orders_list()));
		//pree($split_proceed);exit;
		if($split_proceed){
		}else{
			return;
		}
		
		wc_os_settings_refresh();
		
		//wc_os_pree($_POST['wc_os_ps']);exit;
		//wc_os_pree(wc_os_order_split());exit;
		
		
		//pree($order_id);pree($quick_split);exit;
		//wc_os_pree(wc_os_order_split());exit;
		if(wc_os_order_split()){
			
			
			//$split_action = $split_action?(get_post_meta($order_id, 'wc_os_customer_permitted', true)== 'yes'):$split_action;
				
						
			$wc_os_general_settings = get_option('wc_os_general_settings', array());
			
			$split_action = $split_action?array_key_exists('wc_os_auto_forced', $wc_os_general_settings):$split_action;
			
			$customer_permission_required = array_key_exists('wc_os_customer_permitted', $wc_os_general_settings);
			
			if($customer_permission_required){
			
				$split_action = $split_action?(get_post_meta($order_id, 'wc_os_customer_permitted', true) == 'yes'):$split_action;
			
			}			
			
			
			$wc_os_order_splitter_cron_clear = get_option('wc_os_order_splitter_cron_clear', array());
			$wc_os_order_splitter_cron_clear = (is_array($wc_os_order_splitter_cron_clear)?$wc_os_order_splitter_cron_clear:array());
				
			$wc_os_products = $wc_os_settings['wc_os_products'];		
			
			$wc_os_order_splitter_cron = (!$order_id?get_option('wc_os_order_splitter_cron', array()):array());
			$wc_os_order_splitter_cron = (is_array($wc_os_order_splitter_cron)?$wc_os_order_splitter_cron:array());
			
			global $wpdb;
			
			if(!$order_id){
				
				if(function_exists('wc_os_get_io_setting') && wc_os_get_io_setting('out_stock_automation')=='yes'){
			
					$cron_query = "SELECT p.ID FROM $wpdb->postmeta mt RIGHT JOIN $wpdb->posts p ON p.ID=mt.post_id AND p.post_type='shop_order' WHERE mt.meta_key IN ('_wos_out_of_stock')";
					$wc_os_order_key_cron = $wpdb->get_results($cron_query);			
					//pree($wc_os_order_key_cron);exit;
					if(!empty($wc_os_order_key_cron)){
						
						$io_options = get_option('wc_os_io_options', array());
						$in_stock_status = (array_key_exists('in_stock_status', $io_options) ? $io_options['in_stock_status'] : '');
						
						foreach($wc_os_order_key_cron as $all_crons_items){		
								//pree($all_crons_items->ID);
							//if(isset($_GET['update-status'])){
								$order_data = wc_get_order( $all_crons_items->ID );
								foreach($order_data->get_items() as $item_id => $item_data){	
									$pid = $item_data->get_product_id();
									$vid = $item_data->get_variation_id();
									$product_item = $vid?$vid:$pid;	
									$product = wc_get_product($product_item);
									if(!is_array($product) && !is_object($product)){ continue; }
									$product_parent = (!$product->get_parent_id()?$product:wc_get_product($product->get_parent_id()));
									$qty_stock_status = $product->managing_stock()?$product->get_stock_quantity():$product_parent->get_stock_quantity();
									
									//pree($all_crons_items->ID.' - '.$item_data->get_quantity().' - '.$qty_stock_status);
									
									if($qty_stock_status>=$item_data->get_quantity()){
										$updated_stock = ($qty_stock_status-$item_data->get_quantity());
										update_post_meta($product_item, '_stock', $updated_stock);									
										
										//wp_update_post(array('ID'=>$all_crons_items->ID, 'post_status'=>$in_stock_status));
										wc_os_set_order_status($all_crons_items->ID, $in_stock_status);
										
										//update_wcfm_order_status($all_crons_items->ID, $in_stock_status);
										
										delete_post_meta($all_crons_items->ID, '_wos_out_of_stock');
									}
								}
							//}
							
						}
					}else{
						//pree('NO BACKORDERS FOUND.');
					}
				}		
				
			
			
			
				$cron_query = "SELECT p.ID FROM $wpdb->postmeta mt RIGHT JOIN $wpdb->posts p ON p.ID=mt.post_id AND p.post_type='shop_order' WHERE mt.meta_key IN ('_wos_consider_split_email')";
				//pree($cron_query);exit;
				$wc_os_order_key_cron = $wpdb->get_results($cron_query);			
				//pree($wc_os_order_key_cron);exit;
				if(!empty($wc_os_order_key_cron)){
					foreach($wc_os_order_key_cron as $all_crons_items){
						//pree($all_crons_items->ID);exit;
                        $mail_success = wos_email_notification(array('new'=>array($all_crons_items->ID), 'original'=>$all_crons_items->ID));
						//exit;
						if($mail_success){
							delete_post_meta($all_crons_items->ID, '_wos_consider_split_email');
						}
						
					}
				}
				
				$cron_query = "SELECT p.ID, mt.meta_value FROM $wpdb->postmeta mt RIGHT JOIN $wpdb->posts p ON p.ID=mt.post_id AND p.post_type='shop_order' WHERE mt.meta_key IN ('_wc_os_set_status')";
				//pree($cron_query);exit;
				$wc_os_order_key_cron = $wpdb->get_results($cron_query);			
				//pree($wc_os_order_key_cron);exit;
				if(!empty($wc_os_order_key_cron)){
					//pree($wc_os_order_key_cron);exit;
					foreach($wc_os_order_key_cron as $all_crons_items){
						
						//$parent_id = get_post_meta($all_crons_items->ID, 'splitted_from', true);
						//$parent_id = ($parent_id?$parent_id:get_post_meta($all_crons_items->ID, 'cloned_from', true));
						
						//if($parent_id)
						///update_post_meta($parent_id, 'split_status', 1);
						
						$wc_child_order = wc_get_order($all_crons_items->ID);
						
						//$wc_child_order_status = $wc_child_order->get_status();
						
						$order_status = wc_os_add_prefix($all_crons_items->meta_value, 'wc-');
						
						//$wc_child_order->set_status($order_status);
						wc_os_update_order_status($all_crons_items->ID, $order_status);
						
						//$wc_child_order = wc_get_order($all_crons_items->ID);
						//pree($wc_child_order->get_id().' - '.$wc_child_order_status.' > '.$order_status.' > '.$wc_child_order->get_status());
						
						delete_post_meta($all_crons_items->ID, '_wc_os_set_status');
						
						
						
						
						
					}//exit;
				}
			
			
				$cron_query = "SELECT p.ID FROM $wpdb->postmeta mt RIGHT JOIN $wpdb->posts p ON p.ID=mt.post_id AND p.post_type='shop_order' WHERE mt.meta_key='items_status_check'";
				$wc_os_order_key_cron = $wpdb->get_results($cron_query);	
				//pree($wc_os_order_key_cron);exit;		
				if(!empty($wc_os_order_key_cron)){
					foreach($wc_os_order_key_cron as $all_crons_items){				
						$order_data = wc_get_order( $all_crons_items->ID );
						if(count($order_data->get_items())<1 && wc_os_order_removal()){
							wc_os_trash_post($all_crons_items->ID);
						}
					}
				}
				
			
			
				$cron_query = "SELECT p.ID FROM $wpdb->postmeta mt RIGHT JOIN $wpdb->posts p ON p.ID=mt.post_id AND p.post_type='shop_order' WHERE mt.meta_key='_wos_calculate_totals'";
				$wc_os_order_key_cron = $wpdb->get_results($cron_query);
				//pree($wc_os_order_key_cron);exit;		
				if(!empty($wc_os_order_key_cron)){
					foreach($wc_os_order_key_cron as $all_crons_items){			
						$order_data = wc_get_order( $all_crons_items->ID );
						$order_data->calculate_taxes();
						$order_data->calculate_totals();
						delete_post_meta($all_crons_items->ID, '_wos_calculate_totals');
						update_post_meta($all_crons_items->ID, '__wos_calculate_totals_for_tax', true);
					}
				}
			
				$cron_query = "SELECT p.ID FROM $wpdb->postmeta mt RIGHT JOIN $wpdb->posts p ON p.ID=mt.post_id AND p.post_type='shop_order' WHERE mt.meta_key='__wos_calculate_totals_for_tax'";
				$wc_os_order_key_cron = $wpdb->get_results($cron_query);
				//pree($wc_os_order_key_cron);exit;		
				if(!empty($wc_os_order_key_cron)){
					foreach($wc_os_order_key_cron as $all_crons_items){									
						$order_data = wc_get_order( $all_crons_items->ID );
						$order_data->calculate_taxes();
						$order_data->calculate_totals();
						delete_post_meta($all_crons_items->ID, '__wos_calculate_totals_for_tax');
					}
				}
			
			
				$cron_query = "SELECT p.ID FROM $wpdb->postmeta mt RIGHT JOIN $wpdb->posts p ON p.ID=mt.post_id AND p.post_type='shop_order' WHERE mt.meta_key='wos_remove_taxes'";
				$wc_os_order_key_cron = $wpdb->get_results($cron_query);
				//pree($wc_os_order_key_cron);exit;
				//pree($cron_query);
				if(!empty($wc_os_order_key_cron) && false){
					add_action( 'woocommerce_calculate_totals', 'wc_os_action_woocommerce_calculate_totals', 10, 1 );
					add_filter('woocommerce_order_is_vat_exempt', function(){ return true; });
					
					foreach($wc_os_order_key_cron as $all_crons_items){
						$_shipping_postcode = get_post_meta($all_crons_items->ID, '_shipping_postcode', true);
						delete_post_meta($all_crons_items->ID, '_shipping_postcode');
						$order_data = wc_get_order( $all_crons_items->ID );
						
						
						//$woocommerce->customer->set_is_vat_exempt( true );
						delete_post_meta($all_crons_items->ID, 'wos_remove_taxes');
						delete_post_meta($all_crons_items->ID, '_order_tax');
						delete_post_meta($all_crons_items->ID, '_tax_status');
						delete_post_meta($all_crons_items->ID, '_tax_class');
						foreach($order_data->get_items() as $item_id => $item_data){						
							update_metadata( 'order_item', $item_id, '_line_subtotal_tax', 0);
							update_metadata( 'order_item', $item_id, '_line_tax_data', 0);
							update_metadata( 'order_item', $item_id, '_line_tax_data', array());						
						}
						$order_data->calculate_totals();
						update_post_meta($all_crons_items->ID, '_shipping_postcode', $_shipping_postcode);
					
					}

				}
				
			}
				
			
			$cron_query = "SELECT p.ID FROM $wpdb->postmeta mt RIGHT JOIN $wpdb->posts p ON p.ID=mt.post_id AND p.post_type IN ('shop_order') ".($order_id?'AND p.ID IN ('.$order_id.') ':'')."WHERE mt.meta_key='wc_os_order_splitter_cron'";// AND mt.meta_key!='splitted_from'
			//wc_os_pree($cron_query);exit;
			$wc_os_order_key_cron = $wpdb->get_results($cron_query);
			//wc_os_pre($cron_query);
			//wc_os_pree($wc_os_order_key_cron);exit;
			
			if($wc_os_debug)
			wc_os_pree($wc_os_order_key_cron);
			
			//pree($wc_os_order_key_cron);
			if(!empty($wc_os_order_key_cron)){
				
				if($order_id){
					$wc_os_order_splitter_cron = array($order_id=>true);
					$delete_post_meta = delete_post_meta($order_id, 'wc_os_order_splitter_cron');
					//$wpdb->query("DELETE FROM $wpdb->comments WHERE comment_post_ID = $order_id"); //02/07/2020
					
					//echo $delete_post_meta?'Deleted > '.$all_crons_items->ID.'<br />':'Exists < <br />';
				}else{
					//pree($wc_os_order_splitter_cron);
					//pree($wc_os_order_key_cron);
					//pree($wc_os_order_key_cron);
					foreach($wc_os_order_key_cron as $all_crons_items){
						//wc_os_pree($all_crons_items->ID);
						if(!array_key_exists($all_crons_items->ID, $wc_os_order_splitter_cron)){
							$wc_os_order_splitter_cron[$all_crons_items->ID] = (is_admin()?true:$split_action); //23/10/2019 //13/10/2019							
							//echo $delete_post_meta?'Deleted > '.$all_crons_items->ID.'<br />':'Exists < <br />';
						}
						$delete_post_meta = delete_post_meta($all_crons_items->ID, 'wc_os_order_splitter_cron');
					}
					//exit;
				}
			}else{
				
				$wc_os_order_splitter_cron = array();
				update_option('wc_os_order_splitter_cron', $wc_os_order_splitter_cron);
			}

			//wc_os_pree($wc_os_order_splitter_cron);exit;	
						
						
			if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'wos_quick_split'){
				$split_action = true;
				if(empty($wc_os_order_splitter_cron)){					
					$wc_os_order_splitter_cron[$order_id] = true;
				}
			}			

			//if(empty($wc_os_order_splitter_cron) && isset($_GET['refreshed']) && $_GET['refreshed']==true){
			//	$wc_os_order_splitter_cron[67691] = true;
			//	delete_post_meta(67691, 'split_status');
			//}
						
			//pree($wc_os_order_splitter_cron);
				
			/*if($wos_status_change){
	
				if(empty($wc_os_order_splitter_cron)){					
					$wc_os_order_splitter_cron[$order_id] = true;
				}
			}	*/		
			
			if(!empty($wc_os_order_splitter_cron)){
							
				//pree($wc_os_order_splitter_cron);exit;
				
				foreach($wc_os_order_splitter_cron as $order_id_split => $auto_split){
					//wc_os_pree($order_id_split.' => '.$auto_split.' > '.get_post_type( $order_id_split ));exit;
					
					if ( get_post_type( $order_id_split ) != 'shop_order' ) {
						update_post_meta($order_id_split, 'split_status', true);
						continue;
					}
					
					$valid_order = wc_get_order($order_id_split); 
					//wc_os_pree($order_id_split);wc_os_pree($valid_order);exit;
					$wc_os_log_order = $valid_order;
					
					if(empty($valid_order)){ unset($wc_os_order_splitter_cron[$order_id_split]); continue; }
					//wc_os_pree($order_id);   
					//wc_os_pree($order);
					
					
					$wc_os_order_splitter->cron_in_progress = true;
					
					$wc_os_order_splitter->auto_split = ($auto_split?true:false);
				
					//wc_os_pree($auto_split);//exit;
					//wc_os_pree($wc_os_order_splitter->auto_split);
					//wc_os_pree($order_id);exit;
					
					$wc_os_prcess_status = true;
					
					//pree($auto_split);
					//pree($order_id_split);

					
					//pree($order_details_page);
					//exit;
								
					if($auto_split){	
						//echo $order_id.'<br /><br />';
							$wc_os_ie = $wc_os_settings['wc_os_ie'];
							//wc_os_pree($wc_os_ie);exit;
							$wos_forced_ie = get_post_meta($order_id_split, 'wos_forced_ie', true);
							$wos_delete_order = get_post_meta($order_id_split, 'wos_delete_order', true);
							if($wos_forced_ie && $wos_delete_order){
								$wc_os_ie = $wos_forced_ie;
							}
							
							//wc_os_pree($wc_os_ie);
						//exit;
						//if(!$a){
							update_post_meta($order_id_split, '_wc_os_skip_default_coupon', true);
							do_action('wc_os_before_order_split', $order_id_split);
							
							/*		
							$order_details_page = get_post_meta($order_id_split, '_order_details_page', true);
							if($order_details_page){  //MANUAL SPLIT CASE 12/12/2020
								//pree($wc_os_ie);
								$wc_os_ie = 'default'; 
								$split_action = true;
								delete_post_meta($order_id_split, '_order_details_page'); 
								//pree($split_action);
								//pree($wc_os_ie);exit;
							}
							*/
						
							
							switch($wc_os_ie){
								default:
									//wc_os_pree($order_id_split." > $wc_os_prcess_status");exit;

                                    //pre($split_action);//exit;
									//pre('split_order_logic: '.$order_id_split);
									
									if($split_action){
										$order_id_split_status = get_post_meta($order_id_split, 'split_status', true);
										//pree($wc_os_ie.'-'.$order_id_split.'-'.$split_action.'-'.$order_id_split_status);exit;
										
										$wc_os_logger_str = 'split_order_logic > '.date('d M, Y H:i:s A').' ~ '.$order_id_split.' SPLITTED '.($order_id_split_status?'YES':'NO');
										//wc_os_logger('email', $wc_os_logger_str);
										
										if(!$order_id_split_status){						
											//wc_os_logger('email', '$wc_os_prcess_status = $wc_os_order_splitter->split_order_logic($order_id_split);');
											$wc_os_prcess_status = $wc_os_order_splitter->split_order_logic($order_id_split);//, $wc_os_products);
											//update_post_meta($order_id_split, 'split_status', true);
										}
									}
									//wc_os_pree($order_id_split.' > '.$wc_os_prcess_status);exit;
									//$wpdb->query("DELETE FROM $wpdb->comments WHERE comment_post_ID = $order_id_split"); //02/07/2020
								break;
								case 'default':
									//wc_os_pree($order_id);
									//
									if($split_action){
										$wc_os_order_splitter->split_order($order_id_split);
									}
								break;								
							}
                            delete_post_meta($order_id_split, 'wc_os_order_splitter_cron');
							
                            $wc_os_split_status = get_post_meta($order_id_split, 'split_status', true);
                            if($wc_os_log_order && wc_os_order_removal() && $wc_os_split_status){

                                wc_os_save_order_log($wc_os_log_order);

                            }							
							//$a++;
							
						//}
						//exit;
						
						//wc_os_pree('split_order_logic');
						
					}else{
						
						//wc_os_pree('wc_os_crons');exit;
						//wc_os_pree($order_id);wc_os_pree($wc_os_products);exit;
						
						//1 MARCH, 2019
						//if(!$wc_os_debug)
						//$wc_os_order_splitter->split_order($order_id, $wc_os_products);
						//else
						//wc_os_pree('split_order');
					}
					
					//if(wc_os_order_removal()){ //WE ARE CLONING SO WE HAVE TO REMOVE IT, NO NEED TO CHECK REMOVAL OPTION
					if($wc_os_prcess_status){ //20/05/2019
						$wc_os_order_splitter_cron_clear[$order_id_split] = time(); //24/01/2019
						unset($wc_os_order_splitter_cron[$order_id_split]);
					}
					//}

					
					
					$wc_os_order_splitter->cron_in_progress = false;
					
				}
				
				
			} 
			
			if(!$order_id){
				
				
				
				
				if(!empty($wc_os_order_splitter_cron_clear)){
					
					// pree($wc_os_order_splitter_cron_clear);exit;
					
					foreach($wc_os_order_splitter_cron_clear as $order_id_cron_clear => $timestamp){
						
						$mins = ((time()-$timestamp)/60);
					
							$split_status = get_post_meta($order_id_cron_clear, 'split_status', true);
							$splitted_from = get_post_meta($order_id_cron_clear, 'splitted_from', true);		
							$cloned_from = get_post_meta($order_id_cron_clear, 'cloned_from', true);
							$wos_untrashed = get_post_meta($order_id_cron_clear, 'wos_untrashed', true);
							
							if(!$wc_os_debug){
								
								if(!wc_os_order_removal()){
									
									$wos_delete_order = get_post_meta($order_id_cron_clear, 'wos_delete_order', true);
									if($wos_delete_order){
										wc_os_trash_post($order_id_cron_clear); //14/05/2019
									}else{
										
										$split_removal_case = (count(wc_os_child_orders_by_order_id($order_id_cron_clear))>0);
										
										if($split_removal_case){
											$removal_action = wc_os_order_split_removal_action('string');
										}else{																				
											$wc_os_rule_based_switch = wc_os_implement_rule_status($order_id_cron_clear);
											$removal_action = ($wc_os_rule_based_switch != false ? $wc_os_rule_based_switch : wc_os_order_removal_action('string'));
										}
										
										if($removal_action!=''){
											$removal_arr = get_option('wos_update_status', array());
											if(!wc_os_is_empty_order_status($order_id_cron_clear)){

												if(!wc_os_check_ignored_order($order_id_cron_clear)){
													wc_os_remove_order_from_ignored($order_id_cron_clear);
													$removal_arr[$order_id_cron_clear] = $removal_action;
												}


											}
											// pree($removal_arr);exit;
											update_option('wos_update_status', $removal_arr);
											
										}
									
									}
									
								}elseif($split_status && (!$splitted_from && !$cloned_from) && wc_os_order_removal() && !$wos_untrashed){
									//pree($order_id.' removed through crons ~ '.($split_status?'Splitted':'Not Splitted').' from '.$splitted_from.' or Cloned from '.$cloned_from);//exit;
									wc_os_trash_post($order_id_cron_clear); //24/01/2019
								}
							}
							
							unset($wc_os_order_splitter_cron_clear[$order_id_cron_clear]);
						//}									
					}
					
					
					
					
				}else{
					if(wc_os_order_removal()){ //24/03/2020
						$split_status = get_post_meta($order_id, 'split_status', true);
						$splitted_from = get_post_meta($order_id, 'splitted_from', true);		
						$cloned_from = get_post_meta($order_id, 'cloned_from', true);
						//$_wos_restored = get_post_meta($order_id, 'wos_untrashed', true);
								
						if($split_status && (!$splitted_from && !$cloned_from) && !$_wos_restored){				
							wc_os_trash_post($order_id);
						}
					}
				}
				
				//exit;
				
				
			
				$removal_arr = get_option('wos_update_status', array());
				
				
				if(!empty($removal_arr)){
					//pree($removal_arr);
					foreach($removal_arr as $order_id=>$status){
						
						
				
						//$order_data = wc_get_order( $order_id );
						$status = 'wc-'.str_replace('wc-', '', $status);
						$update_post = array('ID' => $order_id, 'post_status' => $status);
						//pree($update_post);
						//wp_update_post($update_post);
						$is_custom_status = get_post_meta($order_id, '_wos_custom_status_update', true);
						if(!$is_custom_status){					
							//wp_update_post($update_post);
							
							wc_os_set_order_status($order_id, $status);
							
							//update_wcfm_order_status($order_id, $status);
					
						}
					
						unset($removal_arr[$order_id]);
						update_option('wos_update_status', $removal_arr);
						
						
					}
					//exit;
				}
			}
			
			update_option('wc_os_order_splitter_cron_clear', $wc_os_order_splitter_cron_clear);
			//pree($wc_os_order_splitter_cron_clear);exit;
			
		}
		
		
		
		
		if($order_id){;

            return $order_id;
		}
		
		//if($wc_os_debug)
		//exit;
							
	}
	
	function wos_array_unique_recursive($array)
	{
		$array = array_unique($array, SORT_REGULAR);
	
		foreach ($array as $key => $elem) {
			if (is_array($elem)) {
				$array[$key] = wos_array_unique_recursive($elem);
			}
		}
	
		return $array;
	}	

	
	
	
	
	
	function wc_os_init(){
		
		//if(!wc_os_is_orders_list())
		//return;
		
		
		global $wc_os_currency, $wc_os_settings, $wc_os_activated;
		
		
		
		if(!$wc_os_activated)
		return;
		
		
		$wc_os_currency = wc_os_currency_symbol();
		wc_os_settings_refresh();
		
		
		//wc_os_pree($wc_os_settings);exit;
		
		//add_action('init', array($this, 'split_order'));
		
		
		
		
	}
	
	add_action('init', 'wc_os_init');	
	
	
	if(!function_exists('get_order_title_status')){
		function get_splitted_order_title_status(){
			global $wc_os_general_settings;
			
			return array_key_exists('wc_os_order_title_splitted', $wc_os_general_settings);
		}
	}	
	

	
	function __wos_change_order_received_text($order_id, $parent_order=array(), $deleted=true){
		ob_start();
		
		global $wpdb, $wc_os_general_settings, $wc_os_tax_cost, $wc_os_shipping, $wc_os_shipping_cost;
		
		$child_orders = 0;

		$parent_order = (empty($parent_order)?wc_get_order($order_id):$parent_order);
		//pree($parent_order);pree($order_id);
		//pree($wc_os_vendor_name);
		$wc_os_vendor_name = array_key_exists('wc_os_vendor_name', $wc_os_general_settings);
		
		$cart_total = 0;
		if(!empty($parent_order) && array_key_exists('wc_os_order_total', $wc_os_general_settings)){
			$cart_total = $parent_order->get_total();
		}
		
		
		$wos_cart_notices = get_option( 'wc_os_cart_notices', true);
		$co_total = (isset($wos_cart_notices['co_total'])?$wos_cart_notices['co_total']:'');
		$args = array(
			'posts_per_page'   => -1,
			'offset'           => 0,
			'cat'         => '',
			'category_name'    => '',
			'orderby'          => 'ID',
			'order'            => 'ASC',
			'include'          => '',
			'exclude'          => '',
			'meta_key'         => 'splitted_from',
			'meta_value'       => $order_id,
			'post_type'        => array('shop_order'),
			'post_mime_type'   => '',
			'post_parent'      => '',
			'author'	   => '',
			'author_name'	   => '',
			'post_status'      => 'any',
			'suppress_filters' => true,
			'fields'           => '',
		);
		//pre($args);
		$posts_array = get_posts( $args );
		$child_orders = count($posts_array);
		//pre($posts_array);
		
		if(!empty($posts_array)){
			//$items = wc_get_order($order_id);
			//pree($items->get_items());
			//pree(get_post_meta($order_id, '_wc_os_parcels_array', true));
			//wc_os_add_shipping_fee($order_id, false);
			$first_order = current($posts_array);
			$order_total = 0;
			foreach($posts_array as $post_data){
				$this_order = wc_get_order($post_data->ID);
				$_wos_keep_shipping = get_post_meta($post_data->ID, '_wos_keep_shipping', true);
				$_wos_remove_shipping = get_post_meta($post_data->ID, '_wos_remove_shipping', true);
				//pree($_wos_remove_shipping);
				
				$total_amount = $this_order->get_total();
				$order_total += $total_amount;
				
				if(!$wc_os_shipping_cost){
					$child_order_shipping_items = $this_order->get_items('shipping');
					//pree($child_order_shipping_items);exit;
					
					if(!empty($child_order_shipping_items)){
						foreach($child_order_shipping_items as $item_id=>$item_data){
							//pree($item_id);
							//pree('if(!$_wos_keep_shipping || ($_wos_keep_shipping && $item_id!=$_wos_keep_shipping)){');
							//pree('if(!'.$_wos_keep_shipping.' || ('.$_wos_keep_shipping.' && '.$item_id.'!='.$_wos_keep_shipping.')){');
							if(!$_wos_keep_shipping || ($_wos_keep_shipping && $item_id!=$_wos_keep_shipping)){
								
								if(class_exists('WC_OS_Shipping')){
									if($wc_os_shipping->get_selection() == 'no'){
									
										wc_delete_order_item($item_id);									
									}
								}else{
									wc_delete_order_item($item_id);
								}
							}
						}
						
					}
				}
				$this_order->calculate_totals();
				
				$child_order = wc_get_order($post_data->ID);
				$cart_total += $child_order->get_total();
				
				
				if($wc_os_shipping_cost){
					
					$_wc_os_set_status = get_post_meta($child_order->get_id(), '_wc_os_set_status', true);
					$_order_shipping = get_post_meta($child_order->get_id(), '_order_shipping', true);
					
					//wc_os_logger('email', '$wc_os_shipping_cost > '.$wc_os_shipping_cost.' > '.'$_wc_os_set_status > '.$child_order->get_status().' / '.$_wc_os_set_status.' > '.'$child_order->get_id() > '.$child_order->get_id().' *** '.$_order_shipping);
					
					if($_wc_os_set_status){
						$child_order->set_status(wc_os_add_prefix($_wc_os_set_status, 'wc-'));
						$child_order->save(); //__wos_change_order_received_text()
						
						delete_post_meta($child_order->get_id(), '_wc_os_set_status');
					}
				}
			
			}
			
			
			//pree($cart_total);
			//pree($parent_order->get_items());
			$parent_items = array(); 
			$bright_items = array(); 
			if(count($parent_order->get_items())>0){
				foreach($parent_order->get_items() as $parent_arr){
					$product_id = $parent_arr->get_product_id();
					$parent_items[] = $product_id;
					
					$meta = get_post_meta($product_id, 'wos_force_display', true);
					if(!empty($meta)){
						$bright_items[] = $product_id;
					}
				}
			}
				
			//pree(array_key_exists('wc_os_display_parent', $wc_os_general_settings));				
			//pree($deleted);
			//pree(count($parent_order->get_items()));
			//pree(count($posts_array));
	?>
	
    <?php if($deleted): ?>
	
	<ul class="woocommerce-order-overview woocommerce-thankyou-order-details order_details">
	
        <li class="woocommerce-order-overview__order order">
        <?php _e('Order number', 'woo-order-splitter'); ?>: <strong><?php echo $order_id; ?></strong>
        </li>
        
        <li class="woocommerce-order-overview__date date">
        <?php _e('Date', 'woo-order-splitter'); ?>: <strong><?php echo date('F d, Y', strtotime($first_order->post_date)); ?></strong>
        </li>
        
        
        <li class="woocommerce-order-overview__total total">
        <?php _e('Total', 'woo-order-splitter'); ?>: <?php echo wc_price($cart_total); ?>
        </li>
	
	</ul>
    <?php else:  ?>
    <?php if(count($parent_order->get_items())==0 || (count($posts_array)>0 && array_key_exists('wc_os_display_parent', $wc_os_general_settings))): 
			
	?>
    <style type="text/css">
		.woocommerce-order-details:not(.child-section)<?php echo !empty($bright_items)?':not(.product-'.implode('):not(product-', $bright_items).')':''; ?>,
		.woocommerce-order-overview__order.order<?php echo !empty($bright_items)?':not(.product-'.implode('):not(product-', $bright_items).')':''; ?>{
			display:none !important;
		}
	</style>
    <?php endif; ?>
    <?php endif; ?>
    <script type="text/javascript" language="javascript">
		jQuery(document).ready(function($){
			$('ul.woocommerce-thankyou-order-details.order_details li.total strong').html('<?php echo wc_price($cart_total); ?>');
			
<?php 
			if(!empty($parent_items)){
?>
			
			$('table.shop_table.order_details, .woocommerce-order-details').addClass('product-<?php echo implode(' product-', $parent_items); ?>');
<?php 
			}
?>
		});
	</script>
    
    <?php if(count($posts_array)>0 && !array_key_exists('wc_os_display_child', $wc_os_general_settings)): ?>
	<section class="woocommerce-order-details child-section">
	
	<h2 class="woocommerce-order-details__title"><?php echo isset($wos_cart_notices['co_heading'])?$wos_cart_notices['co_heading']:(count($posts_array)>1?__('Orders', 'woo-order-splitter'):__('Order', 'woo-order-splitter')); ?></h2>
	
	
	<?php 
	$cart_total += $order_total;
	//$posts_array = get_posts( $args );
	$child_counter = 1;

	$vendors = array();	
	foreach($posts_array as $post_data){ $child_order = wc_get_order($post_data->ID); $child_order->calculate_totals();
		
		//pree($child_order);
		$_payment_method = $child_order->get_payment_method_title();
		$child_order_data = $child_order->get_data();	
		//pree($child_order_data);
		//pree(array_keys(get_post_meta($post_data->ID)));
		//pree($post_data->ID);
		//pree('_order_shipping: '.get_post_meta($post_data->ID, '_order_shipping', true));
		//pree('_order_shipping_tax: ');
		
		/*$table = $wpdb->prefix.'woocommerce_order_items';
		$shipping_query = "SELECT order_item_id FROM $table WHERE order_item_type='shipping' AND order_id=".esc_sql($post_data->ID);
		$order_item_id = $wpdb->get_var($shipping_query);
		$table = $wpdb->prefix.'woocommerce_order_itemmeta';
		$shipping_meta_query = "SELECT * FROM $table WHERE order_item_id='".esc_sql($order_item_id)."'";
		$shipping_meta_results = $wpdb->get_results($shipping_meta_query);
		//pree($shipping_meta_results);*/
		
		$_order_shipping_tax = (get_post_meta($post_data->ID, '_order_shipping_tax', true));
		$_order_shipping_tax = ($_order_shipping_tax?$_order_shipping_tax:0);

		$tax_string = '';
		if(wc_tax_enabled() && !is_null(WC()->cart) && WC()->cart->display_prices_including_tax()){
			$tax_string_array = array();
			$tax_string_array[] = wc_price($child_order_data['total_tax']);

			$tax_string = ' <small class="includes_tax">(' .__( 'includes', 'woo-order-splitter' ).' '. sprintf( '%s', implode( ', ', $tax_string_array ) .' '. WC()->countries->tax_or_vat() ). '</small>';

			$child_order_data['total_tax'] -= $_order_shipping_tax;
			$child_order_data['shipping_total'] += $_order_shipping_tax;

		}
			
					
		
		//exit;
		
		$child_id = $child_order->get_order_number();
		
		//$_wc_os_shipping_cost = get_post_meta($child_id, '_wc_os_shipping_cost', true);
		//$_wc_os_parcels_array = get_post_meta($child_id, '_wc_os_parcels_array', true);	
		
		//pree($_wc_os_shipping_cost);
		//pree($_wc_os_parcels_array);
		//if(function_exists('wc_os_add_shipping_fee')){
		//	wc_os_add_shipping_fee($child_id);
		//}
		


		if(get_splitted_order_title_status()){

            $child_id = ($order_id. ' - ' .count($posts_array). ' - ' .$child_counter);

            $child_counter++;

        }		
		
	?>
	
	<h3 class="child_order_heading"><?php echo isset($wos_cart_notices['co_number'])?$wos_cart_notices['co_number']:__('Order number', 'woo-order-splitter'); ?> <?php echo $child_id; ?></h3>
	<table class="woocommerce-table woocommerce-table--order-details shop_table order_details">
	
	<thead>
	<tr>
	<th class="woocommerce-table__product-name product-name"><?php _e('Product', 'woo-order-splitter'); ?></th>
	<th class="woocommerce-table__product-table product-total"><?php _e('Total', 'woo-order-splitter'); ?></th>
	</tr>
	</thead>
	
	<tbody>
	
	<?php foreach($child_order->get_items() as $order_items){ 
			$meta_data = array();
			$vendor_product_id = $order_items->get_product_id();
			if($wc_os_vendor_name){
					if(!array_key_exists($vendor_product_id, $vendors)){
						$post_vendor = get_post($vendor_product_id);
						$vendors[$vendor_product_id] = $post_vendor->post_author;
					}
					if(array_key_exists($vendor_product_id, $vendors)){
						$vendor_data = get_user_by( 'ID', $vendors[$vendor_product_id] );
						$full_name = trim($vendor_data->first_name.' '.$vendor_data->last_name);		
						$full_name = ($full_name?$full_name:$vendor_data->display_name);				
						$meta_data[] = __('Vendor', 'woo-order-splitter').': '.$full_name;
					}					
			}	
	
	?>    
	<tr class="woocommerce-table__line-item order_item">
	
	<td class="woocommerce-table__product-name product-name">
	<a href="<?php echo get_permalink($order_items->get_product_id()); ?>"><?php echo $order_items['name']; ?></a> <strong class="product-quantity">× <?php echo $order_items->get_quantity(); ?></strong>
    <div class="wos-item-meta"><?php echo implode(', ', $meta_data); ?></div>
    </td>
	
	<td class="woocommerce-table__product-total product-total"><?php echo wc_price($order_items->get_total()+$child_order_data['total_tax']); ?></td>
	
	</tr>
	<?php } ?>
    
	<?php if($child_order_data['shipping_total']): ?>
    <tr>
    <td class="woocommerce-table__product-name product-name"><?php _e('Shipment', 'woo-order-splitter'); ?>:</td>	
	<td class="woocommerce-table__product-total product-total"><?php echo wc_price($child_order_data['shipping_total']); ?></td>	
	</tr>
    <?php endif; ?>   
    
    <?php /*if($child_order_data['total_tax']): //$wc_os_tax_cost &&  ?>
    <tr>
    <td class="woocommerce-table__product-name product-name"><?php _e('Tax', 'woo-order-splitter'); ?>:</td>	
	<td class="woocommerce-table__product-total product-total"><?php echo wc_price($child_order_data['total_tax']); ?></td>	
	</tr>
    <?php endif; */ ?>
    <tr>
    <td class="woocommerce-table__product-name product-name"><?php _e('Payment method', 'woo-order-splitter'); ?>:	</td>	
	<td class="woocommerce-table__product-total product-total"><?php echo $_payment_method; ?></td>	
	</tr>
    
	
	</tbody>
	
	<tfoot>
					
		
				   <tr>
			<th scope="row"><?php _e('Total', 'woo-order-splitter'); ?>:</th>
			<td><?php echo wc_price($child_order->get_total()).' '.$tax_string; ?></td>
		</tr>
							</tfoot>
	</table>
	<?php 
	}
	?>

    
    <?php if($co_total): ?>
    <table class="woocommerce-table woocommerce-table--order-details shop_table order_details">
	
	<thead>
	<tr>
	<th class="woocommerce-table__product-name product-name"><?php _e('Order Total', 'woo-order-splitter'); ?></th>
	<th class="woocommerce-table__product-table product-total"><?php _e('Amount', 'woo-order-splitter'); ?></th>
	</tr>
	</thead>
	
	<tbody>
	
	
	<tr class="woocommerce-table__line-item order_item">
	
	<td class="woocommerce-table__product-name product-name"><?php _e('Total amount charged to billing method', 'woo-order-splitter'); ?></td>
	
	<td class="woocommerce-table__product-total product-total"><?php echo wc_price($cart_total); ?></td>
	
	</tr>
	
	
	</tbody>
	
	
	</table>
    <?php endif;?>
	</section>
    <?php endif; ?>
    
	<?php					
	
			
		}	
		
		
		$str = ob_get_contents();
		ob_end_clean();	
		
		return array('child'=>$child_orders, 'content'=>$str);
	}
	
	add_filter( 'woocommerce_order_number', 'wos_change_woocommerce_order_number' );
	
	function wos_change_woocommerce_order_number( $order_id ) {
		
		global $wc_os_pro;
		//pree(get_post_meta($order_id));exit;
		if($wc_os_pro && get_splitted_order_title_status()){
			
			$order_id = wc_os_get_order_title_html($order_id, 'return');
			//pree($order_id);
		}
		
		return $order_id;
		
	}
	
	add_filter('woocommerce_thankyou_order_received_text', 'wos_change_order_received_text', 10, 2 );
	
	function wos_change_order_received_text( $str, $order ) {
		$qs = $_SERVER['REQUEST_URI'];
		$qs = explode('/', $qs);
		$qs = array_filter($qs, 'strlen');
		if(!is_numeric(end($qs))){
			array_pop($qs);
			//$qs = array_filter($qs, 'strlen');
		}
		
		//pree($qs);
		//pree($order);
		if(is_numeric(end($qs))){
			$order_id = end($qs);
			//pree($order_id);		
			$deleted = false;	
			if(empty($order)){			
				$order = wc_get_order($order_id);	
				$deleted = true;
			}
				
			if(!empty($order)){	
				$received_text = __wos_change_order_received_text($order_id, $order, $deleted);	
				global $wc_os_general_settings;
				$wc_os_display_child_number = (array_key_exists('wc_os_display_child_number', $wc_os_general_settings) && trim($wc_os_general_settings['wc_os_display_child_number'] && $wc_os_general_settings['wc_os_display_child_number']>0)?str_replace('[NUMBER_OF_CHILD_ORDERS]', $received_text['child'], $wc_os_general_settings['wc_os_display_child_number']).'<br /><br />':'');
				
				$str = $wc_os_display_child_number.$str.$received_text['content'];
			}				
		
		}
		
		return $str;
	}
	
	add_action('woocommerce_thankyou', 'wc_os_checkout_order_processed', 10, 1);
	
	$wc_os_order_status_hooks = WC_OS_PLUGIN_DIR . '/inc/sections/wc_os_order_status_hooks.php';
	
	
	if(file_exists($wc_os_order_status_hooks)){
		include_once $wc_os_order_status_hooks;
	}

	
	
	function wc_os_checkout_order_processed($order_id){
		//return;
		//wc_os_pree($_POST['wc_os_ps']);exit;
		//wc_os_pree($_REQUEST);exit;
		
		//pree('WOS: '.$order_id);
		
		if ( ! $order_id )
        return;
		
		//wc_os_logger('email', $order_id.' > wc_os_checkout_order_processed'); return;
		//update_post_meta($order_id, 'order_splitting', date('H:i:s A'));
		
		$split_status = get_post_meta($order_id, 'split_status', true);
		
		if($split_status && $split_status==1)
		return;
		
		
		//pre($_REQUEST);		
		if(
				is_admin() 
			&& 
			(
					((isset($_GET['clone']) && $_GET['clone'] == 'yes') || (isset($_REQUEST['post_type']) && $_REQUEST['post_type']=='shop_order' && $_REQUEST['action']=='clone'))
				||
					((isset($_REQUEST['post_type']) && $_REQUEST['post_type']=='shop_order' && $_REQUEST['action']=='split'))
			)
		){
			return;
		}
		
		//pre($_REQUEST);
		
		$post = get_post($order_id);
		
		$wos_get_valid_status = wos_get_valid_status($post, $order_id);
		extract($wos_get_valid_status);		
		
		if(!$valid_post_type){
			return;			
		}
		
		order_details_page_saved( $order_id, $post );
		
		global $wc_os_settings, $wc_os_general_settings;
		$order_data = wc_get_order( $order_id );
		
		$wc_os_shipping_methods = array_key_exists('wc_os_shipping_methods', $wc_os_general_settings);	
		
		if($wc_os_shipping_methods && wc_os_get_session( 'wc_os_customer_permitted')=='on'){
			update_post_meta($order_id, '_wc_os_shipping_cost', wc_os_get_session('wc_os_calculated_shipping_cost'));
			update_post_meta($order_id, '_wc_os_parcels_array', wc_os_get_session('wc_os_parcels_array'));

		}
		//pree(count($order_data->get_items()));
		//wc_os_pree($order_id);
		//wc_os_pree($order_data);
		$split_lock = (isset($wc_os_settings['wc_os_additional']['split_lock'])?$wc_os_settings['wc_os_additional']['split_lock']:array());
		$split_lock = is_array($split_lock)?$split_lock:array();
		
		$status_lock_released = empty($split_lock);
		
		if(!empty($split_lock)){
			foreach($split_lock as $split_lock_i){
				if(!$status_lock_released){
					$status_lock_released = $order_data->has_status($split_lock_i);
				}
			}
		}		
		//wc_os_pree($status_lock_released);
		//wc_os_pree(get_option('wc_os_auto_forced', 0));
		
		$wc_os_general_settings = get_option('wc_os_general_settings', array());
		//pree($wc_os_general_settings);exit;
		if(function_exists('wc_os_order_remove_shipping_adjustment')){
			wc_os_order_remove_shipping_adjustment($order_id);//exit;
		}		
		if(!empty($order_data) && $status_lock_released
            && !empty($wc_os_general_settings)
			&& array_key_exists('wc_os_auto_forced', $wc_os_general_settings)){
		

			//for($c=0;$c<=5;$c++){
				
				//$_wos_restored = get_post_meta($order_id, 'wos_untrashed', true);
				
				//if(!$_wos_restored){
					wc_os_crons($order_id);
				//}
				
				//pre('wc_os_crons('.$order_id.')');
			//}

		
		}
		
		//echo $order_id;
		
		if(!is_admin()){
		
			$received_text = __wos_change_order_received_text($order_id, array(), false);
			$wc_os_display_child_number = (array_key_exists('wc_os_display_child_number', $wc_os_general_settings) && trim($wc_os_general_settings['wc_os_display_child_number'] && $wc_os_general_settings['wc_os_display_child_number']>0)?str_replace('[NUMBER_OF_CHILD_ORDERS]', $received_text['child'], $wc_os_general_settings['wc_os_display_child_number']).'<br /><br />':'');
				
			$str = $wc_os_display_child_number.$received_text['content'];
			
			echo $str;
				
			for($c=0;$c<3;$c++){
				wc_os_crons();
			}
			wc_os_emails_to_admin_cron();
			wc_os_emails_to_resend_cron();
			WC()->session->set( 'wc_os_customer_permitted', 'off');

		}
		
		
		
		
	}
	
	function wc_os_get_customer_permission_status($order_id=0){		
		
		$wc_os_general_settings = get_option('wc_os_general_settings', array());
		$wc_split_permit = true;						
		
		//pree($wc_split_permit);exit;
		//pree($customer_permission);exit;
		
		if(array_key_exists('wc_os_customer_permission', $wc_os_general_settings) && $order_id){				

			$wc_split_permit = get_post_meta($order_id, '_wc_os_customer_permitted', true);

		}
		
		return $wc_split_permit;
	}


	function wos_get_valid_status($post, $order_id = 0){
		$ret = array();
		$valid_post_type = true;
		
		
		if(is_object($post) && isset($post->post_type) && !in_array($post->post_type, array('shop_order'))){
			$valid_post_type = false;
			
			if(!$valid_post_type && $post->post_parent>0){
				//wcdp_payment //20/05/2020
				//pre($post->post_parent);
				$expected_order = get_post($post->post_parent);
				//pre($expected_order);
				if(is_object($expected_order) && isset($expected_order->post_type) && in_array($expected_order->post_type, array('shop_order'))){
					$valid_post_type = true;
					$order_id = $expected_order->ID;
					$post = $expected_order;
				}
				
			}
		}	
		
		
		$ret = array('valid_post_type' => $valid_post_type, 'order_id' => $order_id, 'post' => $post);
		
		return $ret;	
	}
		
	function order_details_page_saved( $order_id, $post=array() ) {
		
		global $wp;
		
		$order_details_page = (isset($_POST['wc_os_ps']));// || stripos(home_url( $wp->request ), 'order-received')!='');
		
		//$_POST['post_type']=='shop_order'
		//in_array($_POST['save'], array('Create', 'Update'))
		//$_POST['action']=='woocommerce_save_order_items'

		//wc_os_logger('email', $_POST); return;

		//wc_os_pre($_POST);
		//wc_os_pre($order_details_page);
		//wc_os_pree($order_details_page);exit;
		
		//wc_os_pre($order_id);//exit;
		//wc_os_pree($order_status);exit;
		
		// If this is just a revision, don't send the email.
		if ( wp_is_post_revision( $order_id ))
		return;
		
		//pree($post);//exit;
		//if ( !$post && !$order_details_page )
		
		
		//pre($post);pre($order_details_page);
		$wos_get_valid_status = wos_get_valid_status($post, $order_id);
		extract($wos_get_valid_status);
		
		//pre($valid_post_type);pre($order_details_page);
		
		$do_not_proceed = ( !$valid_post_type && !$order_details_page );
		
		
		//pree($do_not_proceed?'DO NOT PROCEED':'DO PROCEED');exit;
		
		if ($do_not_proceed)
		return; 
		
		
		//pre($order_id);
			
		global $wc_os_settings, $wc_os_general_settings;
		wc_os_settings_refresh();
		
		//wc_os_pree($_POST['wc_os_ps']);exit;
		//wc_os_pree(wc_os_order_split());
		//wc_os_pre($wc_os_settings);
		
		$wc_os_customer_permitted = ((isset($_POST['wc_os_customer_permitted'])?sanitize_wc_os_data($_POST['wc_os_customer_permitted']):'no')=='yes');
     
        update_post_meta($order_id, '_wc_os_customer_permitted',  $wc_os_customer_permitted);
		
		$split_permission_status = wc_os_get_customer_permission_status($order_id);

		//pre('wc_os_order_split() '.wc_os_order_split().' && $split_permission_status '.$split_permission_status);

		if(wc_os_order_split() && $split_permission_status){
			
			
			
			
			$wc_os_all_products = (isset($wc_os_settings['wc_os_all_product']) && $wc_os_settings['wc_os_all_product']) ? true : false; //flag indicating to all products are subject to splitting
			$wc_os_products = $wc_os_settings['wc_os_products'];
			
			
			//wc_os_pree($wc_os_all_products); exit;
			
			//wc_os_pree($_POST['wc_os_ps']);exit;
			$wc_os_ps = false;
			$wc_os_ie = $wc_os_settings['wc_os_ie'];
			
			if($order_details_page){
				$_POST['wc_os_ps'] = (!empty($_POST['wc_os_ps'])?sanitize_wc_os_data($_POST['wc_os_ps']):array());
				$_POST['wc_os_ps'] = array_filter($_POST['wc_os_ps'], 'is_numeric');
				$wc_os_ps = true;
			}
			//wc_os_pree($wc_os_order_splitter->cron_in_progress);exit;
			//wc_os_pree($_POST['wc_os_ps']);exit;
			//wc_os_pree(!empty($wc_os_products) && count($wc_os_products)>1);

			//wc_os_pree('$wc_os_all_products');
			//wc_os_pree($wc_os_all_products);
			
			//wc_os_pree('$wc_os_products');			
			$wc_os_products = (isset($wc_os_products[$wc_os_ie])?$wc_os_products[$wc_os_ie]:array());
			//wc_os_pre($wc_os_products);exit;
			//wc_os_pree('$order_details_page');
			//wc_os_pree($order_details_page);
			$wc_os_order_splitter_cron = get_option('wc_os_order_splitter_cron', array());
			$wc_os_order_splitter_cron = (is_array($wc_os_order_splitter_cron)?$wc_os_order_splitter_cron:array());
			
			
			//pre($wc_os_ie);
			//pre($wc_os_all_products);
			//pre($wc_os_products);
			//pre($order_details_page);	
		
			if(
			
					($wc_os_ie=='cats')
				||
					(
							($wc_os_ie!='cats')
						&&
							($wc_os_all_products || (!empty($wc_os_products) && count($wc_os_products)>1))
					)
						
				||
					$order_details_page
				
			){
				//wc_os_pre('ONE');
				//wc_os_pree($order_details_page);
				//wc_os_pree($wc_os_all_products);exit;
				
				//wc_os_pree($order_id);
				//wc_os_pree($_POST['wc_os_ps']);exit;
				
				
				$wc_os_order_splitter = new wc_os_order_splitter;		
				//wc_os_pree('wc_os_ie');		
				//wc_os_pree($wc_os_settings['wc_os_ie']);//exit;
				if($wc_os_ps){ //MANUAL SPLIT RESTORED 12/12/2020
					$wc_os_settings['wc_os_ie'] = 'default';
				}
				
				switch($wc_os_settings['wc_os_ie']){
					
						default:
						case 'default':
						
							//wc_os_pree('order_details_page_saved');exit;
							
							if($order_details_page)
							$wc_os_order_splitter->split_order($order_id, $wc_os_products);
							elseif(!$wc_os_order_splitter->cron_in_progress)
							$wc_os_order_splitter_cron[$order_id] = ($wc_os_all_products?true:false);
							
						break;	
						
						case 'exclusive':
						case 'inclusive':
						case 'shredder':
						case 'io':
						case 'quantity_split':
						case 'subscription_split':
						case 'cats':
						case 'groups':
						case 'group_cats':
						
							//$this->auto_split = true;
							
							
							$wc_os_order_splitter_cron[$order_id] = true;
							
						break;
						
				}
				//pre($wc_os_order_splitter_cron);
				//wc_os_pree('wc_os_order_splitter_cron');		
				//wc_os_pree($wc_os_order_splitter_cron);
				//wc_os_pree($wc_os_order_splitter->cron_in_progress);exit;
				
				//wc_os_pree('is_admin cron_in_progress wc_os_ps order_id');
				//wc_os_pree(!is_admin());
				//wc_os_pree(!$wc_os_order_splitter->cron_in_progress);
				//wc_os_pree($wc_os_ps);exit;
				//wc_os_pree($order_id);
				
				if(((!is_admin() && !$wc_os_order_splitter->cron_in_progress) || $wc_os_ps)){

					update_post_meta($order_id, 'wc_os_order_splitter_cron', true);
					
				}
				
				
				//wc_os_pree($wc_os_order_splitter_cron);exit;
				
				if(((!is_admin() && !$wc_os_order_splitter->cron_in_progress) || $wc_os_ps)){
					update_option('wc_os_order_splitter_cron', $wc_os_order_splitter_cron);
				}else{
					
				}
				
				
				
			}elseif((!is_admin() && array_key_exists('wc_os_auto_forced', get_option('wc_os_general_settings', array())))){
				
				//wc_os_pre('ONE O ONE');
				
				$wc_os_order_splitter_cron[$order_id] = true;
				update_post_meta($order_id, 'wc_os_order_splitter_cron', true);
				update_option('wc_os_order_splitter_cron', $wc_os_order_splitter_cron);
			}
			
			//pree($wc_os_ps);
			
			//if($wc_os_ps){
			//	update_post_meta($order_id, '_order_details_page', true);
			//}
			
			//pree($wc_os_ps);
			//exit;
		}		
		
		//wc_os_pre($order_id.': '.get_post_meta($order_id, 'wc_os_order_splitter_cron', true));
		
		
		
	
		if((isset($_GET['refreshed']) && $_GET['refreshed']=='true') && $order_id){
			
			
			$wc_os_parent_order_email = !array_key_exists('wc_os_parent_order_email', $wc_os_general_settings);
			//pree('wc_os_process_parent_email: '.$order_id);
			//pree($wc_os_parent_order_email);
			if($wc_os_parent_order_email){
				wc_os_process_parent_email($order_id);
			}
			//exit;
		}			
	
	}
	add_action( 'save_post', 'order_details_page_saved', 11 );	
	
	function wc_os_order_vendor_email_status(){
		global $wc_os_settings, $wc_os_general_settings;
		
		$group_by_vendors = ($wc_os_settings['wc_os_ie']=='group_by_vendors' || $wc_os_settings['wc_os_ie']=='group_by_woo_vendors');
		//pree('$group_by_vendors: '.$group_by_vendors);
		$wc_os_order_created_email_vendor = array_key_exists('wc_os_order_created_email_vendor', $wc_os_general_settings);
		//pree('$wc_os_order_created_email_vendor: '.$wc_os_order_created_email_vendor);
		$order_split_created_vendor = ($group_by_vendors && $wc_os_order_created_email_vendor);
		//pree('$order_split_created_vendor: '.$order_split_created_vendor);
		return $order_split_created_vendor;
	}
	
	function wc_os_get_order_vendor($order_id=0){
		
		$ret = array();

        $_vendor_id = get_post_meta($order_id, '_vendor_id', true);
        $_vendor_by_term = get_post_meta($order_id, '_vendor_term', true);

        if($_vendor_id){

            if($_vendor_by_term){

                if($_vendor_id != -1){

                    $vendor_data = get_term_meta( absint( $_vendor_id ), 'vendor_data', true );
                    $info = array('user_email' => $vendor_data['email']);
                    return (object) $info;

                }else{

                    $new_order_settings = get_option( 'woocommerce_new_order_settings', array() );
                    $new_order_settings = ! empty( $new_order_settings['recipient'] ) ? $new_order_settings['recipient'] : get_option( 'admin_email' );
                    $info = array('user_email' => $new_order_settings);
                    return (object) $info;
                }


            }else{

			    $ret = get_userdata($_vendor_id);

            }


		}
		
		return $ret;
		
	}
	
	function wc_os_process_parent_email($order_id){
		
		//pree('wc_os_process_parent_email: '.$order_id);
		//return;
		
		global $wc_os_settings, $wc_os_general_settings, $woocommerce;
			
		
		$post_meta = get_post_meta($order_id);
		if(!empty($post_meta)){
			
			
			
			
			
			$post_meta = array_keys($post_meta);
			//pree($post_meta);
			$is_parent_order = (!in_array('splitted_from', $post_meta) && !in_array('cloned_from', $post_meta));
			//pree($is_parent_order);
			if($is_parent_order){
				

									
					//pree('wc_os_child_orders_by_order_id');
					$has_child_orders = (count(wc_os_child_orders_by_order_id($order_id))>0);
					$_wos_parent_email = get_post_meta($order_id, '_wos_parent_email', true);
					$_wos_parent_email = is_array($_wos_parent_email)?$_wos_parent_email:array();
					//pree($has_child_orders?'CHILD':'NO CHILD');
					//pree($_wos_parent_email);
					//exit;
					//pree((!$has_child_orders && !empty($_wos_parent_email)));
					if(!$has_child_orders && !empty($_wos_parent_email)){
						
						
						$_billing_email = get_post_meta($order_id, '_billing_email', true);
						$_customer_registered_id = get_post_meta($order_id, '_customer_user', true);
						
						$new_order_settings = get_option('woocommerce_new_order_settings');
						$new_order_settings['recipient'] = ($new_order_settings['recipient']!=''?$new_order_settings['recipient']:get_option('admin_email'));
						
						$mailer = $woocommerce->mailer();
						
						$co_efrom_name = get_bloginfo('name');
						$co_efrom_email = get_bloginfo('admin_email');
						$co_ereplyto_email = get_bloginfo('admin_email');						
						
						//$wc_os_mailer = WOS_Mailer::get_instance();									
						//($wc_os_mailer->send_mail($new_order_settings['recipient'], $_wos_parent_email['subject'], $_wos_parent_email['message'])?__('Admin Success', 'woo-order-splitter'):__('Admin Failure', 'woo-order-splitter')).'<br />';		
						
						ob_start();
						wc_get_template( 'emails/email-header.php', array( 'email_heading' => get_bloginfo('name') ) );
						echo $body;
						wc_get_template( 'emails/email-footer.php' );
						$message = ob_get_clean();
						
						$headers = array(
							'Content-Type: text/html; charset=UTF-8',
							'From: '.$co_efrom_name.' <'.$co_efrom_email.'>',
							($co_ereplyto_email?'Reply-To: '.get_bloginfo('name').' <'.$co_ereplyto_email.'>':'')
						);
					
						$status = $mailer->send( $new_order_settings['recipient'], $_wos_parent_email['subject'], $_wos_parent_email['message'], $headers );
												
						
						$order_split_created_vendor = wc_os_order_vendor_email_status();
						if($order_split_created_vendor){
							$user_info = wc_os_get_order_vendor($order_id);
							if(!empty($user_info)){
								//($wc_os_mailer->send_mail($user_info->user_email, $_wos_parent_email['subject'], $_wos_parent_email['message'])?__('Vendor Success', 'woo-order-splitter'):__('Vendor Failure', 'woo-order-splitter')).'<br />';	
								$status = $mailer->send( $user_info->user_email, $_wos_parent_email['subject'].'', $_wos_parent_email['message'], $headers );
								$wc_os_logger_str = $user_info->user_email.' - '.$_wos_parent_email['subject'].' '.($status?__('Success', 'woo-order-splitter'):__('Failed', 'woo-order-splitter')).' '.__('Vendor Email', 'woo-order-splitter');
								//wc_os_logger('email', $wc_os_logger_str);
							}
						}
													
						if($_billing_email){
							
							//($wc_os_mailer->send_mail($_billing_email, $_wos_parent_email['subject'], $_wos_parent_email['message'])?__('Customer Success', 'woo-order-splitter'):__('Customer Failure', 'woo-order-splitter')).'<br />';		
							$status = $mailer->send( $_billing_email, $_wos_parent_email['subject'], $_wos_parent_email['message'], $headers );
							
							$wc_os_logger_str = $_billing_email.' - '.$_wos_parent_email['subject'].' '.($status?__('Success', 'woo-order-splitter'):__('Failed', 'woo-order-splitter')).' '.__('Billing Email', 'woo-order-splitter');
							//wc_os_logger('email', $wc_os_logger_str);
							
						}
						
						
						
						if($_customer_registered_id){
							$get_customer_by = get_user_by('ID', $_customer_registered_id);
							
							if($get_customer_by->user_email && $_billing_email!=$get_customer_by->user_email){
								$status = $mailer->send( $get_customer_by->user_email, $_wos_parent_email['subject'], $_wos_parent_email['message'], $headers );
								
								$wc_os_logger_str = $get_customer_by->user_email.' - '.$_wos_parent_email['subject'].' '.($status?__('Success', 'woo-order-splitter'):__('Failed', 'woo-order-splitter')).' '.__('Registered Email', 'woo-order-splitter');
								//wc_os_logger('email', $wc_os_logger_str);
							}
						}						
						
						delete_post_meta($order_id, '_wos_parent_email');
						
						
						
					}
				
			}
		}		
	}
	
	if(!function_exists('wc_os_get_session')){
		function wc_os_get_session($key, $default='') {
			
			return ((!is_admin() && isset(WC()->session) && WC()->session->has_session())?WC()->session->get($key):$default);
			
		}
	}

	function wc_os_front_scripts() {	
	
		global $wp, $wc_os_settings, $wc_os_general_settings, $woocommerce, $wc_os_minified_js, $wc_os_minified_css;
	
		$wc_os_shipping_methods = array_key_exists('wc_os_shipping_methods', $wc_os_general_settings);

		$front_script = ($wc_os_minified_js ? 'js/front-scripts-min.js' : 'js/front-scripts.js');
		$front_style = ($wc_os_minified_css ? 'css/front-style-min.css' : 'css/front-style.css'.'?t='.time());
				
		wp_enqueue_script(
			'wos_scripts',
			plugins_url($front_script, dirname(__FILE__)),
			array('jquery'),
			$wc_os_minified_js?date('Y'):time()
		);	
		
		
		
		wp_enqueue_style( 'wos-styles', plugins_url($front_style, dirname(__FILE__)), '', ($wc_os_minified_css?date('Y'):time()) );
		
		$chosen_methods = wc_os_get_session( 'chosen_shipping_methods' );
		
		$chosen_shipping = !empty($chosen_methods)?current($chosen_methods):''; 
		
		$cart_url = (function_exists('wc_get_cart_url')?wc_get_cart_url():$woocommerce->cart->get_cart_url());
		$checkout_url = (function_exists('wc_get_checkout_url')?wc_get_checkout_url():$woocommerce->cart->get_checkout_url());
		
		
		$translation_array = array(
			'wc_os_packages_overview' => array_key_exists('wc_os_packages_overview', $wc_os_general_settings) ? 'on' : 'off',
			'orders_page_refresh' => in_array('order-refresh', $wc_os_settings['wc_os_additional'])?'false':'true',
			'chosen_shipping_method' => $chosen_shipping,
			'total_shipping_cost' => wc_os_get_session('wc_os_total_shipping_cost'),
			'wc_os_customer_permitted' => wc_os_get_session('wc_os_customer_permitted', 'on'),
            'ajax_url' => admin_url( 'admin-ajax.php' ),
            'wc_os_customer_permitted_nonce' => wp_create_nonce( 'wc_os_customer_permitted_action' ),
			'wc_os_shipping_methods' => $wc_os_shipping_methods,
			
			'cart_url' => $cart_url,
			'checkout_url' => $checkout_url,
			'is_cart' => (is_cart()),// || $is_cart),
			'is_checkout' => (is_checkout()),// || $is_checkout),			
			'is_product' => (is_product()),
			'is_view_order' => stripos(home_url( $wp->request ), 'view-order')!='',
			'is_thank_you' => stripos(home_url( $wp->request ), 'order-received')!='',
			'product_url' => (is_product()?get_permalink():''),
			'this_url' => get_permalink(),
			'url' => plugin_dir_url( dirname(__FILE__) ),
			'posted' => is_array($_POST)?count($_POST):0
			



		);
		
		
		//pree($translation_array);exit;
		wp_localize_script( 'wos_scripts', 'wos_obj', $translation_array );		
	}
		
	function wc_os_admin_scripts() {
		
		global $wc_os_css_arr, $wc_os_settings, $post, $wc_os_cust, $wos_actions_arr, $wc_os_general_settings, $wp_scripts, $wc_os_minified_js, $wc_os_minified_css, $post_type, $wc_os_order_statuses_class;
		$is_wc_os_settings = (isset($_GET['page']) && $_GET['page']=='wc_os_settings');
        $admin_script = ($wc_os_minified_js ? 'js/admin-scripts-min.js' : 'js/admin-scripts.js');
        $admin_style = ($wc_os_minified_css ? 'css/admin-style-min.css' : 'css/admin-style.css'.'?t='.time());
		
		if($is_wc_os_settings){
			wp_enqueue_style( 'wos_bs_grid_only', plugins_url('css/bootstrap-grid.min.css', dirname(__FILE__)), array(), true );
		}		
		
		if($is_wc_os_settings && !array_key_exists('wc_os_fa', $wc_os_general_settings)){
			wp_enqueue_style( 'fontawesome', plugins_url('css/fontawesome.min.css', dirname(__FILE__)), array(), true );
			
			wp_enqueue_script(
				'fontawesome',
				plugins_url('js/fontawesome.min.js', dirname(__FILE__)),
				array('jquery'),
				$wc_os_minified_js?date('Y'):time()
			);	
		}
		//pree($is_wc_os_settings);pree($wp_scripts->registered);

		if($is_wc_os_settings && !array_key_exists('jquery-ui-sortable', $wp_scripts->registered)){

		    wp_enqueue_script('jquery-ui-sortable');
        }		
		
		wp_register_style('wos-admin', plugins_url($admin_style, dirname(__FILE__)));
		
		
		wp_enqueue_style( 'wos-admin' );
		
		wp_enqueue_script(
			'wos_scripts',
			plugins_url($admin_script, dirname(__FILE__)),
			array('jquery', 'jquery-ui-sortable'),
			$wc_os_minified_js?date('Y'):time()
		);	
		
		wp_enqueue_style( 'jquery.multiselect', plugins_url('css/jquery.multiselect.css', dirname(__FILE__)), array(), true );
		
		wp_enqueue_script(
			'jquery.multiselect',
			plugins_url('js/jquery.multiselect.js', dirname(__FILE__)),
			array('jquery'),
			$wc_os_minified_js?date('Y'):time()
		);		
		//pree($post);exit;
		$conflict_status_options = array();
		if(is_object($post) && isset($post->post_type) && $post->post_type=='shop_order' && isset($_GET['action']) && $_GET['action']=='edit'){
			$order_id = $post->ID;
			$conflict_status = get_post_meta($order_id, 'conflict_status', true);
			
			if($conflict_status){
				
				$order_data = wc_get_order( $order_id );
				//pree($actions_arr);
				if($order_data->get_items()){			
					//pree($order_data->get_items());
					$wc_os_ie_selected = $wc_os_settings['wc_os_ie'];
					$wc_os_order_splitter = new wc_os_order_splitter;
					$products_with_actions = $wc_os_order_splitter->products_with_actions();
					$actions_arr = array();
					foreach($order_data->get_items() as $item_data){				
						//pree($item_data);
						//pree($item_data->get_product_id());
						if(array_key_exists($item_data->get_product_id(), $products_with_actions)){
							$actions_arr[] = $products_with_actions[$item_data->get_product_id()];
						}
					}
					$actions_arr = array_unique($actions_arr);
					//pree($actions_arr);	
					if(count($actions_arr)==0){ //BACKWARDS COMPATIBILITY
					}elseif(count($actions_arr)==1){ //REGULAR/VALID/NORMAL CASE
						$wc_os_ie_selected = current($actions_arr);
					}elseif(count($actions_arr)>1){ //EXPECTED/INVALID/CONFLICT CASE					
						$conflict_status_options[] = '<h6>'.__('Following product/items are configured with different split actions.', 'woo-order-splitter').'<br />'.__('Select one of these split actions to proceed for this order.', 'woo-order-splitter').'</h6>';
						if(!empty($actions_arr)){
							$conflict_status_options[] = '<ul>';
							$wos_forced_ie = get_post_meta($order_id, 'wos_forced_ie', true);
							foreach($actions_arr as $action_title){
								$conflict_status_options[] = '<li><a data-action="'.$action_title.'" class="'.($wos_forced_ie==$action_title?'forced':'').'">'.ucwords(split_actions_display($action_title, 'title')).'</a></li>';
							}
							$conflict_status_options[] = '</ul><div class="wos_loading smart"></div>';
						}
					}				
				}
			}
		}
		//pree($conflict_status_options);exit;
		$wc_os_group_meta = get_option('wc_os_group_meta', array());
		$wc_os_group_meta = (is_array($wc_os_group_meta) && !empty($wc_os_group_meta)?$wc_os_group_meta:array('wc_os_cats'=>array('group_cats'=>array())));
		
		//pree($wc_os_settings);
		
		$translation_array = array(
		
		
			'permission_text_warning' => __('This option will not work with Auto Split.', 'woo-order-splitter'),
			'wc_os_group_meta' => $wc_os_group_meta,
			'wc_os_nonce' => wp_create_nonce('wc_os_nonce_action'),
			'wc_os_vendor_nonce' => wp_create_nonce('wc_os_vendors_action'),
			'defined_rules_confirm' => __('Are you sure, you want delete this rule?', 'woo-order-splitter'),
			'this_url' => admin_url( 'admin.php?page=wc_os_settings' ),
			'conflict_status' => (!empty($conflict_status_options)?implode('', $conflict_status_options):''),
			'wc_os_defalut_split_1' => __('Manual split from order page will not follow the split rules which you defined on the settings page. Here you split with the manual selection.', 'woo-order-splitter'),
			'wc_os_defalut_split_2' => __('Split with the rules > Orders list page and the following icon', 'woo-order-splitter').' <span class="wc_os_manual_split"><a target="_blank" href="https://ibulb.wordpress.com/2021/04/05/auto-split-vs-manual-split/" class="wc_os_split"></a></span>',			
			'orders_list' => admin_url( 'edit.php?post_type=shop_order' ),
			'wc_os_ie' => $wc_os_settings['wc_os_ie'],
			'wc_os_tab' => (isset($_GET['t'])?esc_attr($_GET['t']):'0'),
			'wc_os_pg' => (isset($_GET['pg'])?esc_attr($_GET['pg']):'0'),
			'orders_list_refresh' => in_array('split-refresh', $wc_os_settings['wc_os_additional']),
			'mark_parent' => __('Click here to mark this item as parent/main order during this action', 'woo-order-splitter'),
			'wc_os_splitting' => (((isset($_GET['post_type']) && $_GET['post_type']=='shop_order') && 
			
							(
									
									((isset($_GET['order_id']) && is_numeric($_GET['order_id'])) && (isset($_GET['split']) && $_GET['split']=='init') && isset($_GET['split-session']))
								||
									isset($_GET['ids'])
									
							))?true:false),
			'wc_os_group_statuses' => (function_exists('wc_os_statuses_by_action') ? wc_os_statuses_by_action($wc_os_settings['wc_os_ie']) : array()),
		);
		
		$translation_array['booking_strings'] = array(
		        'd' => __('All booking items will be grouped by same date', 'woo-order-splitter'),
		        'm' => __('All booking items will be grouped by same month', 'woo-order-splitter'),
		        'y' => __('All booking items will be grouped by same year', 'woo-order-splitter'),
		        'd_m' => __('All booking items will be grouped by same day and month', 'woo-order-splitter'),
		        'd_y' => __('All booking items will be grouped by same day and year', 'woo-order-splitter'),
		        'm_y' => __('All booking items will be grouped by same month and year', 'woo-order-splitter'),
        );
		
		$translation_array['wos_email_tab'] = (isset($_GET['wos_email_tab']) ? $_GET['wos_email_tab'] : false);
		$translation_array['wc_os_product_search'] = (isset($_POST['wc_os_product_search']) ? sanitize_wc_os_data($_POST['wc_os_product_search']) : false);		
		$translation_array['wc_os_clear_email_log_nonce'] = wp_create_nonce('wc_os_clear_email_log_action');

		if($post_type == 'shop_order'){
            $custom_order_statuses = $wc_os_order_statuses_class->get_all_statuses();
            $shop_order_array = array(
                'post_type' => $post_type,
                'disable_split' => in_array('split', $wc_os_settings['wc_os_additional']),
                'post_status' => (array_key_exists('post_status', $_GET) ? $_GET['post_status'] : ''),
                'wc_os_order_cloning' => wc_os_order_cloning(),
                'wos_pending_str' => esc_attr(__('Change status to pending', 'woo-order-splitter')),
                'wos_cancelled_str' => esc_attr(__('Change status to cancelled', 'woo-order-splitter')),
                'wos_restore_str' => esc_attr(__('Force Restore', 'woo-order-splitter')),
                'clone_str' => esc_attr(__('Clone Orders', 'woo-order-splitter')),
                'split_str' => esc_attr(__('Split Orders', 'woo-order-splitter')),
                'combine_str' => esc_attr(__('Consolidate/Combine/Merge Orders', 'woo-order-splitter')),
                'mark_str' => esc_attr(__('Mark', 'woo-order-splitter')),
                'isset_mt' => isset($_GET['mt']),
                'isset_post' => isset($_GET['post']),
                'mt' => (isset($_GET['mt']) ? $_GET['mt'] : ''),
                'custom_order_statues' => (!empty($custom_order_statuses) ? $custom_order_statuses : false),
            );
            $translation_array = array_merge($translation_array, $shop_order_array);
        }
		$translation_array = apply_filters('wc_os_translation_array', $translation_array);		
		//pree($translation_array);exit;
		wp_localize_script( 'wos_scripts', 'wos_obj', $translation_array );
		
		
		
	}		
	
	add_filter( 'woocommerce_checkout_fields' , 'wc_os_override_checkout_fields' );
	
	function split_actions_display($key, $type){
		global $wc_os_cust, $wos_actions_arr;
		
		$action_type = ($type=='title'?'action':'description');
		return ((isset($wc_os_cust[$key]) && isset($wc_os_cust[$key][$type]) && $wc_os_cust[$key][$type]!='')?$wc_os_cust[$key][$type]:((isset($wos_actions_arr[$key]) && isset($wos_actions_arr[$key][$action_type]))?$wos_actions_arr[$key][$action_type]:''));
	}
	
	
	
	function wc_os_override_checkout_fields( $fields ) {
		
		global $wc_os_general_settings;
		$wc_os_general_settings = (is_array($wc_os_general_settings)?$wc_os_general_settings:array());
	
		if(array_key_exists('wc_os_shipping_off', $wc_os_general_settings)){
			unset($fields['shipping']['shipping_first_name']);
			unset($fields['shipping']['shipping_last_name']);
			unset($fields['shipping']['shipping_company']);
			unset($fields['shipping']['shipping_address_1']);
			unset($fields['shipping']['shipping_address_2']);
			unset($fields['shipping']['shipping_city']);
			unset($fields['shipping']['shipping_postcode']);
			unset($fields['shipping']['shipping_country']);
			unset($fields['shipping']['shipping_state']);
			unset($fields['shipping']['shipping_phone']);
			unset($fields['shipping']['shipping_email']);

		}
		
		if(array_key_exists('wc_os_billing_off', $wc_os_general_settings)){
			unset($fields['billing']['billing_first_name']);
			unset($fields['billing']['billing_last_name']);
			unset($fields['billing']['billing_company']);
			unset($fields['billing']['billing_address_1']);
			unset($fields['billing']['billing_address_2']);
			unset($fields['billing']['billing_city']);
			unset($fields['billing']['billing_postcode']);
			unset($fields['billing']['billing_country']);
			unset($fields['billing']['billing_state']);
			unset($fields['billing']['billing_phone']);	
			unset($fields['billing']['billing_email']);
		}
		
		if(array_key_exists('wc_os_order_comments_off', $wc_os_general_settings))
		unset($fields['order']['order_comments']);
		
		return $fields;
	}	
	
	function wc_os_header_scripts(){
		
		global $wc_os_general_settings;
?>
	<style type="text/css">
	<?php
		if(array_key_exists('wc_os_shipping_off', $wc_os_general_settings)){
?>
			.woocommerce-shipping-fields{
				display:none;	
			}
<?php			
		}
		if(array_key_exists('wc_os_billing_off', $wc_os_general_settings)){
?>
			.woocommerce-billing-fields{
				display:none;	
			}
<?php			
		}
		if(array_key_exists('wc_os_order_comments_off', $wc_os_general_settings)){
?>
			.woocommerce-additional-fields{
				display:none;
			}
<?php			
		}				
	?>
	</style>
<?php		
	}
	
	add_action('wp_head', 'wc_os_header_scripts');		
	
	function wc_os_order_cloning(){
		wc_os_settings_refresh();
		global $wc_os_settings;
		
		$cloning = (in_array('cloning', $wc_os_settings['wc_os_additional']));		
		
		return $cloning;
	}
	function wc_os_order_split(){
		wc_os_settings_refresh();
		global $wc_os_settings, $post;
		
		$split = (!in_array('split', $wc_os_settings['wc_os_additional']));
		$split_lock = (isset($wc_os_settings['wc_os_additional']['split_lock'])?$wc_os_settings['wc_os_additional']['split_lock']:array());
		
		if(!is_array($split_lock)){ //BACKWARDS COMPATIBILITY
			$wc_os_settings['wc_os_additional']['split_lock'] = ($split_lock!=''?array($split_lock):array());
			update_option('wc_os_settings', sanitize_wc_os_data($wc_os_settings));
		}
		
		$split_lock = is_array($split_lock)?$split_lock:array();
		
		//pree($split);
		//pree($split_lock);exit;
		if($split && !empty($split_lock)){
			$wc_os_order_splitter = new wc_os_order_splitter;
			//pree($_POST['post_ID']);
			//pree($post->ID);
			$order_id = (isset($_GET['order_id'])?sanitize_wc_os_data($_GET['order_id']):$wc_os_order_splitter->original_order_id);
			$order_id = (!$order_id?(isset($_POST['post_ID']) && $post->ID==$_POST['post_ID'])?sanitize_wc_os_data($_POST['post_ID']):$order_id:$order_id);
			//pree($order_id);
			//exit;
			//pree($split_lock);
			//pree($get_order_status);
			if($order_id){
				$get_order_status = str_replace('wc-', '', get_post_status($order_id));
				$split = empty($split_lock);
				
				if(!empty($split_lock)){
					foreach($split_lock as $split_lock_i){
						if(!$split){
							$split = ($get_order_status==$split_lock_i);
						}
					}
				}
			}
			
			//pree($get_order_status);
			//pree($split_lock);exit;
		}
		//pree($split);
		//exit;
		
		return $split;		
	}

	function wc_os_order_removal(){
		wc_os_settings_refresh();
		global $wc_os_settings;
		
		$removal = (in_array('removal', $wc_os_settings['wc_os_additional']));
		
		return $removal;		
	}
	function wc_os_order_removal_action($type='boolean'){
		wc_os_settings_refresh();
		global $wc_os_settings;
		
		$removal_lock = (array_key_exists('removal_lock', $wc_os_settings['wc_os_additional']) && $wc_os_settings['wc_os_additional']['removal_lock']);
		
		if($type=='string' && $removal_lock){
			$removal_lock = $wc_os_settings['wc_os_additional']['removal_lock'];
		}
		
		return $removal_lock;		
	}	
	
	function wc_os_order_split_removal_action($type='boolean'){
		wc_os_settings_refresh();
		global $wc_os_settings;
		
		$removal_lock = (array_key_exists('removal_lock_split', $wc_os_settings['wc_os_additional']) && $wc_os_settings['wc_os_additional']['removal_lock_split']);
		
		if($type=='string' && $removal_lock){
			$removal_lock = $wc_os_settings['wc_os_additional']['removal_lock_split'];
		}
		
		return $removal_lock;		
	}		
	
	function wc_os_order_split_status_action(){
		wc_os_settings_refresh();
		global $wc_os_settings;

		$split_status_lock = in_array('split_status_lock', $wc_os_settings['wc_os_additional']);
		$split_status_lock = (isset($wc_os_settings['wc_os_additional']['split_status_lock'])?$wc_os_settings['wc_os_additional']['split_status_lock']:'');
		
		
		return $split_status_lock;		
	}	
		
	function wc_os_order_qty_split(){
		wc_os_settings_refresh();
		global $wc_os_settings;
		
		$qty_split = (in_array('qty_split', $wc_os_settings['wc_os_additional']));
		
		return $qty_split;		
	}	
	
	add_action( 'pre_get_posts', 'wos_shop_page_pre_get_posts' );
	function wos_shop_page_pre_get_posts( $query ) {
		if ($query->is_main_query() && isset($_GET['vendor']) && is_numeric($_GET['vendor']) && $_GET['vendor']>0) :
			$query->set( 'author', sanitize_wc_os_data($_GET['vendor']) );
		endif;
	}
	function wc_os_links($actions, $post=array()){
		

	
	
		if (is_object($post) && $post->post_type=='shop_order' && wc_os_order_cloning()) {
			
			$url = admin_url( 'edit.php?post_type=shop_order&order_id=' . $post->ID );
			
			$copy_link = wp_nonce_url( add_query_arg( array( 'clone' => 'yes', 'clone-session' => date('Ymhi') ), $url ), 'edit_order_nonce' );
			
			$actions = array_merge( $actions, 
				array(
					'clone' => sprintf( '<a href="%1$s">%2$s</a>',
						esc_url( $copy_link ), 
						__('Clone', 'woo-order-splitter')
					) 
				) 
			);
		}
	
		if (is_object($post) && $post->post_type=='shop_order' && wc_os_order_split()) {
		
			$url = admin_url( 'edit.php?post_type=shop_order&order_id=' . $post->ID );
			
			$copy_link = wp_nonce_url( add_query_arg( array( 'split' => 'init', 'split-session' => date('Ymhi') ), $url ), 'edit_order_nonce' );
			
			$actions = array_merge( $actions, 
				array(
					'split' => sprintf( '<a href="%1$s">%2$s</a>',
						esc_url( $copy_link ), 
						__( 'Split', 'woo-order-splitter' )
					) 
				) 
			);
			
		}
		//pree($post->post_author);
		if (is_object($post) && $post->post_type=='product' && $post->post_author>0 && !isset($_GET['vendor'])) {
		
			$url = admin_url().'user-edit.php?user_id='. $post->post_author;
			
			$display_name = wos_get_author_name($post->post_author);
			
			$copy_link = wp_nonce_url( add_query_arg( array(), $url ), 'edit_order_nonce' );
			
			$actions = array_merge( $actions, 
				array(
					'vendor_url' => sprintf( '<a href="%1$s" target="_blank">%2$s</a>',
						esc_url( $copy_link ), 
						$display_name
					) 
				) 
			);
			
		}		
	
		return $actions;
				
	}
	
	add_filter( 'post_row_actions', 'wc_os_links', 10, 2 );
	
	function wos_get_author_name($vendor_id=0){
		$display_name = '';
		if($vendor_id>0){
			$vendor_data = get_user_by( 'ID', $vendor_id );
			if(!empty($vendor_data) && is_object($vendor_data)){
				$full_name = trim($vendor_data->first_name.' '.$vendor_data->last_name);
				$display_name = trim($vendor_data->display_name?$vendor_data->user_login:$vendor_data->user_login).($full_name?' ('.$full_name.')':'');
				$display_name = ($display_name?$display_name:$vendor_data->user_email);		
			}
		}
		return $display_name;
	}
		
	function sv_wc_add_order_meta_box_action( $actions ) {
		global $theorder;

		global $wc_os_settings;
		
		$split_status = get_post_meta($theorder->get_order_number(), 'split_status', true);
		$splitted_from = get_post_meta($theorder->get_order_number(), 'splitted_from', true);	
		
		//wc_os_pree($wc_os_settings);
		//wc_os_pree(!$theorder->is_paid());
		//wc_os_pree($split_status);
		//wc_os_pree($splitted_from);
				
		// bail if the order has been paid for or this action has been run
		//! $theorder->is_paid() || 
		if ( $split_status || $splitted_from) {
			return $actions;
		}
	
	
		// add "mark printed" custom action
		//wc_os_pree(wc_os_order_split());
		if(wc_os_order_split()){
			$actions['wc_os_split_action'] = __( 'Split Order', 'woo-order-splitter' );
		}
		
		return $actions;
	}
	add_action( 'woocommerce_order_actions', 'sv_wc_add_order_meta_box_action' );	
		
	function sv_wc_process_order_meta_box_action( $order ) {
		//wc_os_pree($order->get_id());exit;
		
		wc_os_checkout_order_processed($order->get_order_number());
		
	}
	
	//add_action( 'woocommerce_order_action_wc_custom_order_action', 'sv_wc_process_order_meta_box_action' );
	function wc_order_total_qty($order){
		$qty = 0;		
		foreach($order->get_items() as $item_id=>$item_data){
		
			$qty += $item_data->get_quantity();
			
		}
		
		return $qty;
	}
	
	
		
	add_filter( 'woocommerce_admin_order_actions', 'add_wc_os_order_status_actions_button', 100, 2 );
	function add_wc_os_order_status_actions_button( $actions, $order ) {
		// Display the button for all orders that have a 'processing' status
		global $wc_os_settings;
		//pree($wc_os_settings['wc_os_ie']);
		//pree($order->get_id());exit;
		$url = admin_url( 'edit.php?post_type=shop_order&order_id=' . $order->get_id() );
		//pree($url);
		$conflict_status = get_post_meta($order->get_order_number(), 'conflict_status', true);
		
		$split_lock = (isset($wc_os_settings['wc_os_additional']['split_lock'])?$wc_os_settings['wc_os_additional']['split_lock']:array());
		$split_lock = is_array($split_lock)?$split_lock:array();
		//pree($order->get_id(), 3);pree($split_lock, 3);
		
		$group_by_vendors = (isset($wc_os_settings['wc_os_ie']) && $wc_os_settings['wc_os_ie']=='group_by_vendors');
		
		//$status_arr = array( 'processing', 'on-hold', 'completed', 'pending' );
		//$status_arr[] = str_replace('wc-', '', $split_lock);
		//$status_arr = array_unique($status_arr);
		
		$wc_os_order_statuses = wc_get_order_statuses(); 
		$wc_os_order_statuses_keys = array_keys($wc_os_order_statuses);		
		$wc_os_order_statuses_keys = array_unique($wc_os_order_statuses_keys);
		
		//pree($split_lock, 3);
		$status_lock_released = empty($split_lock);
		//pree($order->get_id().': '.$status_lock_released, 3);
		if(!empty($split_lock)){
			foreach($split_lock as $split_lock_i){				
				if(!$status_lock_released){
					$status_lock_released = $order->has_status($split_lock_i);
				}
			}
		}
		
		//pre($status_arr);
		//pre($order->get_status());
		
		if ( $status_lock_released && wc_os_order_split() ) {
			
			$split_status = get_post_meta($order->get_id(), 'split_status', true);
			
			$splitted_from = get_post_meta($order->get_id(), 'splitted_from', true);
			
			$order_total_qty = wc_order_total_qty($order);
			//wc_os_pree(count($order->get_items())>1);exit;
			//wc_os_pree('$order_total_qty: '.$order_total_qty.' && wc_os_ie:'. $wc_os_settings['wc_os_ie']);
			//wc_os_pree('$split_status: '.$split_status.' && '.'$splitted_from: '.$splitted_from);
			
			$is_bundle = false;
			$vendors_arr = array();
			
			if(count($order->get_items())>0){			
				foreach($order->get_items() as $item_id=>$item_values){
					$pid = $item_values->get_product_id();
					
					if(count($order->get_items())==1){
	
						$vid = $item_values->get_variation_id();
						$product_item = $vid?$vid:$pid;				
						$product = wc_get_product($pid);
						
	
						
						if(is_object($product) && method_exists($product, 'get_type')){
							$is_bundle = ($product->get_type()=='bundle');
						}
					}
					//pree($pid);
					if($wc_os_settings['wc_os_ie']){
						$product_post = get_post($pid);
						$vendors_arr[] = $product_post->post_author;
					}
				}
				$vendors_arr = array_unique($vendors_arr);
			}
			
			
			//pree($vendors_arr);
			$methods_based_condition = true;
			
			switch($wc_os_settings['wc_os_ie']){
				case 'subscription_split':
					$methods_based_condition = (
						(count($order->get_items())>=1 || $order_total_qty>1) //30/04/2021
					);
				break;
				case 'group_by_vendors':
					$methods_based_condition = (count($order->get_items())>1 && $group_by_vendors && count($vendors_arr)>1); //20/08/2020
				break;
				case 'io':
					$methods_based_condition = (
						(count($order->get_items())>=1) //17/03/2021
					);
				break;
				default:
					//pree('$methods_based_condition');
					$methods_based_condition = (
						(count($order->get_items())>1 || (count($order->get_items())==1 && $is_bundle))
					|| 
						($order_total_qty>1 && $wc_os_settings['wc_os_ie']=='quantity_split') //21/05/2019
					);
				break;
			}
			
			
			
			//pree(!$split_status .' && '.!$splitted_from.' && '.$methods_based_condition, 3);
			if(!$split_status && !$splitted_from && $methods_based_condition){
	
				
				
				$copy_link = wp_nonce_url( add_query_arg( array( 'split' => 'init', 'split-session' => date('Ymhi') ), $url ), 'edit_order_nonce' );
				
				// Get Order ID (compatibility all WC versions)
				$order_id = $order->get_order_number();
				// Set the action button
				$actions['split_order'] = array(
					'url'       => $copy_link,
					'name'      => __( 'Split Order', 'woo-order-splitter' ),
					'action'    => "wc_os_split", 
				);
				
			}
		}
		
		if(wc_os_order_cloning()){
				
			$copy_link = wp_nonce_url( add_query_arg( array( 'clone' => 'yes', 'clone-session' => date('Ymhi') ), $url ), 'edit_order_nonce' );				
			$actions['clone_order'] = array(
				'url'       => $copy_link,
				'name'      => __( 'Clone Order', 'woo-order-splitter' ),
				'action'    => "wc_os_clone", 
			);	
		}
		
		if($conflict_status){			

			$actions['clone_order'] = array(
				'url'       => get_edit_post_link($order->get_order_number()),
				'name'      => __( 'Conflict Alert!', 'woo-order-splitter' ),
				'action'    => "wc_os_conflict", 
			);	
			
		}
		
		
		return $actions;
	}	
	
	function wos_clone_order_notes($original_order_id=0, $order_id=array()){
		//pree($original_order_id);
		//pree($order_id);exit;
		if($original_order_id && ((is_numeric($order_id) && $original_order_id != $order_id) || (is_array($order_id) && !in_array($original_order_id, $order_id)))){
			
			$order_id = (is_numeric($order_id)?array($order_id):$order_id);

			global $wpdb;		
			$comments_query = "SELECT * FROM $wpdb->comments WHERE comment_post_ID=$original_order_id ORDER BY comment_ID DESC";
			//wc_os_pree($comments_query);
			$original_order = wc_get_order($original_order_id);
			$comments_results = $wpdb->get_results($comments_query);
			//$orginal_order_post = get_posts(array('include'=>$original_order_id, 'post_type'=>'shop_order', 'post_status'=>'any'));
			//$orginal_order_post = (!empty($orginal_order_post)?current($orginal_order_post):'');
			//pree($original_order_id);
			//pree(get_post($original_order_id));
			//pree($orginal_order_post);
			//pree($original_order->customer_message);
			
			//wc_os_pree($comments_results);
			if(!empty($comments_results)) {

                foreach ($comments_results as $comments) {


                    unset($comments->comment_ID);
                    if (!empty($order_id)) {
                        foreach ($order_id as $new_order_id) {
//						    wc_os_pree(is_array($comments));
                            if (is_array($comments)) {

                                $comments['comment_post_ID'] = $new_order_id;

                            } elseif(isset($comments->comment_post_ID)) {
                                $comments->comment_post_ID;
                            }
                            $comments = (array)$comments;
                            //wc_os_pree($comments);//exit;
                            if (wp_insert_comment($comments)) {
//								wc_os_pree($comments->comment_post_ID.' > Ok');
                            } else {
//								wc_os_pree($comments->comment_post_ID.' > Failed');
                            }

                        }
                    }
                }
            }

			if(!empty($order_id) && !empty($original_order) && $original_order->get_customer_note()!=''){					
				foreach($order_id as $new_order_id){
					$my_order = array(
						  'ID'           => $new_order_id,
						  'post_excerpt' => $original_order->get_customer_note()
					  );
					wp_update_post( $my_order );
				}
			}
			//exit;
			
		}
	}	
	
	function wc_os_random_color_part() {
		return str_pad( dechex( mt_rand( 0, 255 ) ), 2, '0', STR_PAD_LEFT);
	}
	
	function wc_os_random_color() {
		return wc_os_random_color_part() . wc_os_random_color_part() . wc_os_random_color_part();
	}	
	
	function wos_troubleshooting(){
		extract($_POST);
		$ret = array();
		$hex = '#'.wc_os_random_color();
		$ret['color_hex'] = $hex;
		list($r, $g, $b) = sscanf($hex, "#%02x%02x%02x");
		$ret['color'] = array('r'=>$r, 'g'=>$g, 'b'=>$b);
		$order_data = new WC_Order($order_id);
		
		$order_data->calculate_totals();
		
		$get_items = $order_data->get_items();
		$shipping_items = $order_data->get_items('shipping');
		
		
		$meta = get_post_meta($order_id);
		$wc_os_meta_keys = get_option('wc_os_meta_keys', array());
		
		$cloned_from = (isset($meta['cloned_from'])?$meta['cloned_from'][0]:false);
		$splitted_from = (isset($meta['splitted_from'])?$meta['splitted_from'][0]:false);
		
		
		$wc_os_meta_data = array(
			'parent_order' => (!$cloned_from && !$splitted_from)?'Yes':'No',
			'cloned_from' => $cloned_from?'<a target="_blank" href="'.get_edit_post_link($cloned_from).'">'.$cloned_from.'</a>':'-',
			'splitted_from' => $splitted_from?'<a target="_blank" href="'.get_edit_post_link($splitted_from).'">'.$splitted_from.'</a>':'-',
		);
				
		ob_start();
		
		foreach($get_items as $item_id=>$item_data){

			//wc_os_pree($item_id);
			
			//wc_os_pree(get_metadata( 'order_item', $item_id, '_line_subtotal_tax'));
			//wc_os_pree(get_metadata( 'order_item', $item_id, '_line_tax'));
			//wc_os_pree(get_metadata( 'order_item', $item_id, '_line_tax_data'));

/*
			update_metadata( 'order_item', $item_id, '_line_subtotal_tax', 0);
			update_metadata( 'order_item', $item_id, '_line_tax_data', 0);
			update_metadata( 'order_item', $item_id, '_line_tax_data', array());
*/			
			
			//wc_os_pree($item_data);
			
			//wc_os_pree(wc_get_order_item_meta( $item_id ));

		}
		
		wc_os_pree($wc_os_meta_data);
		
		wc_os_pree($order_data);
		
		wc_os_pree($meta);		
		
		wc_os_pree($get_items);		
		
		wc_os_pree($shipping_items);
		
		$ret['html'] = ob_get_contents();
		ob_end_clean();
		
		
		$ret = json_encode($ret);
		echo $ret;
		exit;
	}
	
	add_action( 'wp_ajax_wos_troubleshooting', 'wos_troubleshooting' );
	
	
	function wos_auto_settings(){
		
		global $wc_os_settings;
		$wc_os_products = $wc_os_settings['wc_os_products'];
		$ret = $selected_items = array();
		
		$wc_os_ie = sanitize_wc_os_data($_POST['wc_os_ie']);
		//pree($wc_os_ie);exit;
		//$products = wc_os_get_products();
		
		switch($wc_os_ie){
			default:
				if(array_key_exists($wc_os_ie, $wc_os_products)){
					$selected_items = $wc_os_products[$wc_os_ie];
					unset($wc_os_products[$wc_os_ie]);
				}
				
				$ret = array($selected_items, $wc_os_products);
				
			break;
			
			case 'cats':
				
				$ret = $wc_os_settings['wc_os_cats']['cats'];
				
			break;
			
			
			case 'group_cats':
				
				$ret = $wc_os_settings['wc_os_cats']['group_cats'];
				
			break;
			
			
			case 'group_by_vendors':
				
				$ret = $wc_os_settings['wc_os_vendors'];
				
			break;		
            case 'group_by_woo_vendors':

                $ret = $wc_os_settings['wc_os_woo_vendors'];

			break;							
		}
				
		
		/*
		if(!empty($products)){
			foreach($products as $prod){				
				$product = wc_get_product($prod->ID);
				$ticked = in_array($prod->ID, $wc_os_settings['wc_os_products']);
				$ret[] = array(
								'id'=>$prod->ID, 
								'stock'=>$product->managing_stock()?(($product->is_in_stock() && $product->get_stock_quantity()>0)?'<span class="green"><b>'.__('In', 'woo-order-splitter').'</b></span>':'<span class="red">'.__('Out', 'woo-order-splitter').'</span>'):'<small class="faded">'.__('N/A', 'woo-order-splitter').'</small>',
								'title_price'=>$prod->post_title.' '.$wc_os_currency.$product->get_price(),
								'edit_link'=>get_edit_post_link($prod->ID),
								'view_link'=>get_permalink($prod->ID)
						);
			}
		}*/
		
		
		$ret = json_encode($ret);
		echo $ret;
		exit;
	}	
	
	add_action( 'wp_ajax_wos_auto_settings', 'wos_auto_settings' );
	
	function wos_forced_ie(){
		if(isset($_POST['order_action'])){
			$order_id = sanitize_wc_os_data($_POST['order_id']);
			$order_data = wc_get_order( $order_id );
			if(!empty($order_data)){
				update_post_meta($order_id, 'wos_forced_ie', sanitize_wc_os_data($_POST['order_action']));
				update_post_meta($order_id, 'wc_os_order_splitter_cron', true);				
				delete_post_meta($order_id, 'conflict_status');
				delete_post_meta($order_id, 'split_status');

			}
		}
		exit;
	}
	
	add_action( 'wp_ajax_wos_forced_ie', 'wos_forced_ie' );
	
	function wpdocs_filter_wp_title( $title, $sep ) {
		global $paged, $page;
	 
		if ( is_feed() )
		return $title;
	 
		// Add the site name.
		$title .= get_bloginfo( 'name' );
	 
		// Add the site description for the home/front page.
		$site_description = get_bloginfo( 'description', 'display' );
		if ( $site_description && ( is_home() || is_front_page() ) )
			$title = "$title $sep $site_description";
	 
		// Add a page number if necessary.
		if ( $paged >= 2 || $page >= 2 )
			$title = "$title $sep " . __( 'Page', 'woo-order-splitter' ).' '.sprintf( '%s', max( $paged, $page ) );
	 
		return $title;
	}	
	
	add_filter( 'wp_title', 'wpdocs_filter_wp_title', 10, 2 );
	
	function wos_cart_notices($content=''){
		
		global $wos_notices_css;
		//pree($_SERVER);
		$notice_text = '';
		
		$wos_cart_notices = get_option( 'wc_os_cart_notices', true);
		$page_type = '';
		
		if(is_cart()){
			$notice_text = isset($wos_cart_notices['cart'])?$wos_cart_notices['cart']:'';
			$page_type = 'cart';
		}if(is_checkout()){
			$notice_text = isset($wos_cart_notices['checkout'])?$wos_cart_notices['checkout']:'';
			$page_type = 'checkout';
		}if(is_product()){
			$notice_text = isset($wos_cart_notices['product'])?$wos_cart_notices['product']:'';
			$page_type = 'product';
		}if(is_shop()){
			$notice_text = isset($wos_cart_notices['shop'])?$wos_cart_notices['shop']:'';
			$page_type = 'shop';
		}
		
		$wos_notices_css = ((isset($wos_cart_notices['styles']) && $wos_cart_notices['styles']!='')?$wos_cart_notices['styles']:$wos_notices_css);
		
		if($notice_text){
			$notice_text = '<style type="text/css">							
							'.$wos_notices_css.'
							</style><div class="wos_notice_div wos_'.$page_type.'">'.$notice_text.'</div>';
							
							
							
							/*'<script type="text/javascript" language="javascript">
								jQuery(document).ready(function($){
									if($(".wos_notice_div.wos_product").length>1)
									$(".wos_notice_div.wos_product").eq(0).remove();
									
									if($(".wos_notice_div.wos_product").length>0)
									$(".wos_notice_div.wos_product").eq(0).show();
									
								});
							</script>							
							';*/
		}
		
		if(is_product()){
			return $notice_text.$content;
		}elseif(is_shop()){
			return $notice_text.$content;
		}else{
			return $content;
		}
	}
		
	add_filter('the_content', 'wos_cart_notices', 20);	
	
	add_filter('woocommerce_before_main_content', 'wos_cart_notices', 5);
	
	add_filter('woocommerce_before_single_product', 'wos_cart_notices', 10);
	
	function wos_filter_woocommerce_can_reduce_order_stock( $return, $order ) { 
		
		$order_id = $order->get_id();

		$wc_os_logger_str = 'Before: reduce_order_stock #'.$order_id.' '.($return?'YES':'NO');
		//wc_os_logger('email', $wc_os_logger_str);
		
		if($order_id){
			$post_meta = get_post_meta($order_id);
			
			if(!empty($post_meta)){			
				$post_meta = array_keys($post_meta);			
				$is_parent_order = (!in_array('splitted_from', $post_meta) && !in_array('cloned_from', $post_meta));			
				if($is_parent_order){
					$return = true;
				}else{
					$return = false;
				}
			}
			
		}

		$wc_os_logger_str = 'After: reduce_order_stock #'.$order_id.' '.($return?'YES':'NO');
		//wc_os_logger('email', $wc_os_logger_str);
				
		return $return; 
	}
	
	
	add_action('wp_ajax_wos_quick_split', 'wos_quick_split');
	
	if(!function_exists('wos_quick_split')){
		function wos_quick_split(){
			$url = parse_url($_POST['url']);
			parse_str($url['query'], $query_string);
			//pree($query_string);exit;
			global $wc_os_order_splitter, $wc_os_general_settings, $wc_os_shipping_cost;
			
			//pree($query_string['order_id']);
			
			if($wc_os_shipping_cost){

				$child_orders_by_order_id = wc_os_child_orders_by_order_id($query_string['order_id'], true);

				if(!empty($child_orders_by_order_id)){
					foreach($child_orders_by_order_id as $child_order_id){
						$_wc_os_set_status = get_post_meta($child_order_id, '_wc_os_set_status', true);
						
						if($_wc_os_set_status){
							$child_order = wc_get_order($child_order_id);
							$child_order->set_status(wc_os_add_prefix($_wc_os_set_status, 'wc-'));
							$child_order->save(); //__wos_change_order_received_text()
							
							delete_post_meta($child_order_id, '_wc_os_set_status');
						}
					}
				}
				
			}
			
			
			$wc_os_parent_order_email = !array_key_exists('wc_os_parent_order_email', $wc_os_general_settings);
			//pree($wc_os_order_splitter);
			$wc_os_order_splitter->splitCheck($query_string['split'], $query_string['_wpnonce'], $query_string['order_id'], true);
			$crons_order_id = (wc_os_crons($query_string['order_id'])==$query_string['order_id']);
			echo ($crons_order_id?$query_string['order_id']:0);			
			
			
			//
			//
			
			
			if($crons_order_id && $wc_os_parent_order_email){								
				wc_os_process_parent_email($query_string['order_id']);
			}
			exit;
		}
	}
	if(!function_exists('wc_os_trash_post')){
		function wc_os_trash_post($originalorderid=0){
			if($originalorderid){
				$has_child_orders = (count(wc_os_child_orders_by_order_id($originalorderid))>0);
				if($has_child_orders){
					wp_trash_post($originalorderid);
				}
			}
		}
	}	
	if(!function_exists('wc_os_force_trash_post')){
		function wc_os_force_trash_post($originalorderid=0){
			if($originalorderid){
				wp_trash_post($originalorderid);
			}
		}
	}										

	if(!function_exists('wc_os_cron_jobs')){
		function wc_os_cron_jobs(){
			if(isset($_GET['wc_os_cron_jobs'])){
				$order_id = isset($_GET['order_id'])?sanitize_wc_os_data($_GET['order_id']):0;
				//$_wos_restored = get_post_meta($order_id, 'wos_untrashed', true);
				//if(!$_wos_restored){
					wc_os_crons($order_id);exit;
				//}
			}
			
			//if(isset($_GET['refreshed']) && $_GET['refreshed']=='true'){
			//	wc_os_order_remove_shipping_adjustment(67704);
			//}
		}
		
		//add_action('woocommerce_order_status_pending', 'wc_os_checkout_order_processed');
		//add_action('woocommerce_order_status_on-hold', 'wc_os_checkout_order_processed');
		//add_action('woocommerce_order_status_processing', 'wc_os_checkout_order_processed');
		//add_action('woocommerce_order_status_completed', 'wc_os_checkout_order_processed');	
			
		add_action('init', 'wc_os_cron_jobs');
	}
	
	if(!function_exists('wc_os_chosen_shipping_methods')){
		function wc_os_chosen_shipping_methods(){
				
			$chosen_methods = wc_os_get_session( 'chosen_shipping_methods' );
			$chosen_shipping = !empty($chosen_methods)?current($chosen_methods):''; 
			
			echo $chosen_shipping;exit;
			
		}
	}


	add_action('wp_ajax_wc_os_customer_permitted_method', 'wc_os_customer_permitted_method');
	add_action('wp_ajax_nopriv_wc_os_customer_permitted_method', 'wc_os_customer_permitted_method');


    if(!function_exists('wc_os_customer_permitted_method')){
        function wc_os_customer_permitted_method(){
			
				$resp = array();

                if(isset($_POST['wc_os_customer_permitted'])){

                    if (
                        ! isset( $_POST['wc_os_customer_permitted_nonce'] )
                        || ! wp_verify_nonce( $_POST['wc_os_customer_permitted_nonce'], 'wc_os_customer_permitted_action' )
                    ) {

                        _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
                        exit;

                    } else {


                        $wc_os_customer_permitted = sanitize_wc_os_data($_POST['wc_os_customer_permitted']);

                        WC()->session->set( 'wc_os_customer_permitted', $wc_os_customer_permitted );
						
						//pree($wc_os_customer_permitted);

						if($wc_os_customer_permitted=='on'){
							$fee = wc_os_get_session('wc_os_calculated_shipping_cost');
							$resp['total'] = wc_price(WC()->cart->get_cart_contents_total() + WC()->cart->get_cart_contents_tax() + ($fee));
						}else{
							$fee = 0;							
							$resp['total'] = '';
						}
						$resp['fee'] = wc_price($fee);
						
						
						

                    }

                }
				
				echo json_encode($resp);

                wp_die();

        }
    }
	
	add_filter( 'woocommerce_order_item_get_formatted_meta_data', 'wc_os_item_get_formatted_meta_data', 10, 1 );
	
	function wc_os_item_get_formatted_meta_data($formatted_meta){
		
		$formatted_meta = ((isset($_GET['refreshed']) && $_GET['refreshed']=='true')?array():$formatted_meta);
		
		return $formatted_meta;
	}	
	
    function wc_os_save_order_log($order){


//
//        $order = new WC_Order($order_id);

         $order_id = $order->get_id();


        if($order instanceof  WC_Order){

            
			$order_log = wc_os_logger('order');

            $order_log_string = "Order# $order_id- | ";
            $order_items = $order->get_items();
            $order_item_string = array();

            if(!empty($order_items)){


                foreach($order_items as $item_id => $item){

                    $order_item_string[] = $item->get_name(). ' &times; '. $item->get_quantity();

                }
            }

            $order_total = wc_price($order->get_total());
            $order_log_string .= implode(', ', $order_item_string);
            $order_log_string .= " | $order_total";


            $order_log[$order_id] = $order_log_string;
			
			wc_os_logger('order', $order_log);


        }



    }

    add_action('wp_ajax_wc_os_clear_order_log', 'wc_os_clear_order_log');

    if(!function_exists('wc_os_clear_order_log')){
        function wc_os_clear_order_log($force=false){

            if((!empty($_POST) && isset($_POST['wc_os_clear_order_log'])) || $force){

                if (
					!$force
					&&
					(
						! isset( $_POST['wc_os_clear_email_log_field'] )
						|| ! wp_verify_nonce( $_POST['wc_os_clear_email_log_field'], 'wc_os_clear_email_log_action' )
					)
                ) {

                    _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
                    exit;

                } else {


                    if($force || $_POST['wc_os_clear_order_log']){

                        delete_option('wc_os_remove_order_log');
						_e('Order log removed!', 'woo-order-splitter');
						if($force){
							//pree(get_option('wc_os_remove_order_log'));
						}

                    }

                }
            }

            wp_die();
        }
    }
	
	add_action('wp_ajax_wc_os_email_log', 'wc_os_email_log');
	
    if(!function_exists('wc_os_email_log')){
        function wc_os_email_log(){

            if(!empty($_POST) && isset($_POST['wc_os_email_log'])){

                if (
                    ! isset( $_POST['wc_os_clear_email_log_field'] )
                    || ! wp_verify_nonce( $_POST['wc_os_clear_email_log_field'], 'wc_os_clear_email_log_action' )
                ) {

                    _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
                    exit;

                } else {

					
                    if($_POST['wc_os_email_log']){
						
						if($_POST['wc_os_email_log']=='no'){
	                        update_option('wc_os_email_log', true);
						}else{
							delete_option('wc_os_email_log');
						}

                    }

                }
            }

            wp_die();
        }
    }	
	
	add_action('wp_ajax_wc_os_order_log', 'wc_os_order_log');
	
    if(!function_exists('wc_os_order_log')){
        function wc_os_order_log(){

            if(!empty($_POST) && isset($_POST['wc_os_order_log'])){

                if (
                    ! isset( $_POST['wc_os_clear_email_log_field'] )
                    || ! wp_verify_nonce( $_POST['wc_os_clear_email_log_field'], 'wc_os_clear_email_log_action' )
                ) {

                    _e('Sorry, your nonce did not verify.', 'woo-order-splitter');
                    exit;

                } else {

					//pree($_POST);
                    if($_POST['wc_os_order_log']){
						
						if($_POST['wc_os_order_log']=='no'){
	                        update_option('wc_os_order_log', true);
						}else{
							delete_option('wc_os_order_log');
						}

                    }

                }
            }

            wp_die();
        }
    }		

    // this function used for generate select and video html for quantity split method
    if(!function_exists('wc_os_get_quantity_split_extra')){
        function wc_os_get_quantity_split_extra(){
            global $wc_os_settings;
            ?>

            <div class="qty_split_options">

                <a title="<?php _e('Default (All qty. to x1) - Video Tutorial', 'woo-order-splitter'); ?>" class="split_default" href="https://www.youtube.com/embed/vspbAX8Krx4" target="_blank"><i class="fab fa-youtube"></i></a> &nbsp; <a title="<?php _e('Custom (Split only defined values) - Video Tutorial', 'woo-order-splitter'); ?>" class="split_custom" href="https://www.youtube.com/embed/7m05fzIQlqY" target="_blank"><i class="fab fa-youtube"></i></a>&nbsp; <a title="<?php _e('Eric (Selected + Defined values) - Video Tutorial', 'woo-order-splitter'); ?>" class="split_eric_logic" href="https://www.youtube.com/embed/KSl_5VC1PPs" target="_blank"><i class="fab fa-youtube"></i></a>

                <select name="wc_os_settings[wc_os_qty_split_option]">

                    <option value="default" <?php selected($wc_os_settings['wc_os_qty_split_option']=='default'); ?>><?php _e('Default (All qty. to x1)', 'woo-order-splitter'); ?></option>

                    <option value="custom" <?php selected($wc_os_settings['wc_os_qty_split_option']=='custom'); ?>><?php _e('Custom (Split only defined values)', 'woo-order-splitter'); ?></option>

                    <option value="eric_logic" <?php selected($wc_os_settings['wc_os_qty_split_option']=='eric_logic'); ?>><?php _e('Eric Logic (Selected+Defined items/quantity into new order)', 'woo-order-splitter'); ?></option>

                </select>


            </div>


            <?php

        }
    }

    // this function generate youtube video url section used inside ie html
    if(!function_exists('wc_os_get_video_url_section')){
        function wc_os_get_video_url_section($video_urls = array()){

            if(!empty($video_urls)):
            ?>

                <div class="qty_split_options">

                    <?php

                        foreach($video_urls as $url_data):
								list($url_title, $url) = $url_data;
								$url_title = ($url_title?$url_title:__('Video Tutorial', 'woo-order-splitter'));
								echo ($url?'<a class="split_default" title="'.$url_title.'" href="'.$url.'" target="_blank"><i class="fab fa-youtube"></i></a>':'');

                        endforeach;


                    ?>

                </div>

            <?php

            endif;
        }
    }

    // this function generate html for methods from array
    if(!function_exists('wc_os_get_ie_html')){
        function wc_os_get_ie_html(){

            global $wc_os_ie_arr, $wc_os_pro;

            ?>

            <ul class="wc_os_ie_wrapper">

                <?php

                        if(!empty($wc_os_ie_arr)){
                            foreach($wc_os_ie_arr as $id => $items_arr){


                                echo "<li class='$id'>";

                                    if($id == 'wc_os_ie_products'){

                                        ?>

                                            <label for="wc_os_ie_products"><input type="radio" value="default" id="wc_os_ie_products" name="wc_os_settings[wc_os_ie]" <?php //checked($wc_os_settings['wc_os_ie']=='default'); ?> /><?php echo _e('Product Based', 'woo-order-splitter'); ?> <i>(<?php echo split_actions_display('default', 'title'); ?> | <?php echo split_actions_display('exclusive', 'title'); ?> | <?php echo split_actions_display('inclusive', 'title'); ?> | <?php echo split_actions_display('shredder', 'title'); ?> | <?php echo split_actions_display('io', 'title'); ?> | <?php echo split_actions_display('quantity_split', 'title'); ?>)</i> </label><div class="qty_split_options"><a title="<?php _e('Video Tutorial', 'woo-order-splitter'); ?>" class="split_default" href="https://www.youtube.com/embed/tOT4l7_GCIw" target="_blank"><i class="fab fa-youtube"></i></a></div>

                                        <?php

                                        wc_os_get_video_url_section(array(array(__('Video Tutorial', 'woo-order-splitter'),'https://www.youtube.com/embed/tOT4l7_GCIw')));

                                    }


                                ?>


                                <ul>
                                    <?php

                                    if(!empty($items_arr)):

                                        foreach($items_arr as $ie => $ie_data):

                                            $id = $ie_data['id'];
                                            $classes = (array_key_exists('class', $ie_data) ? $ie_data['class'] : '');
                                            $videos = (array_key_exists('video', $ie_data) && is_array($ie_data['video'])? $ie_data['video'] : array());
                                            $image = (array_key_exists('img', $ie_data) && $ie_data['img']? $ie_data['img'] : '');
                                            $id_class = ($classes ? $id.' '.$classes : $id);
                                            $title = split_actions_display($ie, 'title');
                                            $description = split_actions_display($ie, 'description');
                                            $is_premium = (array_key_exists('premium', $ie_data) ? $ie_data['premium'] : false);
                                            $is_not_pro_item = ($is_premium && !$wc_os_pro);


                                            ?>

                                            <li class="<?php echo $id_class ?> <?php echo ($is_not_pro_item ? 'wc_os_premium' : ''); ?>">
                                                <label for="<?php echo $id ?>">
                                                    <input type="radio"  data-title="<?php echo $title; ?>" value="<?php echo $ie ?>" id="<?php echo $id ?>" name="wc_os_settings[wc_os_ie]" />                                                    
                                                    <?php echo $title; ?> <i>(<?php echo $description; ?>)</i>
                                                </label>
                                                <?php

                                                    if(!empty($videos)){
                                                        wc_os_get_video_url_section($videos);
                                                    }

                                                    if($ie == 'quantity_split'){
                                                        wc_os_get_quantity_split_extra();
                                                    }

                                                ?>
                                                <?php echo ($image?'<a class="wos-va" href="//ps.w.org/woo-order-splitter/assets/'.$image.'" target="_blank"></a>':''); ?>
                                                <?php do_action('wc_os_ie_options_'.$ie, $ie); ?>
                                            </li>

                                    <?php
                                        endforeach;
                                    endif;
                                    ?>


                                </ul>

                                <?php


                                echo '</li>';

                            }
                        }

                ?>

            </ul>

            <?php



        }
    }

    //this function return single array of all available methods
    if(!function_exists('wc_os_get_ie_methods_list')){
        function wc_os_get_ie_methods_list(){

            global $wc_os_ie_arr;

            $ie_list = array();
            if(!empty($wc_os_ie_arr)){
                foreach($wc_os_ie_arr as $ie_group_key => $ie_array){
                    if(!empty($ie_array)){

                        $ie_list = array_merge($ie_list, $ie_array);
                    }
                }
            }

            return $ie_list;
        }
    }

    // this function get all the groups of acf fields and generate checkboxes according to these groups
    if(!function_exists('wc_os_acf_group_fields_screen_options')){
        function wc_os_acf_group_fields_screen_options($method_checked){

            global $is_acf, $wos_acf_string;
            $group_args = array(

                'numberposts' => -1,
                'post_status' => 'any',
                'post_type' => 'acf-field-group',

            );
            $acf_groups = ($is_acf? get_posts($group_args): array());
            $wc_os_acf_group_selection = get_option('wc_os_acf_group_selection', array());

            ?>

              <div class="wc_os_acf_group_selection" style="display: <?php echo $method_checked ? '' : 'none' ?>">



                <?php
                if(!empty($acf_groups)){

                    ?>

                    <h5>
                        <?php _e('Select ACF Groups to show fields', 'woo-order-splitter') ?>
                    </h5>

                    <?php

                    foreach($acf_groups as $group){

                        ?>

                        <label>
                            <input class="group_input" name="acf_group_selection" type="checkbox" value="<?php echo $group->ID; ?>" <?php echo checked(in_array($group->ID, $wc_os_acf_group_selection)); ?>>
                            <?php echo $group->post_title ?>
                        </label>

                        <?php

                    }


                }else {

                    if($is_acf):

                        ?>

                        <div>
                            <?php _e('No ACF group found ', 'woo-order-splitter') ?>
                            <a target="_blank" href="<?php echo admin_url('post-new.php?post_type=acf-field-group'); ?>"><?php _e('Click here', 'woo-order-splitter') ?> </a> <?php _e('to create new ACF group', 'woo-order-splitter')?>
                        </div>

                    <?php

                    else:

                        echo $wos_acf_string;
                    endif;

                }

                ?>

            </div>


            <?php

        }
    }

    //generate screen options wrapper and button for toggle
    if(!function_exists('wc_os_method_screen_option_html')){
        function wc_os_method_screen_option_html(){

            global $wc_os_url;


            $ie_method_list = wc_os_get_ie_methods_list();
            $wc_os_ie_method_selection = get_option('wc_os_ie_method_selection', false);

            if($wc_os_ie_method_selection == false){

                $wc_os_ie_method_selection = array_keys($ie_method_list);

                // update with all method on first time load when option is not set
                update_option('wc_os_ie_method_selection', $wc_os_ie_method_selection);
            }


            ?>

            <div class="wc_os_screen_option" style="display:none">

                <div id="screen-meta">
                    <div id="screen-options-wrap"  tabindex="-1" aria-label="Screen Options Tab" style="display: block;">



                        <fieldset>

                            <legend>
                                <?php _e('Split Settings (ON/OFF)', 'woo-order-splitter') ?>
                            </legend>

                            <?php

                            if(!empty($ie_method_list)){

                                foreach($ie_method_list as $method_key => $method){

                                    $method_title = split_actions_display($method_key, 'title');
                                    $method_checked = in_array($method_key, $wc_os_ie_method_selection);

                                    $method_id = $method['id'];
                                    ?>

                                    <label>
                                        <input class="group_input" name="method_selection" type="checkbox" value="<?php echo $method_key; ?>" data-target="<?php echo $method_id; ?>" <?php echo checked($method_checked); ?>>
                                        <?php echo $method_title ?>
                                    </label>



                                    <?php

                                        if($method_key == 'group_by_acf_group_fields' && function_exists('wc_os_acf_group_fields_screen_options')){
                                            wc_os_acf_group_fields_screen_options($method_checked);
                                        }

                                }

                            }

                            ?>

                            <p class="submit">
                                <button id="wos_save_acf_groups" class="button button-primary">
                                    <?php _e('Save Changes', 'woo-order-splitter') ?>
                                </button>
                                <img src="<?php echo $wc_os_url.'/img/juggler.gif'?>" class="wc_os_loading">
                                <span class="dashicons dashicons-yes-alt result_success"></span>

                            </p>

                        </fieldset>

                    </div>
                </div>

                <div id="screen-meta-links">
                    <div id="screen-options-link-wrap" class="hide-if-no-js screen-meta-toggle" style="">
                        <button type="button" id="show-settings-link" class="button show-settings screen-meta-active" aria-controls="screen-options-wrap" aria-expanded="true"><?php _e('Screen Options', 'woo-order-splitter'); ?></button>
                    </div>
                </div>

            </div>

            <?php
        }
    }

    // save screen options for method selection and acf group selection with ajax request
    add_action('wp_ajax_wc_os_save_ie_method_selection', 'wc_os_save_ie_method_selection');
    if(!function_exists('wc_os_save_ie_method_selection')){


        function wc_os_save_ie_method_selection(){

            $result = array('status' => false);
            if(!empty($_POST) && isset($_POST['wc_os_ie_method_selection'])){


                if(!isset($_POST['wc_os_nonce']) || !wp_verify_nonce($_POST['wc_os_nonce'], 'wc_os_nonce_action')){

                    wp_die(__('Sorry, your nonce did not verify.', 'woo-order-splitter'));

                }else{

                    //your code here
                    $wc_os_ie_method_selection = sanitize_wc_os_data($_POST['wc_os_ie_method_selection']);
                    $method_update = update_option('wc_os_ie_method_selection', $wc_os_ie_method_selection);

                    $group_update = false;
                    if(isset($_POST['wc_os_acf_group_selection'])){

                        $wc_os_acf_group_selection = sanitize_wc_os_data($_POST['wc_os_acf_group_selection']);
                        $group_update = update_option('wc_os_acf_group_selection', $wc_os_acf_group_selection);

                    }

                    $result['status'] = ($method_update || $group_update);

                }

            }
            wp_send_json($result);
        }
    }
	
	if(!function_exists('wc_os_update_order_status')){
        function wc_os_update_order_status($order_id, $status){

            global $wpdb;
            $order_post = get_post($order_id);

            if(is_object($order_post) && $order_post->post_type = 'shop_order'){

                $update_query = "UPDATE $wpdb->posts set post_status = '$status' WHERE ID = $order_id";
                $wpdb->query($update_query);
				update_post_meta($order_id, 'split_status', true);
				
				//update_wcfm_order_status($order_id, $status);

            }


        }
    }

    if(!function_exists('wc_os_get_packages_strings')){
        function wc_os_get_packages_strings($type=''){
            global $wc_os_settings;
            $wos_packages_strings = get_option( 'wc_os_packages_strings', true);			
			$wos_packages_strings = (is_array($wos_packages_strings)?$wos_packages_strings:array());
            $_heading = '';
            switch($wc_os_settings['wc_os_ie']){
                default:
                    break;
                case 'io':
                    if($type){
                        $_heading = trim(wc_os_get_io_setting($type.'_heading'));
                    }
                break;
            }

            if($_heading!=''){
                $wos_packages_strings['parcel-heading'] = $_heading;
            }
           
            return $wos_packages_strings;
        }
    }

    if(!function_exists('wc_os_inclusive_method_options')){
        function wc_os_inclusive_method_options(){
            global $wc_os_pro, $wc_os_settings;
            $wc_os_order_statuses = wc_get_order_statuses();
            $wc_os_order_statuses_keys = array_keys($wc_os_order_statuses);
            $method = 'inclusive';


            if($wc_os_pro){
                ?>

                    <div class="wc_os_io_options" data-method="inclusive"<?php echo $wc_os_settings['wc_os_ie']==$method?'':'style="display:none;"'; ?>>

                        <div class="vendor-left ">
                            <div class="wc_os_select_wrapper">
                                <p><?php _e('Inclusive parcel status after split', 'woo-order-splitter'); ?></p>
                                <?php if(function_exists('wc_os_get_statuses_select_html')){wc_os_method_statuses_select_html($method, $method, $wc_os_order_statuses_keys);} ?>
                            </div>
                            <div class="wc_os_select_wrapper">
                                <p><?php _e('Remaining parcel status after split', 'woo-order-splitter'); ?></p>
                                <?php if(function_exists('wc_os_get_statuses_select_html')){wc_os_method_statuses_select_html($method, 'remaining',  $wc_os_order_statuses_keys);} ?>
                            </div>
                        </div>

                    </div>

                <?php

            }

        }
    }

    if(!function_exists('wc_os_update_method_options')){
        function wc_os_update_method_options($posted_method_options){

            global $wc_os_method_options;

            if(!empty($wc_os_method_options)){
                foreach($wc_os_method_options as $method => $method_options){
                    if(array_key_exists($method, $posted_method_options)){
                        $wc_os_method_options[$method] = $posted_method_options[$method];
                        unset($posted_method_options[$method]);
                    }
                }
            }

            if(!empty($posted_method_options)){
                foreach($posted_method_options as $p_method => $p_method_options){
                    $wc_os_method_options[$p_method] = $p_method_options;
                }
            }

            update_option('wc_os_method_options', $wc_os_method_options);
            $wc_os_method_options = get_option('wc_os_method_options', array());

        }
    }

    if(!function_exists('wc_os_get_method_option')){
        function wc_os_get_method_option($method, $option_name = false, $default = ''){
                global $wc_os_method_options;

                $current_method_option =  (array_key_exists($method, $wc_os_method_options) ? $wc_os_method_options[$method] : array());

                if($option_name === false){
                    return $current_method_option;
                }else{

                    $current_option =  (array_key_exists($option_name, $current_method_option) ? $current_method_option[$option_name] : $default);
                    return $current_option;
                }


        }
    }

    if(!function_exists('wc_os_method_statuses_select_html')){
        function wc_os_method_statuses_select_html($method, $field_prefix, $wc_os_order_statuses){

            $input_name = 'wc_os_method_options['.$method.']';

            $status_key = $field_prefix.'_status';
            $selected_status =  wc_os_get_method_option($method, $status_key);


            ?>

            <select name="<?php echo $input_name.'['.$field_prefix.'_status]';?>">

                <option value=""><?php _e('Default', 'woo-order-splitter'); ?></option>

                <?php foreach($wc_os_order_statuses as $order_status){ ?>

                    <option value="<?php echo $order_status; ?>" <?php selected($order_status==$selected_status); ?>><?php echo __('Change', 'woo-order-splitter').' to '.str_replace('WC-', '', (strtoupper($order_status))); ?></option>

                <?php } ?>

            </select>

    <?php
        }
    }

    if(!function_exists('wc_os_update_method_order_status')){
        function wc_os_update_method_order_status($child_order, $original_order_id){
            global $wc_os_settings;
            $method = $wc_os_settings['wc_os_ie'];

            $allowed_method = array(
                    'inclusive'
            );

            if(!in_array($method, $allowed_method)){
                return;
            }

            $method_status =  wc_os_get_method_option($method, $method.'_status');
            $remain_status =  wc_os_get_method_option($method, 'remaining_status');

            switch($method){
                case 'inclusive':

                    $child_status = $method_status;
                    $parent_status = $remain_status;

                break;
                default:

                    $parent_status = $method_status;
                    $child_status = $remain_status;

                break;
            }


            if($parent_status){

                wc_os_update_order_status($original_order_id, $parent_status);
				update_post_meta($original_order_id, '_wos_custom_status_update', true);
            }

            if($child_status){

                if(!empty($child_order)){
                    foreach($child_order as $child_order_id)
                        wc_os_update_order_status($child_order_id, $child_status);
						update_post_meta($child_order_id, '_wos_custom_status_update', true);
                }

            }

        }
    }

    if(!function_exists('wc_os_get_groups_range')){
        function wc_os_get_groups_range(){
            global $wc_os_general_settings;
            $wc_os_limit_alphabets = (array_key_exists('wc_os_limit_alphabets', $wc_os_general_settings) && $wc_os_general_settings['wc_os_limit_alphabets'] ? $wc_os_general_settings['wc_os_limit_alphabets'] : 26);
            $start_alpha = 'A';
            $range_group = array();
            for($a = 1; $a <= $wc_os_limit_alphabets; $a++ ){
                $range_group[] = $start_alpha;
                if($start_alpha == 'ZZ'){
                    break;
                }else{
                    $start_alpha++;
                }

            }

            return $range_group;


        }
    }

    function wc_os_rule_based_switch(){
        wc_os_settings_refresh();
        global $wc_os_general_settings;
        return array_key_exists('wo_os_rule_switch', $wc_os_general_settings);
    }


    function wc_os_implement_rule_status($order_id){

        global $wc_os_pro;
		
		//wc_os_logger('email', 'wc_os_implement_rule_status: '. $order_id);

        $return_value = false;

        if(!$order_id || !wc_os_rule_based_switch() || !$wc_os_pro){
             return $return_value;
        }
        $order = new WC_Order($order_id);
        $order_items = $order->get_items();

        if(count($order_items) > 1){
            return $return_value;
        }elseif($wc_os_pro){
			$classObj = new wc_os_bulk_order_splitter;
			$return_value = $classObj->get_order_status_by_rule($order_id);
        }


        return $return_value;
    }	
	
		
	if(!function_exists('wc_os_set_empty_order_status')){
		function wc_os_set_empty_order_status($order_id){
	
			global $wc_os_settings;
	
			
			
	
			if($order_id){
	
				$order_obj = wc_get_order($order_id);
				$order_items = $order_obj->get_items();
	
				if(empty($order_items)){	
					$wc_os_additional = (array_key_exists('wc_os_additional', $wc_os_settings) ? $wc_os_settings['wc_os_additional'] :array());		
					$empty_order_status = (array_key_exists('empty_order_status', $wc_os_additional) ? $wc_os_additional['empty_order_status'] :'');
					
					if($empty_order_status){
						wc_os_update_order_status($order_id, $empty_order_status);	
					}
				}else{
					update_post_meta($order_id, '_not_empty', true);
				}
	
	
			}
	
		}
	}	
		
	if(!function_exists('wc_os_is_empty_order_status')){
		function wc_os_is_empty_order_status($order_id){
	
			global $wc_os_settings;
	
			$wc_os_additional = (array_key_exists('wc_os_additional', $wc_os_settings) ? $wc_os_settings['wc_os_additional'] :array());
			$empty_order_status = (array_key_exists('empty_order_status', $wc_os_additional) ? $wc_os_additional['empty_order_status'] :'');
			$order_obj = wc_get_order($order_id);
			$order_items = $order_obj->get_items();
			return ($empty_order_status && empty($order_items));
	
		}
	}	
	
    if(!function_exists('wc_os_status_options_html')){

	    function wc_os_status_options_html($selected){

            $wc_os_order_statuses = wc_get_order_statuses();
            $wc_os_order_statuses_keys = array_keys($wc_os_order_statuses);

            ?>

            <option value=""><?php _e('Default', 'woo-order-splitter'); ?></option>

            <?php foreach($wc_os_order_statuses_keys as $order_status){ ?>

                <option value="<?php echo $order_status; ?>" <?php selected($order_status == $selected); ?>><?php echo __('Change', 'woo-order-splitter').' to '.str_replace('WC-', '', (strtoupper($order_status))); ?></option>

            <?php

            }
        }

    }

	if(!function_exists('wc_os_get_auto_clone_status')){
	    function wc_os_get_auto_clone_status(){
            global $wc_os_general_settings;
            $auto_clone_selected_status = (array_key_exists('wc_os_auto_clone_status', $wc_os_general_settings) && $wc_os_general_settings['wc_os_auto_clone_status'] ? $wc_os_general_settings['wc_os_auto_clone_status'] : '');
            return $auto_clone_selected_status;
        }
    }
	
	if(!function_exists('wc_os_apply_coupon_child_orders')){

        function wc_os_apply_coupon_child_orders($child_ids = array(), $original_order_id = 0){

            global $wc_os_settings;
            if(empty($child_ids) || empty($original_order_id) || !class_exists('WC_Coupon')){
                return;
            }

            $original_order = new WC_Order($original_order_id);
            $coupon_items = $original_order->get_items('coupon');
            $effected_parent_method = array(
                'default', 'exclusive', 'inclusive', 'shredder', 'io'
            );



            if(empty($coupon_items)){

                return;

            }

            $wc_os_method = $wc_os_settings['wc_os_ie'];

            $actual_effect_parent = get_post_meta($original_order_id, '_wc_os_effected_order', true);

            if($actual_effect_parent && in_array($wc_os_method, $effected_parent_method)){
                $child_ids[] = $original_order_id;
                $effected_order = new WC_Order($original_order_id);

                foreach($coupon_items as $c_item_id => $c_item){

                    wc_os_remove_coupon($effected_order, $c_item->get_code());
                    $effected_order->calculate_taxes();
                    $effected_order->calculate_totals( false );
                    $effected_order->save();
                }

            }


            foreach($coupon_items as $item_id => $coupon_item){

                $coupon_code = $coupon_item->get_code();
                $coupon_obj = new WC_Coupon($coupon_code);
                $coupon_type = $coupon_obj->get_discount_type('edit');

                if($coupon_type != 'fixed_cart'){

                    foreach($child_ids as $child_id){

                        $child_order_obj = new WC_Order($child_id);
                        $result = wc_os_apply_coupon($child_order_obj, wc_format_coupon_code( wp_unslash( $coupon_code ) ));
                        $child_order_obj->calculate_taxes();
                        $child_order_obj->calculate_totals( false );
                        $child_order_obj->save();

                    }

                }else{

                    $total_cart_discount = $coupon_item->get_discount();



                    $all_orders_total = 0;

                    foreach($child_ids as $child_id){

                        $child_order_obj = new WC_Order($child_id);
                        $result = wc_os_apply_coupon($child_order_obj, $coupon_obj);


                        if($result){

                            $all_orders_total += $child_order_obj->get_subtotal();

                            wc_os_remove_coupon($child_order_obj, $coupon_obj->get_code('edit'));
                            $child_order_obj->calculate_taxes();
                            $child_order_obj->calculate_totals( false );
                            $child_order_obj->save();
                        }



                    }


                    foreach($child_ids as $child_id){

                        $child_order_obj = new WC_Order($child_id);
                        $coupon_obj_new = $coupon_obj;
                        $current_total = $child_order_obj->get_subtotal();
                        $discount_ratio = ($current_total / $all_orders_total);
                        $current_order_discount = round(($total_cart_discount * $discount_ratio), 2);

                        try {

                            $actual_price = $coupon_obj_new->get_amount();
                            $coupon_obj_new->set_amount($current_order_discount);
                            $coupon_obj_new->save();

                            $result = wc_os_apply_coupon($child_order_obj, $coupon_obj_new);

                            $coupon_obj_new->set_amount($actual_price);
                            $coupon_obj_new->save();
                            $child_order_obj->calculate_taxes();
                            $child_order_obj->calculate_totals( false );
                            $child_order_obj->save();

                        }catch(Exception $e){}

                    }

                }

            }

        }

    }

    if(!function_exists('wc_os_apply_coupon')){

        function wc_os_apply_coupon(&$current_order, $raw_coupon) {
            if ( is_a( $raw_coupon, 'WC_Coupon' ) ) {
                $coupon = $raw_coupon;
            } elseif ( is_string( $raw_coupon ) ) {
                $code   = wc_format_coupon_code( $raw_coupon );
                $coupon = new WC_Coupon( $code );

                if ( $coupon->get_code() !== $code ) {
                    return false;
                }
            } else {
                return false;
            }



            // Check to make sure coupon is not already applied.
            $applied_coupons = $current_order->get_items( 'coupon' );
            foreach ( $applied_coupons as $applied_coupon ) {
                if ( $applied_coupon->get_code() === $coupon->get_code() ) {
                    return false;
                }
            }

            $discounts = new WC_Discounts( $current_order );

            $applied   = $discounts->apply_coupon( $coupon );

            if ( is_wp_error( $applied ) ) {
                return false;
            }

            $data_store = $coupon->get_data_store();

            // Check specific for guest checkouts here as well since WC_Cart handles that seperately in check_customer_coupons.


            wc_os_set_coupon_discount_amounts($current_order, $discounts);
            $current_order->save();

            // Recalculate totals and taxes.
            $current_order->recalculate_coupons();



            return true;
        }

    }

    if(!function_exists('wc_os_set_coupon_discount_amounts')){

        function wc_os_set_coupon_discount_amounts(&$order, $discounts) {

            $coupons           = $order->get_items( 'coupon' );
            $coupon_code_to_id = wc_list_pluck( $coupons, 'get_id', 'get_code' );
            $all_discounts     = $discounts->get_discounts();
            $coupon_discounts  = $discounts->get_discounts_by_coupon();

            if ( $coupon_discounts ) {
                foreach ( $coupon_discounts as $coupon_code => $amount ) {

                    $item_id = isset( $coupon_code_to_id[ $coupon_code ] ) ? $coupon_code_to_id[ $coupon_code ] : 0;

                    if ( ! $item_id ) {
                        $coupon_item = new WC_Order_Item_Coupon();
                        $coupon_item->set_code( $coupon_code );
                    } else {
                        $coupon_item = $order->get_item( $item_id, false );
                    }

                    $discount_tax = 0;

                    // Work out how much tax has been removed as a result of the discount from this coupon.
                    foreach ( $all_discounts[ $coupon_code ] as $item_id => $item_discount_amount ) {
                        $item = $order->get_item( $item_id, false );

                        if ( 'taxable' !== $item->get_tax_status() || ! wc_tax_enabled() ) {
                            continue;
                        }

                        $taxes = array_sum( WC_Tax::calc_tax( $item_discount_amount, WC_Tax::get_rates( $item->get_tax_class() ), $order->get_prices_include_tax() ) );
                        if ( 'yes' !== get_option( 'woocommerce_tax_round_at_subtotal' ) ) {
                            $taxes = wc_round_tax_total( $taxes );
                        }

                        $discount_tax += $taxes;

                        if ( $order->get_prices_include_tax() ) {
                            $amount = $amount - $taxes;
                        }
                    }

                    $coupon_item->set_discount( $amount );
                    $coupon_item->set_discount_tax( $discount_tax );

                    $order->add_item( $coupon_item );
                }
            }
        }

    }


    if(!function_exists('wc_os_remove_coupon')){

        function wc_os_remove_coupon(&$order,  $coupon_code ) {
            $coupons = $order->get_items( 'coupon' );

            // Remove the coupon line.
            foreach ( $coupons as $item_id => $coupon ) {
                if ( $coupon->get_code() === $coupon_code ) {
                    $order->remove_item( $item_id );
                    $order->recalculate_coupons();
                    break;
                }
            }
        }
    }
	
	
    add_action('wp_ajax_wc_os_update_speed_optimization', 'wc_os_update_speed_optimization');

    if(!function_exists('wc_os_update_speed_optimization')){


        function wc_os_update_speed_optimization(){

            $result = array(
                    'status' => false,
            );

            if(!empty($_POST) && isset($_POST['wc_os_speed_optimization'])){


                if(!isset($_POST['nonce']) || !wp_verify_nonce($_POST['nonce'], 'wc_os_nonce_action')){
                    
                    wp_die(__('Sorry, your nonce did not verify.', 'woo-order-splitter'));
                }else{

                    //your code here

                    $wc_os_speed_optimization = sanitize_wc_os_data($_POST['wc_os_speed_optimization']);
                    $result['status'] = update_option('wc_os_speed_optimization', $wc_os_speed_optimization);
                }

            }

            wp_send_json($result);

        }
    }
	
	add_action('wc_os_ie_options_subscription_split', 'wc_os_ie_options_subscription_split_html');

	if(!function_exists('wc_os_ie_options_subscription_split_html')){
		function wc_os_ie_options_subscription_split_html($method_type){
			?>


				<div class="container-fluid wc_os_delivery_date p-0 mt-3">

					<div class="row">

						<?php wc_os_subscription_single_option('first_order', $method_type); ?>
						<div class="col-md-1" style="text-align:center; margin-top:35px;margin-left: 15px;">/</div>
						<?php wc_os_subscription_single_option('remaining_items', $method_type); ?>

					</div>

					<div class="row my-3">
						<div class="col-md-12 pl-4">
							<button class="button ims_button_white" type="submit">
								<?php _e('Save Changes', 'woo-order-splitter'); ?>
							</button>
						</div>
					</div>

				</div>
				

			<?php
		}
	}

	if(!function_exists('wc_os_subscription_single_option')){
		function wc_os_subscription_single_option($option_type, $method_type){

				global $wc_os_delivery_date_activated;
				$label = '';


				$current_method_options = wc_os_get_method_option($method_type, 'delivery_date', array());

			
				$current_method_options = wc_os_get_value($current_method_options, $option_type, array());
				$selected_type = wc_os_get_value($current_method_options, 'type', '');
				$selected_weekday = wc_os_get_value($current_method_options, 'weekday', '');
				$selected_interval = wc_os_get_value($current_method_options, 'interval', '');

				$week_days = array(

					"monday" => "Monday",
					"tuesday"  => "Tuesday" ,
					"wednesday"  => "Wednesday" ,
					"thursday"  => "Thursday" ,
					"friday"  => "Friday" ,
					"saturday"  => "Saturday" ,
					"sunday"  => "Sunday" ,
				);

				$input_name_prefix = "wc_os_method_options[$method_type][delivery_date][$option_type]";
				

				$select_options = array(
					'order_date' => __('Order Created Date', 'woo-order-splitter'),
					'order_interval' => __('Progressive Order Delivery Date + Interval', 'woo-order-splitter'),
					'order_created_weekdays' => __('Order Created Date + Weekday Interval', 'woo-order-splitter'),
					'order_weekdays' => __('Progressive Order Delivery Date + Weekday Interval', 'woo-order-splitter'),
					'user_selection' => __('Progressive Order Delivery Date selected by Customer (Checkout Page)', 'woo-order-splitter'),
					
				);

				switch($option_type){
					case 'first_order':
						$label = __('First Order Delivery', 'woo-order-splitter');
						$select_options['order_interval'] = str_replace('Progressive ', '', $select_options['order_interval']);
						$select_options['order_weekdays'] = str_replace('Progressive ', '', $select_options['order_weekdays']);
						$select_options['user_selection'] = str_replace('Progressive ', '', $select_options['user_selection']);
					
					break;
					case 'remaining_items':
						$label = __('Remaining Items Delivery', 'woo-order-splitter');
						$select_options['first_order'] = __('Same as First Order', 'woo-order-splitter');

					break;
				}

			?>

				<div class="col-md-5 single_section <?php echo $option_type; ?> pt-2">

					<div class="row">
						
						<div class="col-md-6">

							
							<div class="mb-1">

								<label>
									<?php echo $label; ?>:
								</label>
							
							</div>


							<select name="<?php echo $input_name_prefix; ?>[type]" class='delivery_type'>
								<option value=''><?php _e('Select delivery interval type', 'woo-order-splitter') ?></option>
								
								<?php 
								
									if(!empty($select_options)){

										foreach($select_options as $option_key => $option_name){
											$selected_option = selected($selected_type == $option_key, true, false);

											$disabled = '';

											if($option_key == 'user_selection' && !$wc_os_delivery_date_activated){
												$disabled = 'disabled';
												$selected_option = '';
											}

											echo "<option value='$option_key' $selected_option $disabled>$option_name</option>";
										}

									}

								?>
								
							</select>

						</div>						

						<div class="col-md-6 extended_options" style="display:none;">

							<div class="col-md-2" style="text-align:center;">
								<div style="margin-top:30px;">

									<strong>+</strong>

								</div>
							</div>
													

							<div class="col-md-10 weekdays_option">							
								<div class="mb-1">

									<label>
										<?php _e('Weekday Interval', 'woo-order-splitter'); ?>:
									</label>

								</div>


								<select name="<?php echo $input_name_prefix; ?>[weekday]" id="" class="">
									<option value=""><?php _e('Select Weekdays', 'woo-order-splitter') ?></option>
									<?php

										if(!empty($week_days)){
											foreach($week_days as $day_key => $day_name){
												$selected_day = selected($selected_weekday == $day_key, true, false);
												echo "<option value='$day_key' $selected_day>$day_name</option>";
											}
										}								
									
									?>
								</select>
								
							</div>						

							<div class="col-md-10 interval_option">

								<div class="mb-1">

									<label>
									 	<?php _e('Days Interval', 'woo-order-splitter'); ?>:
									</label>

								</div>							

								<input type="number" min='1' name="<?php echo $input_name_prefix; ?>[interval]" value="<?php echo $selected_interval; ?>">
								
							</div>						
						
						</div>
						
					</div>					

				</div>

			<?php
		}
	}

	if(!function_exists('wc_os_get_value')){
		function wc_os_get_value($array, $key, $default = false){
			$return_val = (array_key_exists($key, $array) ? $array[$key] : $default);
			if(is_array($default) && !is_array($return_val)){

				$return_val = array();
			}


			return $return_val;			
		}
	}	
	if(!function_exists('update_wcfm_order_status')){
		function update_wcfm_order_status($order_id, $order_status){
		
			global $wpdb, $wc_os_wcfm_installed, $wc_os_general_settings;
			
			//wc_os_logger('email', '$wc_os_wcfm_installed:'.$wc_os_wcfm_installed);
			//wc_os_logger('email', 'Upcoming > '.$order_id.':'.$order_status);
			
			if($wc_os_wcfm_installed && get_option('wcfmmp_table_install')){
				
				$order_status = str_replace('wc-', '', $order_status);
				
				$order_id = esc_sql($order_id);
				$order_status = esc_sql($order_status);
				//wc_os_logger('email', $order_id.':'.$order_status);
				
				$set_fields = array();
				
				if(array_key_exists('wcfm_order_status', $wc_os_general_settings)){
					$set_fields[] = 'order_status="'.$order_status.'"';
				}
				if(array_key_exists('wcfm_shipping_status', $wc_os_general_settings)){
					$set_fields[] = 'shipping_status="'.$order_status.'"';
				}
				if(array_key_exists('wcfm_commission_status', $wc_os_general_settings)){
					$set_fields[] = 'commission_status="'.$order_status.'"';
				}
				
				if(is_numeric($order_id) && $order_id>0 && !empty($set_fields)){
					$update_query = 'UPDATE '.$wpdb->prefix.'wcfm_marketplace_orders SET '.implode(',', $set_fields).' WHERE order_id="'.$order_id.'"';
					
					//wc_os_logger('email', $update_query);
					
					$wpdb->query($update_query);
				}
			}
			
		}
	}
	
	if(!function_exists('wc_os_status_change_cron')){

		function wc_os_status_change_cron ($new_status, $old_status, $post){

			if(is_object($post) && isset($post->post_type) && $post->post_type == 'shop_order'){
				//global $wos_status_change;
				//$wos_status_change = true;
				$post_meta = get_post_meta($post->ID);
				
				if(!empty($post_meta)){
					
					$post_meta = array_keys($post_meta);
					
					$is_parent_order = (!in_array('splitted_from', $post_meta) && !in_array('cloned_from', $post_meta));
					
					if($is_parent_order && !in_array('split_status', $post_meta)){
						update_post_meta($post->ID, 'wc_os_order_splitter_cron', true);
						wc_os_crons($post->ID);
					}
					
				}
			}
	
			
		}
	}

	add_action('transition_post_status', 'wc_os_status_change_cron', 10, 3);
	
	if(!function_exists('wc_os_update_ignored_cron_array')){
		function wc_os_update_ignored_cron_array($order_id){

			$ignored_array = get_option('wc_os_ignore_cron_orders', array());

			if(is_array($ignored_array) && $order_id){
				$ignored_array[] = $order_id;
			}

			return update_option('wc_os_ignore_cron_orders', $ignored_array);

		}
	}

	if(!function_exists('wc_os_remove_order_from_ignored')){
		function wc_os_remove_order_from_ignored($order_id){

			$ignored_array = get_option('wc_os_ignore_cron_orders', array());

			if(is_array($ignored_array) && $order_id){
				$order_key = array_search($order_id, $ignored_array);

				if($order_key != false){
					unset($ignored_array[$order_key]);
				}
			}

			return update_option('wc_os_ignore_cron_orders', $ignored_array);

		}
	}

	if(!function_exists('wc_os_check_ignored_order')){
		function wc_os_check_ignored_order($order_id){

			$ignored_array = get_option('wc_os_ignore_cron_orders', array());
			return in_array($order_id, $ignored_array);
		}
	}
	if(!function_exists('wc_os_set_order_status')){
		function wc_os_set_order_status($order_id=0, $status_org=''){
			
			if($order_id>0){

				
				
				global $wc_os_shipping_cost;
				
				$status = str_replace('wc-', '', $status_org);
				$order = wc_get_order($order_id);
				//$wc_os_logger_str = $order->get_shipping_methods();
				//wc_os_logger('email', '$order->get_shipping_methods() > '.$order_id);
				//wc_os_logger('email', $wc_os_logger_str);
				
				//wc_os_logger('email', '$order META DATA > '.$order_id);
				//wc_os_logger('email', get_post_meta($order_id, '_order_shipping'));				
				
				//
				
				if($wc_os_shipping_cost){
					//wp_update_post(array('ID'=>$order_id, 'post_status'=>$status_org));
					update_post_meta($order_id, '_wc_os_set_status', $status);
				}else{
					$order->set_status(wc_os_add_prefix($status, 'wc-'));
					$order->save(); //wc_os_set_order_status()
				}
				
				update_wcfm_order_status($order_id, $status_org);
				
			}
			
		}
	}	
	


	
	add_filter( 'woocommerce_order_needs_shipping_address', '__return_true' );
	
	function wc_os_set_email_content_type(){
		return "text/html";
	}	